c--- program agridMLsm
c--- calculates gridded 10**a-values from catalog
c--- this version uses unequal sampling periods
c--- written by Art Frankel  6/94
c-- to run: agridMLsm parfile
c-- try: agridMLsm WUSagrid.in
      integer*4 readn,nsrc
      real*4 magmin
      character name*30,name2*30,namec*30
      dimension xlev(20),ymag(10),iyr(10)
      dimension asum(200000),asumnew(200000)
      dimension b1(5),b2(5),b3(5),b4(5),b5(5),h(5),sigma(5)
c      write(6,*) "enter name of input file"
 900  format(a30)
      call getarg(1,name)
      open(unit=1,file=name,status='old')
c      open(unit=2,file=name2,type='new')
      write(6,*) "for sites: enter min lat, max lat, dlat"
      read(1,*) ymin, ymax, dy
      write(6,*) "for sites: enter min lon, max lon, dlon"
      read(1,*) xmin, xmax, dx
      write(6,*) "enter increments dlat,dlon for source cell"
      read(1,*) dsy, dsx
      nsx= (xmax-xmin)/dsx +1
      nsy= (ymax-ymin)/dsy +1
      nsrc= nsx*nsy
      write(6,*) nsx,nsy,nsrc
      write(6,*) "enter number of magnitude categories"
      read(1,*) nmag
      write(6,*) "enter min mag and min year of completeness"
      do 11 i=1,nmag
 11   read(1,*) ymag(i),iyr(i)
c
c
      write(6,*) "enter end year of catalog"
      read(1,*)iyrend 
      write(6,*) "enter name of catalog file"
      read(1,900) name
      open(unit=2, file=name,status='old')
      write(6,*) "enter minimum mag,dmag, bval"
      read(1,*) magmin,dmag,bval
      dmag= dmag/2.
c-- above for conversion from cumulative to incremental a value
c-- Hermann's formula is +-dmag
c
      sum= 0.
      do 2 i=1,200000
 2    asum(i)= 0.
      atotal=0.
      do 1 i=1,5000
      read(2,*,end=999,err=999) xmag,xlon,xlat,depth,iyear
      do 12 ii=1,nmag
      if((xmag.ge.ymag(ii)).and.(iyear.ge.iyr(ii))) then
         iy= (ymax-xlat)/dsy
         ix= (xlon-xmin)/dsx
      if((iy.lt.0).or.(iy.ge.nsy).or.(ix.lt.0).or.(ix.ge.nsx)) go to 1
c      write(6,*) ix,iy
         n= iy*nsx + ix +1
         asum(n) = asum(n)+1.
         atotal= atotal+1
         go to 1
         endif
 12   continue
 1    continue
 999  continue
      fac= alog10(10.**(bval*dmag)-10.**(-bval*dmag))
      write(6,*) fac
      beta= bval*2.303
      a1= 0.
      a2= 0.
      do 14 i=1,nmag
      a1= a1+ exp(-beta*(ymag(i)+0.5))
 14   a2= a2 + (iyrend-iyr(i))*exp(-beta*(ymag(i)+0.5))
      fac2= a1/a2
      write(6,*) fac2
c----above is Herrmann's formula to convert from cumul. to interval a-value
      atotal2=0.
      do 3 i=1,nsrc
      if(asum(i).ne.0.) then
c         write(6,*) asum(i)
         asum(i)= asum(i)*fac2
         atotal2= atotal2+asum(i)
         asum(i)= alog10(asum(i)) + bval*magmin
         asum(i)= asum(i)+ fac
         asum(i)= 10.**asum(i)
         sum= sum+asum(i)
c         write(6,*) asum(i)
c         read(5,*) idum
         endif
   3  continue
      write(6,*) atotal, atotal2, sum
c      read(5,*) idum
      write(6,*) "enter correlation distance in km"
      read(1,*) a
      a2= a*a
      coef= 3.14159/180.
      avelat= (ymin+ymax)/2.
c-------smoothing part
c--- go out to 3 times correlation distance
      lx= 3.*a/(111.1*cos(avelat*coef)*dsx)
      ly= 3.*a/(111.1*dsy)
      write(6,*) lx,ly
      do 10 iy=1,nsy
      write(6,*) iy
      do 10 ix=1,nsx
      indx1= ix-lx
      indy1= iy-ly
      n= (iy-1)*nsx+ix
      rx= xmin+(ix-1)*dsx
      ry= ymax-(iy-1)*dsy
      sum1= 0.
      sum2= 0.
      do 20 iyy= indy1,indy1+2*ly
      do 20 ixx= indx1,indx1+2*lx
       if((ixx.lt.1).or.(ixx.gt.nsx)) go to 20
       if((iyy.lt.1).or.(iyy.gt.nsy)) go to 20
       n2= (iyy-1)*nsx+ixx
       sx= xmin+(ixx-1)*dsx
       sy= ymax-(iyy-1)*dsy
       call delaz(sy,sx,ry,rx,dist,az,baz)
       dist2= dist*dist
c----- Gaussian smoothing
       sum1= asum(n2)*exp(-dist2/a2) + sum1
       sum2= exp(-dist2/a2)+sum2
 20    continue
c---- normalize by area under Gaussian
      asumnew(n)= sum1/sum2
c      write(6,*) asumnew(n)
 10   continue
      sum=0.
      do 35 i=1,nsrc
      sum= sum+ asumnew(i)
 35   continue
      write(6,*) sum
      read(1,900) name2
c---output smoothed file with 10**a values
      call openw(name2)
      call putbuf2(asumnew,nsrc,readn)
      write(6,801) nsrc,readn
 801  format('ndata=',i8,'readn=',i8)
      end
      subroutine delaz(sorlat,sorlon,stnlat,stnlon,delta,az,baz)
      coef= 3.14159/180.
      xlat= sorlat*coef
      xlon= sorlon*coef
      st0= cos(xlat)
      ct0= sin(xlat) 
      phi0= xlon
      xlat= stnlat*coef
      xlon= stnlon*coef
      ct1= sin(xlat)
      st1= cos(xlat)
      sdlon= sin(xlon-phi0)
      cdlon= cos(xlon-phi0)
      cdelt= st0*st1*cdlon+ct0*ct1
      x= st0*ct1-st1*ct0*cdlon
      y= st1*sdlon
      sdelt= sqrt(x*x+y*y)
      delta= atan2(sdelt,cdelt)
      delta= delta/coef
      az= atan2(y,x)
      az= az/coef
      x= st1*ct0-st0*ct1*cdlon
      y= -sdlon*st0
      baz= atan2(y,x)
      baz= baz/coef
      delta= delta*111.11
      return
      end         
