/* io subroutines for hazard programs, last modified 10/95 */
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <errno.h>
#include <stdint.h>

#define MAXCHAR 30

FILE *fporg,*fp[50];
//long int index;
struct header
{
   char name[MAXCHAR][6];
   float period;
   int32_t nlev;
   float xlev[20];
   float extra[10];
};
struct header *headr;

void openr_(name,len)
char name[];
int32_t len;
{
       int i;
       char st[MAXCHAR];
       for(i=0; i<MAXCHAR; i++) st[i]= '\0';
       for(i=0; i<MAXCHAR && name[i] != ' ' && name[i] != '\n' ; i++)
          st[i]=name[i];
       if((fp[0]=fopen(st,"rb"))==NULL) {
          fprintf(stderr,"cant open %s for reading\n",st);
       exit(1);
       }
}

void openw_(name,len)
char name[];
int32_t len;
{
       int i;
       char st[MAXCHAR];
       for(i=0; i<MAXCHAR; i++) st[i]= '\0';
       for(i=0; i<MAXCHAR && name[i] != ' ' && name[i] != '\n' ; i++)
          st[i]=name[i];
       if((fp[0]=fopen(st,"wb+"))==NULL) {
          fprintf(stderr,"cant open %s for writing\n",st);
       exit(1);
       }
}

void openwx_(fpx,name)
char name[];
int32_t *fpx;
{
	struct header *headr;
	int32_t *readn;
       int i, j;
       char st[MAXCHAR];
       for(i=0; i<MAXCHAR; i++) st[i]= '\0';
       for(i=0; i<MAXCHAR && name[i] != ' ' && name[i] != '\n' ; i++)
          st[i]=name[i];
       if((fporg=fopen(st,"wb")) < 0) {
          fprintf(stderr,"cant open %s\n",st);
          exit(1);
       }
       *fpx = fporg->_file;
       if(*fpx > 49) {
          fprintf(stderr,"too many files open\n");
          fclose(fporg);
          exit(2);
       }
       fp[*fpx] = fporg;
}

void close_()
{
       int j;
       for (j=0;j<10;j++)
       if(fclose(fp[j])!= 0) {
          fprintf(stderr,"cant close \n");
          exit(1); }
}

void closeio_()
{
        int j;
        for (j=0;j<10;++j)
        if(fclose(fp[j])!=0) {
                fprintf(stderr, "Failed to close\n");
                exit(1);
        }
}

void getbuf_(buf,bufsiz,readn)
int32_t *bufsiz,*readn;
short int *buf;
{
       *readn= fread(buf,2,*bufsiz,fp[0]);
}

void getbuf2_(buf2,bufsiz,readn)
int32_t *bufsiz,*readn;
float *buf2;
{
       *readn= fread(buf2,4,*bufsiz,fp[0]);
}

void getbuf3_(buf2,bufsiz,readn,skip)
int32_t *bufsiz, *readn;
long int *skip;
float *buf2;
{
       fseek(fp[0], *skip, 0);
       *readn= fread(buf2,4,*bufsiz,fp[0]);
}

void putbuf2_(buf2,bufsiz,readn)
int32_t *bufsiz,*readn;
float *buf2;
{
       *readn= fwrite(buf2,4,*bufsiz,fp[0]);
}

void putbuf_(buf2,bufsiz,readn)
int32_t *bufsiz,*readn;
short int *buf2;
{
       *readn= fwrite(buf2,2,*bufsiz,fp[0]);
}

void putbufx_(fpx,buf2,bufsiz,readn)
int32_t *bufsiz,*readn;
float *buf2;
int32_t *fpx;
{
       *readn= fwrite(buf2,4,*bufsiz,fp[*fpx]);
}

void puthead_(fpx,headr,bufsiz,readn)
struct header *headr;
int32_t *bufsiz,*readn;
int32_t *fpx;
{
	int limit = *bufsiz/2;
	int hm, i;
       *readn= fwrite(headr,*bufsiz,1,fp[*fpx]);
	if(!*readn)
		{
		perror("fwrite Error:");
		exit(-1);
		}
}

void gethead_(headr,bufsiz,readn)
struct header *headr;
int32_t *bufsiz,*readn;
{
        *readn = fread(headr, 1, *bufsiz, fp[0]);
}
