c--- program hazFXnga7.f; 12/14/06; Use  with NGA relations, or others.
c--- to compile: cc -c iosubs.c 
c                 f95 -o hazFXnga7 hazFXnga7.f iosubs.o -fast -e -ftrap=%none
c -e to extend linelength. Several statements go past column 72.
c The ftrap flag is required to prevent crashing when NaNs such as log(0) are
c attempted. Code has been modified to avoid some of these where known. 
c Mod Nov 7 to report rates of events when the "list of stations" option is
c invoked. For each station or receiver, a file is written, eqrate.sta_name.
c  NGA7: This code has potential downdip ruptures with tops at 2 and 4 km depth
c when GR-distributed sources and 6.5<=M<=7.0. Testing is nearly complete. 
c  Dec 14 2006: added GR with 6 < M < 6.5. For these, rupture tops are equally distributed 
c               at ztor+0,2,4,6, and 8 km. Revised so that AspectRatio>=1 for all rups,
c		even those associated with M6.0 sources.
c
c--- to run: hazFXnga7 inputfile > report.log &
c
c This code should be compatible with certain Linux Cluster as well as Solaris
c compilers. Solaris version: -e in gfortran is fixed-line-length-none. 
c Linux: gfortran -o hazFXnga7 hazFXnga7.f iosubs.o -ffixed-line-length-none
c   linux compiler is accepting this code Oct 13 2006. 
c "array constructors" are modern replacement for "data" statements. This is the
c main modification to make code gfortran-compatible. SHarmsen
c
c new 6/06:  sources now can have up to 12 magnitude branches per fault.
c For each mag there is a specific cmag and crate. If no epistemic uncert on
c magnitude-frequency is modeled for a given fault, ift line must
c have a 1 for number of mags per fault (this means all 2002-era input files must be modified)
c Has similar mods for GR-distribution of sources. This required dimension increase on
c several arrays including xmo2
c  
c Modified Mar 8 2006 to improve identification of HW sites.
c Also, transfer out of labor-intensive downdip calcs if appropriate. This change
c may bypass the Frankel abrahamson-hw part of code which is not used with
c NGA. If this code is to work with old subroutines, need to revisit...
c
c Some older relations are in the nga-style subroutine format with coeffs 
c	explicitly included as statements. These are:
c iatten=0 Truth. This one hasn't been programmed. It is the oldest but least accessible
c iatten=1 Spudich ea, 2000 Extensional-tectonics regions, with BJF97 site amp
c iatten=2 Toro ea; CEUS 7 periods and BC rock geotech. M has to be Mw. finite fault
c iatten=-2 Toro ea; CEUS 7 periods and A rock geotech. New 11/06: finite fault
c iatten=3 Sadigh 7 periods rock
c iatten=4 or -4. AB06
c iatten=6 Fea ceus 7 periods BC rock
c iatten=-6 Fea ceus 7 periods A rock
c iatten=5 AB94 BC ceus (New index, previously had same 6 index as fea. Too confusing)
c iatten=-5 AB94 A ceus (New, hard rock only)
c iatten=7 Somerville finite, BC rock. ceus
c iatten=-7 Somerville finite, A rock. ceus
c iatten=8 Abrahamson & Silva 7 periods rock. Using the logical variable "hwsite" to
c 	note for A&S: increase ground motion when hwsite is true. THis is a quick fix and does not include
c 	the 22 degree wings.
c iatten= 9 Campbell and Bozorgnia 2003. 7 periods BCrock. july 27 2006
c   added iatten=10 Campbell CEUS. bc rock. july 29
c   added iatten=-10 Campbell CEUS.  hardrock. 
c iatten=19 Tabakoli and Pezeshk can be firm rock or hard rock.
c  BACK TO WUS atten models:
c iatten=11 BJF97, any vs30. 7 periods. july 27.
c Important note, if any of the above require a different than moment mag, must
c do the conversion outside of the subroutine. iconv=1 do something before calling...
c   iatten=12 Motazetti and Atkinson, for PR/VI. Limited period set.
c
c ---  New relations: 
c --- Intent is to include the latest NGA developer-team updates here asap. 
c --- Iatten=13 for B&A 10/06; to 5-s SA maximum T, has PGV model.
c --- Iatten=14 C&B, 11/10/06. Includes PGV&PGD models. Sigma for random H-comp.
c              C&B hanging-wall term (f4) applies to both Normal and Reverse.
c --- Iatten=15 C&Y. This is model of June 2006. No PGV for C&Y, but 105 T-vals 
c --- 
c --- 
c --- Iatten=16 for A&S 8/05; they are changing model this one will deep-6. 
c ********* SH Oct 26 2005
c --- Iatten=17 Idriss. Added nov 2005. Note Sept 2006: Idriss has coeffs for several
c    spectral periods. We haven't seen the report but he discussed at Richmond meeting.
c ***
c *** New Oct 27 2005: Enter vs30 after the site description. Also enter depth of
c *** basin 
c *** dbasin= 0 for surficial hardrock; what about firm rock basement? Depth to 2.5 km/s VS in
c *** Campbell&Bozorgnia (Jan & June 06 NGAmodels) ***
c ***
c *** Towards parallel processing: the code is being tested for parallel
c *** processing using the Solaris C$PAR DOALL instruction. This may not require
c *** use of the 64-bit V9 architecture. V9 requires recompiling iosubs.c
c *** with the v9 architecture if you need to go that route:
c
c   c89 -c iosubs.c -xtarget=ultra -xarch=v9 -o iosubs.o
c ** To determine if your versionof iosubs.o is good to go, issue the command
c **  file iosubs.o	You should see the following message or close when v9 is
c in the plan, otherwise you want to see an ELF32 message here.
c 	iosubs.o:       ELF 64-bit MSB relocatable SPARCV9 Version 1
c
c --- Nov 2005: New Feature corresponding to feature of hazgridXnga2:
c --- code works for a large grid of sites or a small set (<=30) of sites.
c ---   Input file first line is number of sites, nrec.
c --- Make nrec 0 to perform the calculations for a grid of sites.
c --- Make nrec 1 to 30 to specify set of sites <lat(i),long(i),i=1,...,nrec>
c If you use small station set, output includes eq rates*model weight files,
c one for each station.
c --- Output file names are specified in input file, one per period.
c --- This version calls atten. subroutine each time the mean,sd are needed.
c--- uses NGA  subroutines for attenuation relations 
c--- nga6 was built on hazFXnga5
c----  HazFX originally written by Art Frankel, with many modifications & updates 
c        by Steve Harmsen, USGS, Golden,CO
c---- averages strike of fault segment
c---- revised hanging wall test for AS97, including 22.5 degree wings
c-- Can do as many attenuation relations for each period as you wish.
c --- This vers. does not save atten-model pex info in arrays. SH 
c---- added getMota 10/16/02
c---- revised Campbell2002
c---- added hanging wall term for Campbell 2002
c---- hanging wall term, separate reverse from thrust faulting
c---- fixed hanging wall for floating rupture
c---- changed to dmove increment for floating rupture 9/30/02
c---- added getBJF97 9/30/02
c--- changed length to WC all 7/1/02
c--- changed to only epistemic uncertainty for GR faults
c----- changed to Mmin= 5.8  nmag= 55
c---- added clamp for CEUS   max gnd motions
c---- added Mchar epistemic uncertainty 10/16/01
c---- added Mchar aleatory uncertainty 10/16/01
c---- checks to see if distribution goes below M6.5 for GR
c---- or below 6.0 for char.
c---- if so, ignores uncertainties
cc----- truncates at 3 sigma
c--- with clipping for Toro and Boore new table
c--- calculates mean annual frequency of exceedance for dipping faults
c--- written by Art Frankel 4/95, modified 10/95
c--- this version handles multiple periods and gnd motion relations
c Alternate compilation with explicitpar:
c                 f95 -o hazFXnga7 hazFXnga7.f iosubs.o -fast -explicitpar -e
c is supposed to give a speedup when multiple processors are available; however,
c my experience with the placement of DOALL's below is that this is a bust.
c-----  
c-----  
c--- Output of this program is input into hazallXL.v2 to get probabilistic
c    ground motions
c--- PGA & SA ground motion levels should be in units of g
c--- period=0 indicates PGA
c --- PGV ground motions are in units cm/s (BA and CB as of june 2006)
	parameter ( pi=3.14159265)
	parameter (nfltmx=500, nlvmx=20, npmx=8)  
	dimension xlev(nlvmx,npmx),ylev(nlvmx,npmx),nlev(npmx),iconv(7,npmx)
	dimension p(250005)	!table of complementary normal probab.
c You can raise p dim & make some minor code changes to improve accuracy. Currently
c p() has about 4 decimal place accuracy which is likely good enough for gvt wk
	real, dimension(500,500):: x,y,xaz,xlen
	real, dimension(6):: dmin
	real, dimension (6,6):: dminr
        real, dimension(32) :: slat,slong 
        real, dimension(100) :: ale, ale2
c  array of station coordinates if using list option
	integer, dimension(1100):: iymax
	dimension fdist(1100,100,6),nrups(50,500),dmin2(20,1000,6,6)
c add some arrays for storing information related to downdip ruptures
	dimension nrupd(50,500),rupln(50,500)
	dimension nmag0(500,12),nmagf(nfltmx),torate(55),itest(500)
	dimension ratenew(500,12,6),xmo2(500,12),relwt(500,12)
	real aperiod(22),camper(24)	!abrhamson, campbell-boz period sets resp. Code pgv=-1
       real perb(12),abper(26),tpper(14)
c abper atkinson boore ceus2006 tp=tabakoli & pezeshk
	integer ip,nrupdd,ii,iymx	
      character*12 sname(32)    !station names might be useful.
	character*12, dimension(-10:21) :: att_typ	
	real ar(400,6)	!aspect ratio for floating ruptures. Can have 5 downdip
	logical ss,rev,normal,obl,pgacalc,nearsrc,noas97	
	logical grid,isok,slist	!grid=true if stations form a regular grid
c firstf is a logical variable to instruct code to perform certain fault calcs
c the first time the fault is worked on. When many stations present, it makes
c sense to economize on these repeated fault calcs. New Nov 15 2006.
c Some of these laborious calcs only necessary for nearby sources. Logical
c variable nearsrc is true if nearest distance to current fault < 30 km. 
       logical firstf(500)
c type replaces structure & requires gfortran or f95 to compile. It is included
c so that this code has compatibility with Linux cluster computer compilers.
      type header_type
        character*30 :: name(6)
        real*4 :: period
        integer*4 :: nlev
        real*4 :: xlev(20)
        real*4 :: extra(10)
      end type header_type
      type(header_type) :: headr
      real magmin(nfltmx,12),magmax(nfltmx,12), mmax, mmax2,clamp(8)
c clamp can limit the probabilistic motion in CEUS. THis is applied in main
c in hazFXnga7 (Clamp applied in CEUS only. Set clamp(i) to 0 to skip this constraint).
      real v30(100000)	!possible array of site-specific vs30 new mar 2006.
      real dbasin,vs30,pr,rx,ry
      integer nmag,readn,ix,ix0,ix1,iy,iy0,iy1
      character nameout*78,name*30,adum*80,date*8,time*10,zone*5
	common/mech/ss,rev,normal,obl
	common/dipinf/dipang,cosDELTA,cdipsq,cyhwfac,cbhwfac
c pgacalc is a logical variable, true if first period in set is calculated
	common/pgac/pgacalc
	real*8 dp,dp2,pr0,prl,prlr,prr,plim
	real*8 emax/3.0/, sqrt2/1.4142135623730951/
	real xmorate,sum,alet/0.0/
	logical byeca,byeext,byewg99,byeoreg,hwsite,v30a
c hwsite: once ascertained that a site is on hanging wall many calcs can be bypassed.
c for footwall, same is true but code not altered for this case.	
      dimension dmbranch(10),wtbranch(10), testhw3(1000,50)
      dimension prob(1000,20,7),out(800000),
     &  iatten(7,7),wt(7,7,2),wtdist(7,7)
      dimension tarray(2)
      dimension prd(105),ival(8)
c ipertp = map to tabakoli-pezeshsk;iperb = map from input file to boore set of per
      integer, dimension(npmx) :: ipercy,ifp,iper,nattn,ipera,iperb,
     + iperab,ipercb,iperk,ipertp
      integer, dimension (500) :: itype,npts,iftype
      logical, dimension(npmx,8) :: nga,wus02,ceus02	
c logical variables for subsets of attenuation models should help narrow
c the search more efficiently.  Benioff n/a: gridded as of 2003 model anyway     
c new 6/06: potentially variable a and b values for up to 12 branches for each fault
c Provides extra flexibility to model epistemic uncertainty of size of eq. 
c dmag also needs a branch-specific
c value. The customary 0.1 dM wont work when M precision is carried to 2 dec. places
      real, dimension (0:37) :: perka
      real, dimension(npmx):: period,perx,wtsum
      real, dimension(500,12) :: a,b,dmag
      real, dimension(nfltmx,12):: cmag,crate
      real, dimension(500):: dip,dip0,width,depth0,tlen
c Below, the array constructor business. No repeat (8*.01) unlike data statement.
c gfortran required replacement of "data" statements in our Linux PC system. 10/06. SH.
       clamp = (/3.,6.,3.,6.,6.,6.,3.,300./)
c abper is the set of spectral periods for the AB2006 CEUS model. -1 =PGV
      abper = (/5.0000, 4.0000, 3.1250, 2.5000, 2.0000, 1.5873, 1.2500, 1.0000,
     1 0.7937, 0.6289, 0.5000, 0.3968, 0.3155, 0.2506, 0.2000, 0.1580,
     1 0.1255, 0.0996, 0.0791, 0.0629, 0.0499, 0.0396, 0.0315, 0.0250,
     1 0.0000, -1.000/)
c Tabakoli-Pezeshk model for CEUS, 2005.
      tpper = (/0.00e+00,5.00e-02,8.00e-02,1.00e-01,1.50e-01,2.00e-01,3.00e-01,5.00e-01,
     1       7.50e-01,1.00e+00,1.50e+00,2.00e+00,3.00e+00,4.00e+00/)
c perka = period set for Kanno et al., BSSA 2006. 0 = pga.
       perka=(/0.0,0.05,0.06,0.07,0.08,0.09,0.10,0.11,0.12,0.13,0.15,0.17,0.20,
     +0.22,0.25,0.30,0.35,0.40,0.45,0.50,0.60,0.70,0.80,0.90,1.00,1.10,1.20,
     +1.30,1.50,1.70,2.00,2.20,2.50,3.00,3.50,4.00,4.50,5.00/)
c perb = Boore-Atkinson NGA 10/06 period set, -1 = pgv
       perb =(/-1.00, 0.00, 0.05, 0.10, 0.20, 0.30, 0.50, 1.00,
     1 2.00, 3.00, 4.00, 5.00 /)
c perx = a default set of spectral periods used in 2002 PSHA maps. PGV=-1 was not
c available then and should not be tried for those models
       perx = (/0.,0.2,1.0,0.1,0.3,0.5,2.0,-1./)
       aperiod = (/ 0.0,0.01,0.02,0.03,0.04,0.05,0.075,0.1,0.15,
     1  0.2,0.25,0.3,0.4,0.5,0.75,1.,1.5,2.,3.,4.,5.,-1.0/)
c camper=Campbell-Bozorgnia NGA spectral period set, from 11-06 final(?) report. 
c 0.0=pga here, equiv to 0.01 in their report. -1=pgv, -2=pgd set
      camper =(/0.01,0.020,0.030,0.050,0.075,0.100,0.150,0.200,0.250,0.300,0.400,
     1 0.500,0.750,1.0, 1.5, 2.0, 3.0, 4.0, 5.0, 7.5,10.0,0.,-1.0,-2./)
c prd is the C&Y period set, 105 of 'em, june 2006. PGA=0.0s in our code. 
      prd= (/0.0,0.020,0.022,0.025,0.029,0.030,0.032,0.035,0.036,0.040,0.042,0.044,0.045,0.046,
     10.048,0.050,0.055,0.060,0.065,0.067,0.070,0.075,0.080,0.085,0.090,0.095,0.100,0.110,0.120,
     10.130,0.133,0.140,0.150,0.160,0.170,0.180,0.190,0.200,0.220,0.240,0.250,0.260,0.280,0.290,
     10.300,0.320,0.340,0.350,0.360,0.380,0.400,0.420,0.440,0.450,0.460,0.480,0.500,0.550,0.600,
     10.650,0.667,0.700,0.750,0.800,0.850,0.900,0.950,1.000,1.100,1.200,1.300,1.400,1.500,1.600,
     11.700,1.800,1.900,2.000,2.200,2.400,2.500,2.600,2.800,3.000,3.200,3.400,3.500,3.600,3.800,
     14.000,4.200,4.400,4.600,4.800,5.000,5.500,6.000,6.500,7.000,7.500,8.000,8.500,9.000,9.500,
     110.0/)
      wtsum = (/0.,0.,0.,0.,0.,0.,0.,0./)
	att_typ =  (/ 'CampH CEUS A','Space Unoccu','Space Unoccu',
     1 'Somervill HR','FeaHard CEUS','AB-hard CEUS','A&BHR CEUS06',
     1 '------------','TORO-CEUS HR','Space Unoccu','Truth -  N/A',
     1 'Spudich 2000','TORO-CEUS BC','Sadigh ea 97',
     1 'A&B06BC CEUS','AB95-CEUS BC','Frankel eaBC','Somervill BC',
     1 'Abr-Silva 97','Campbell2003',
     2 'Camp CEUS BC','BJF     1997','Mota ea PRVI',
     2 'B&A 10/06NGA','C&B11/06 NGA',
     2 'Chiou-Y 9/06','Ab-Silva NGA','Idriss   PGA','Kanno ea2006',
     2 'T&P CEUS  06','Space Unoccu','Space Unoccu'/)
	do ia=1,8
	do ip=1,npmx
	nga(ip,ia)=.false.
	wus02(ip,ia)=.false.
	ceus02(ip,ia)=.false.
c	benioff02(ip,ia)=.false.
	enddo
	enddo	!ia
	noas97 = .true.
c Initialize truncated normal array Pex, store in p().
        prl=0.5*(erf(emax/sqrt2) + 1.0)
        prlr=1.0/prl
        prr=1.0-prl
        plim=-emax/sqrt2
	v30a = .false.
        pr0=plim
        dp=0.000004*(3.3-plim)
        dp2=1.0/dp
        p(1)=1.e-9
        do i=2,250001
        pr0=pr0+dp
        p(i)=((erf(pr0)+1.)*0.5-prr)*prlr
        enddo
        p(250002)=1.0
c End initializing the truncated normal PEx() array=p()
c The indep. variable is a real*8 to reduce discretization error.
	call date_and_time(date,time,zone,ival)
c      instructions from command-line file, argument 1
 900  format(a)
	call getarg(0,adum)	!keep tract of program name
      headr%name(3)= adum	!new 11/05. prog name (needs to be shortpath)
	headr%name(4)=date
	headr%name(5)=time
      call getarg(1,name)
      headr%name(1)= name
      dum=dtime(tarray)
c      write(*,*)tarray
      inquire(file=name,exist=isok)
      if(isok)then
      open(unit=1,file=name,status='old')
      else
      print *,'hazFXnga7: File not found: ',name
      stop 'Put in working dir and retry'
      endif
	write (6,61)date,time,name
61	format('# *** hazFXnga7 log file. Pgm run on ',a,' at ',a,/,
     +'# *** Input control file: ',a)
c Below bypasses are based on file name. Bypass wont work if file names change
      byeext=index(name,'ext-norm').gt.0
      byeca=index(name,'ca-a').gt.0.or.index(name,'ca-b').gt.0
     1  .or.index(name,'ca-wg').gt.0
	byewg99=index(name,'ca-wg99').gt.0
	byeoreg=index(name,'wa_or').gt.0
c      write(6,*)'Enter a zero for grid of sites 1 to 30 for list: '
      read(1,*)nrec
      if(nrec.eq.0)then
      grid=.true.
      slist=.false.
      write(6,580) "For sites: enter min lat, max lat, dlat: "
      read(1,*) ymin, ymax, dy
      print *,ymin,ymax,dy
      write(6,580) "for sites: enter min lon, max lon, dlon: "
      read(1,*) xmin, xmax, dx
      print *,xmin,xmax,dx
      nx= nint((xmax-xmin)/dx) +1
      ny= nint((ymax-ymin)/dy) +1	!nint will make this calc more robust,
c portable among different computers
      write(6,*) nx,ny,' nx ny for discrete grid of sites'
      nrec= nx*ny
      elseif(nrec.lt.33)then
	write(6,*)'*** Station-list option has been selected.'
	grid=.false.
	slist=.true.
      do i=1,nrec
	write(6,*)'Enter station lat,long (dec deg) and name(1 word): '
580	format(a,$)	
      read(1,*)slat(i),slong(i),sname(i)
      write(6,*)slat(i),slong(i),sname(i)
      open(30+i,file='eqrate.'//sname(i),status='unknown')
      write(30+i,389)headr%name(1)
 389	format('#Pgm hazFXnga7.f file of rates*weights for fault ruptures',/,
     + '#Dist(km)  Mw   Rate*wt, ift,ilt,idis? Infile: ',a)     
c write eqrates to these files New, nov 7 2006.      
      if(slat(i).lt.-88.)stop 'invalid station location. Version 4?'
      enddo
      else
      print *,'hazFXnga7 expects first line of input to be nrec'
      print *,'Valid nrec are 0, 1, ..., 29,30. Just read in ',nrec
      stop 'Please correct input file.'
      endif		!if grid
c **** Enter soil Vs30 condition  ******NEW*******
c      write(6,*)"For sites, enter Vs30(m/s) and basin depth(km)"
      read(1,*)vs30,dbasin
      write(6,*)' Vs30 and depth of basin ',vs30,dbasin
      if(vs30.lt.90..and.vs30.gt.0.)then
      print *,'Vs30 = ',vs30,'. This looks unreasonable.'
      stop'please check input file just before distance incr,dmax'
      elseif(vs30.eq.0)then
      write(6,580)'Enter the name of the binary vs30 array: '
      read (1,900)name
	inquire(file=name,exist=isok)
	if(.not.isok)stop'Vs30 array not in working directory'
      call openr(name)
      write(6,580)'Enter ymin, ymax, dy (lat, d) of Vs30 array: '
      read (1,*)vymin,vymax,vdy
      write(6,580)'Enter xmin, xmax, dx (long, d) of Vs30 array: '
      read (1,*)vxmin,vxmax,vdx
      write(6,580)'Enter a default vs30 in case site not inbounds: '
      read (1,*)vs30dflt
	if(vymin.gt.vymax)then
	y0=vymin
	vymin=vymax
	vymax=y0
c obvious repair if user has transposed. common input error.
	endif
      nvx= nint((vxmax-vxmin)/dvx) +1
      nvy= nint((vymax-vymin)/dvy) +1	
c Using the function nint will make this calc more robust,
c portable among different computers
	v30a=.true.
	nv30=nvx*nvy
	call getbuf2(v30,nv30,nvread)
      write(6,*)'For vs30 expect ',nv30,' got ',nvread
      endif
      srcSiteA=90.	!this angle should vary with site location. See delaz calls
c      write(6,*) "enter distance increment, dmax"
      read(1,*) di,dmax
	write(6,*)'Distance increment and dmax ',di,dmax
cccccccccccccccccccccccccccccccccc
c      write(6,*) "enter number of periods"
      read(1,*) nper
      ndist= nint(dmax/di) +10
      nmag= 55
c hazFXnga7: this version  may not be using the 22 degree wings.
      angtest= 22.5*3.14159/180.
      angtest= tan(angtest)
c---loop through periods
      do 700 ip=1,nper
      read(1,*) period(ip), sigmanf, distnf
      per= period(ip)
      k=1
      dowhile(per.ne.perx(k))
      k=k+1
      if(k.gt.8)then
      print *, '*** Input period not in 2002 group ***', per
	print *,'Warning: some atten relations may not be ready.'
	k=7
	goto 801	!not really a solution
      endif
      enddo
801	write(6,*)'Period ',per,' underway'
      iper(ip)=k
c      write(6,*) "enter name of output file for this period"
      read(1,909) nameout
 909  format(a)
 	if(grid)then
      call openwx(ifp(ip),nameout)
      write(6,*) ifp(ip),nameout
      else
      open(9+ip,file=nameout,status='unknown')	!ascii
 	write(6,895)nameout
895	format('Ascii output file: ',a)
      endif
c      write(6,*) "enter number of ground motion levels"
      read(1,*) nlev(ip)
	if(nlev(ip).gt.nlvmx)stop'number of gm levels exceeds max'
c      write(6,*) "enter ground motion levels"
      read(1,*) (xlev(k,ip),k=1,nlev(ip))
	write(6,*)'Nlev ',nlev(ip),' min max ',
     1 xlev(1,ip),xlev(nlev(ip),ip)
      do 414 k=1,nlev(ip)
      ylev(k,ip)=xlev(k,ip)
 414  xlev(k,ip)= alog(xlev(k,ip))
c-----------
c      write(6,*) "enter number of atten. relations for this period"
      read(1,*) nattn(ip)
	write(6,*)"number of atten. relations for this period ",nattn(ip)
c--- loop through atten relations for that period
      do 701 ia=1,nattn(ip)
c      write(6,*) "enter type of atten. relation, weight1, wtdist, 
c     &  weight2 , mb to M conv."
      read(1,*) iatten(ip,ia),wt(ip,ia,1),wtdist(ip,ia),wt(ip,ia,2),
     &   iconv(ip,ia)
       if(iatten(ip,ia).eq.8)noas97=.false.
c	!certain calcs can be bypassed if not using as97
c hazFXnga7: there is no longer a precalc of a pr() array. Note how 
c for valid iatten() numbers the calls are commentd out.
       wus02(ip,ia)=iatten(ip,ia).eq.1 .or.iatten(ip,ia).eq.3.or.
     1 iatten(ip,ia).eq.8.or.iatten(ip,ia).eq.9.or.iatten(ip,ia).eq.11
       ceus02(ip,ia)=abs(iatten(ip,ia)).eq.2 .or.iatten(ip,ia).eq.19.or.
     1 abs(iatten(ip,ia)).eq.4.or.abs(iatten(ip,ia)).eq.5.or.
     1 abs(iatten(ip,ia)).eq.6.or.abs(iatten(ip,ia)).eq.7.or.abs(iatten(ip,ia)).eq.10
	nga(ip,ia)=iatten(ip,ia).gt.12.and.iatten(ip,ia).lt.19
c kanno et. al. is included with NGA even though it's not. But is modern.
c prepare look-up tables for certain CEUS relations.
       if(iatten(ip,ia).eq.6) then
       call getFEAtab(iper(ip),1)
       print *,'FEA BC table OK for period ',perx(iper(ip))
       elseif(iatten(ip,ia).eq.5) then
       call getFEAtab(iper(ip),2)       
       print *,'ABceus BC table OK for period ',perx(iper(ip))
       elseif(iatten(ip,ia).eq.-6)then
       call getFEAtab(iper(ip),3)
       print *,'FEA hardrock table OK for period ',perx(iper(ip))
	if(vs30.lt.800.)print *,'Warning: vs30 ',vs30,' not consistent with HR'
       elseif(iatten(ip,ia).eq.-5)then
       call getFEAtab(iper(ip),4)
       print *,'ABceus hardrock table OK for period ',perx(iper(ip))       
	if(vs30.lt.800.)print *,'Warning: vs30 ',vs30,' not consistent with HR'
       endif
       	wtsum(ip)=wtsum(ip)+wt(ip,ia,1)
       	if(wtsum(ip).gt.1.01)then
       	write(6,*)' For period ',per,' sum of atten-model wts = ',wtsum(ip)
       	stop'This is unreasonable. Please check input file.'
       	endif
c
	write(6,807)att_typ(iatten(ip,ia)),ia
        if(abs(iatten(ip,ia)).eq.4)then
          ka=1
          dowhile(per.ne.abper(ka))
            ka=ka+1
            if(ka.gt.26)then
              print *, 'As of 6/06 input period doesnt correspond to A&B06 set'
              stop 'Please remove this relation from input file'
            endif
          enddo
          iperab(ip)=ka     
          print *,ip,ka,' A&B 9/06 ip map'
          if(vs30.lt.800..and.iatten(ip,ia).lt.0)write(6,808)vs30
  808	format('You have called hardrock version of AB06 even though vs30 is ',f6.1)   
        endif
        if(iatten(ip,ia).eq.19)then
          ka=1
          dowhile(per.ne.tpper(ka))
            ka=ka+1
            if(ka.gt.14)then
              print *, 'As of 11/06 input period doesnt correspond to T&P05 set'
              stop 'Please remove this relation from input file'
            endif
	if(vs30.gt.1000.)then
	irtb=-1
	else
	irtb=1
	endif
          enddo
          ipertp(ip)=ka
          print *,ip,ka,' T&P 9/06 ip map'
        endif
c For NGA, is the input period available?
	if(iatten(ip,ia).eq.16)then
c Below, find index from abrahamson period set
	ka=1
	dowhile(per.ne.aperiod(ka))
	ka=ka+1
	if(ka.gt.22)stop 'input period doesnt correspond to abram.set'
	enddo
 	ipera(ip)=ka
 	elseif( iatten(ip,ia).eq.14 )then   
c Below, campbell-boz 6-06  period set
	ka=1
	dowhile(per.ne.camper(ka))
	ka=ka+1
	if(ka.gt.22)stop 'input period doesnt correspond to campbell-boz 6-06 set'
	enddo
 	ipercb(ip)=ka  
 	print *,ip,ipercb(ip),' campbell 9/06 ip map'   
cc Below, boore/atkinson period set. 6/06 version of BA model has 7 periods. 
c  3 s SA corresponds to index 7.
	elseif(iatten(ip,ia).eq.13)then
	ka=1
	dowhile(per.ne.perb(ka))
	ka=ka+1
	if(ka.gt.12)then
	print *,'Period ',per
	stop 'For this period please remove the BA relation from input file'
	endif
	enddo
 	iperb(ip)=ka     
 	print *,ip,iperb(ip),' BA 10/06 ip map'   
c Below, chiou/youngs 6/2006 period set
	elseif(iatten(ip,ia).eq.15)then
2006	ka=1
	dowhile(per.ne.prd(ka))
	ka=ka+1
	if(ka.gt.105)then
	print *, 'As of 6/06 input period doesnt correspond to chiou&y.set'
	stop 'Please remove this relation from input file'
	endif
	enddo
2008 	ipercy(ip)=ka     
 	print *,ip,ka,' CY 9/06 ip map'   
 	elseif(iatten(ip,ia).eq.18)then
	ka=0
	dowhile(per.ne.perka(ka))
	ka=ka+1
	if(ka.gt.37)then
	print *,'Period ',per
	stop 'For this period please remove the Kanno relation from input file'
	endif
	enddo
 	iperk(ip)=ka     
 	print *,ip,iperk(ip),' Kanno 10/06 ip map, NGA? ',nga(ip,ia)   
c vsfac used for site-amp in  the Kanno et al. relation.
        vsfac=alog10(vs30) 	   
	endif	!spectral period indexes for NGA relations
	if(ia.eq.1)headr%name(2)=att_typ(iatten(ip,ia))
807	format(a12,1x,'attenuation model assoc. with index ',i1)
 701  continue
 700  continue
ccccccccccccccccccccccccccccccccccc
c      write(6,*) "enter increment dlen and dmove for floating rup"
      read(1,*) dlen, dmove
	write(6,*)'dlen, dmove ',dlen,dmove
c      write(6,*) "enter number of branches for Mchar logic tree"
      read(1,*) nbranch
      write(6,*)'Number of epistemic M-branches: ',nbranch
c      write(6,*) "enter dM of each branch"
      read(1,*) (dmbranch(i),i=1,nbranch)
c      write(6,*) "enter weight of each branch"
      read(1,*) (wtbranch(i),i=1,nbranch)
	write(6,*)'epistemic dM= ',dmbranch(1),dmbranch(2),dmbranch(3)
c      write(6,*) "enter std dev and width for Mchar aleatory uncer"
      read(1,*) sdal,mwid
	write(6,*)sdal,' sd_aleatory'
      if(sdal.gt.0.) then
         denom=0.
         do 670 i= -mwid, mwid
         ale(i+mwid+1)= exp(-(i*0.05)*(i*0.05)/(2.*sdal*sdal))
         denom= denom+ ale(i+mwid+1)*10.**(1.5*i*0.05)
c         write(6,*) ale(i+mwid+1)
 670     continue
         do i=1,2*mwid+1
       ale2(i)= ale(i)/denom
 	alet=alet+ale2(i)
 	enddo      
         write(6,*) 'aletot ',alet,' denom ',denom
c         read(5,*) idum
         endif		!sdal > 0
ccc-------read fault data
      do 1 ift=1,nfltmx
      write(6,*) ift
c      write(6,*) "enter 1 for char. 2 for G-R; 1 for SS, 2 for reverse; nmagep"
      read(1,900,end=999) adum
	write (6,900)adum
c blank lines at end of file are ok. should not cause hiccough below.
c nmagf (ift) is a new required field 6-06. Number of mag branches. Used for
c several SF bay area faults (WG99), for NMSZ and others where the epistemic
c model needs some flexibility. 
c Added relwt to each fault-mag line. This relwt is relative to all faults
c in the current input file, not just this particular fault. For example, if
c combining 25-wt and 50-wt California faults into one file, and the relwt for the
c 25-wt items is X, then the relwt for the 50-wt items is 2X. This was discussed
c at a software meeting late Oct 2006. S Harmsen.
      read(adum,*,err=999,end=999)itype(ift),iftype(ift),nmagf(ift)
	if(nmagf(ift).lt.1.or.nmagf(ift).gt.12)then
	print *,'Number of magnitudes outside of acceptable range (1 to 12).'
	print *,'Please check input file near ',adum
	stop'hazFXnga7: fatal error.'
	endif
	
      if(itype(ift).eq.1) then
      do imag=1,nmagf(ift)	!new: combine all fault mags
c        write(6,*) "enter char. M, rate, and relative weight"
c Added relwt to each fault-mag line. This relwt is relative to all faults
c in the current input file, not just this particular fault. For example, if
c combining 25-wt and 50-wt California faults into one file, and the relwt for the
c 25-wt items is X, then the relwt for the 50-wt items is 2X. This was discussed
c at a software meeting late Oct 2006. S Harmsen. This relwt should be an epistemic
c uncert weight. For example, related to fault location for NMSZ, or to freq
c of recurrence, to fault dip, or other issues.
        read(1,*) cmag(ift,imag),crate(ift,imag),relwt(ift,imag)
	write(6,*) 'Cmag and rate: ',cmag(ift,imag),crate(ift,imag)
c mod 0ct 31, 2006 from Oliver Boyd discovery
	if(imag.gt.1)then
	if(abs(cmag(ift,imag)-cmag(ift,imag-1)).gt.0.8)then
	print *,' characteristic magnitudes varying too rapidly.'
	print *,' This seems like an error. Please check input file near ',adum
	stop'hazFXnga7: fatal error.'
	endif
	endif
        itest(ift)=0	!initially lets not worry about this test for multi-mag
        test= cmag(ift,imag)+dmbranch(1)-mwid*0.05
        if(test.lt.5.8) then
           itest(ift)=1
c           write(6,*) "test.lt.6.",ift,itest(ift)
c           read(5,*) idum
           endif
        enddo	!imag loop, multi mags.
        endif
      if(itype(ift).eq.2) then
      do imag=1,nmagf(ift)	!new: combine all fault mags
c         write(6,*) "enter a,b,min M,max M,dmag for freq mag curve"
c Added relwt to each fault-mag line. This relwt is relative to all faults
c in the current input file, not just this particular fault. For example, if
c combining 25-wt and 50-wt California faults into one file, and the relwt for the
c 25-wt items is X, then the relwt for the 50-wt items is 2X. This was discussed
c at a software meeting late Oct 2006. S Harmsen.
        read (1,*) a(ift,imag),b(ift,imag),magmin(ift,imag),magmax(ift,imag),
     + dmag(ift,imag),relwt(ift,imag)
	print *,'a b magmin magmax relwt',
     + a(ift,imag),b(ift,imag),magmin(ift,imag),magmax(ift,imag),relwt(ift,imag)
c---- center magnitude bins
        if(magmin(ift,imag).ne.magmax(ift,imag)) then
          magmin(ift,imag)= magmin(ift,imag)+dmag(ift,imag)/2.
          magmax(ift,imag)= magmax(ift,imag)-dmag(ift,imag)/2.+.0001	!small delta may be
c needed to insure that magmax(ift,imag) > magmin(ift,imag)          
          endif
        nmag0(ift,imag)= (magmax(ift,imag)-magmin(ift,imag))/dmag(ift,imag) + 1.4
        itest(ift)=0
        test= magmax(ift,imag)+dmbranch(1)
        if((test.lt.6.5).and.(nmag0(ift,imag).gt.1)) then
          itest(ift)=1
          write(6,*) "test.lt.6.5", ift, itest(ift)
c          read(5,*) idum
          endif
        if(nmag0(ift,imag).eq.1) then
           test= magmax(ift,imag)+dmbranch(1)-mwid*0.05
           if(test.lt.5.8) itest(ift)=1
           endif
c---- calculate moment rate
c initialize to nonzero because a log will be taken
        xmorate=1.0e-10
        do 600 i=1,nmag0(ift,imag)
        xmag= magmin(ift,imag)+ dmag(ift,imag)*(i-1)
        xmorate= xmorate+10.**(a(ift,imag)-b(ift,imag)*xmag+1.5*xmag+9.05)
 600    continue
c xmo2 can be different for each "imag" branch. Needs dimension corresponding
c to this potential variation. SH Nov 2006.
        xmo2(ift,imag)= xmorate
        write(6,*) xmorate
c----- find rates for epistemic uncertainty
       if(nmag0(ift,imag).gt.1) then
         do 603 ilt= 1, nbranch
         mmax= magmax(ift,imag)+ dmbranch(ilt)
         sum2= 0.
         nmagg= (mmax-magmin(ift,imag))/dmag(ift,imag) + 1.4
         sum= 1.e-20
         do 602 m=1,nmagg
         xmag= magmin(ift,imag)+ (m-1)*dmag(ift,imag)
  602    sum= sum + 10.**(-b(ift,imag)*xmag+1.5*xmag+9.05)
         ratenew(ift,imag,ilt) = alog10(xmorate/sum)
         write(6,*) 'xmag, rate ',xmag,ratenew(ift,imag,ilt),a(ift,imag)
c         write(6,*) "sum2=",sum2
c         read(5,*) idum
  603    continue
         endif
         enddo	!imag
        endif	!itype=2 (GR)
      if(sdal.eq.0.) itest(ift)=1
c      write(6,*) "enter dip, downdip width, depth0 of fault plane"
      read(1,*) dip(ift), width(ift), depth0(ift)
	print *,'Dip width depth0 ',dip(ift), width(ift), depth0(ift)
	if(depth0(ift).gt.8.)print 2458,depth0(ift),ift
2458	format('***********************************************************',/,
     + '************ Warning: Implausible depth to top of fault ****',
     +/,'************ Depth ',f5.1,' km for fault number ',i3,' ***********')
c      write(6,*) "enter number of segment points"
      read(1,*) npts(ift)
c      write(6,*) "enter lat,lon for each point"
      tlen(ift)= 0.
      do 2 j=1,npts(ift)
      read(1,*) y(j,ift),x(j,ift)
      if(j.gt.1) then
        sy= y(j-1,ift)
        sx= x(j-1,ift)
        ry= y(j,ift)
        rx= x(j,ift)
        if((sy.eq.ry).and.(sx.eq.rx)) then
             delta=0.
             az=0.
             go to 1020
        else
           call delaz(sy,sx,ry,rx,delta,az,baz)
        endif
 1020   if(j.gt.2) xlen(j-1,ift)= delta +xlen(j-2,ift)
        if(j.eq.2) xlen(1,ift)= delta
        xaz(j-1,ift)= az
        tlen(ift)= tlen(ift)+ delta
        endif
c      write(6,*) xlen(j-1),delta,xaz(j-1)
   2  continue
c----- next line added 10/18 based on Harmsen comment
       xaz(npts(ift),ift)= xaz(npts(ift)-1,ift)
      write(6,*) npts(ift),tlen(ift)
      if(tlen(ift).le.0.) then
          write (6,*) "tlen le 0",ift
          read(5,*) idum
          endif
      coef= 3.14159/180.
      dip0(ift)= dip(ift)
      dip(ift) =dip(ift)*coef
   1  continue
 999  nft= ift-1
      write(6,*) "nft=",nft
      if(nft.eq.nftmx)print *,'WARNING: maximum fault index reached. Is this all?'
 	do j=1,nft
	firstf(j)=.true.
	enddo
ccccccccccccccccccccccccccccc
c---- write header --------------
c Discussion at Software meeting Dec 16 2005: header record needs to be
c lengthened to include more input-file information.
      do 201 ip=1,nper
      headr%period= period(ip)
      headr%nlev= nlev(ip)
      do 702 k=1,nlev(ip)
 702  headr%xlev(k)= exp(xlev(k,ip))
      ndata= 308
c New 10/05: store solution grid info.
      headr%extra(2)=xmin
      headr%extra(3)=xmax
      headr%extra(4)=dx
      headr%extra(5)=ymin
      headr%extra(6)=ymax
      headr%extra(7)=dy
      headr%extra(8)=float(nrec)
c store other run-specific info. extra(9) and (10)      
      headr%extra(9)=vs30
      headr%extra(10)=dbasin	!bookkeeping
	if(grid)call puthead(ifp(ip),headr,ndata,readn)
 201  continue
ccccccccccccccccccccccccccccccccccc
ccccccccccccccccccccccccccccccccccc
      icnt=1
      do 30 ip=1,nper
      do 30 k=1,nlev(ip)
      do 30 j=1,1000
  30  prob(j,k,ip)=0.1e-20
c---Here's the guts
c
c---loop through receiver sites

      do 100 i=1,nrec
	if(grid)then
      iy= (i-1)/nx 
      ix= i-1-iy*nx
      rx= xmin + float(ix)*dx
      ry= ymax - float(iy)*dy
      	else
      	rx=slong(i)
      	ry=slat(i)
      	print *,'Computing seismic hazard for ',sname(i)
      	endif
	if(v30a)then
c find nearest gridpoint in vs30 array to the site with coords rx,ry
	if(rx.gt.vxmax.or.rx.lt.vxmin.or.rx.gt.vymax.or.ry.lt.vymin)then
	vs30=vs30dflt
	else
	ivx=1+nint((rx-vxmin)/dvx)	
	ivy=nint((vymax-ry)/dvy)	!same organization as we are used to.
	vs30=v30(nvx*ivy+ivx)
	endif	!inbounds
	endif	!array rather than scalar vs30	
c following lines omit several site checks for ca and/or extensional faults.
	if(byeca.and.ry.gt.43.9) goto 860
	if(byewg99.and.rx.gt.-118.)goto 860	!wg faults 120.5+
      if(byeext.and.ry.lt.38..and.rx.lt.-121.)goto 860
      if(byeext.and.ry.lt.40..and.rx.lt.-122.)goto 860
	if(byeoreg.and.(ry.lt.40..or.rx.gt.-113.))goto 860
c try to parallelize computations for fault hazard at each site
c That did not work. Trying to go further into interior try some ip=1,nper next
c--- loop through faults
      do 850 ift=1,nft
      dipang=dip(ift)
      sinedip=sin(abs(dipang))
      if(dip0(ift).le.70..or.dip0(ift).ge.110..or.dip0(ift).lt.0.)then
      cbhwfac=1.
      else
      cbhwfac=abs(90.-dip0(ift))/20.	!changed july 12 2006 SH
      endif
	cosDELTA=cos(dipang)
      cdipsq=cosDELTA**2
      dtor=depth0(ift)
c Heads up: the below factor changes when top of rupture is moved downdip
        cyhwfac=atan(width(ift)*0.5*cosDELTA/(dtor+1.0))/(pi*0.5)
      if(iftype(ift).eq.1)then
      ss=.true.
      rev=.false.
      normal=.false.
      rake=0.
      F_RV=0.0
      F_NM=0.0
      elseif(iftype(ift).eq.2)then
      rev=.true.
      normal=.false.
      ss=.false.
      rake=90.
      F_RV=1.0
      F_NM=0.0
      elseif(iftype(ift).eq.3)then
      normal=.true.
      rev=.false.
      ss=.false.
      F_RV=0.0
      F_NM=1.0
      rake=-90.
      else
c oblique thrust currently assumed. If transtensional, consider -135.
      obl=.true.
      rev=.true.	!check this Oblique in DB?
      ss=.false.
      normal=.false.
      rake=135.
      F_RV=0.5	!intuitive choice. May require colleagues OK.
      F_NM=0.0
      endif
      xdiff= abs(rx-x(1,ift))
      ydiff= abs(ry-y(1,ift))
      xdmax= (dmax+500.)/(111.11*cos(ymax*coef))
      ydmax= (dmax+500.)/111.11
      if(xdiff.gt.xdmax) go to 850
      if(ydiff.gt.ydmax) go to 850
c      write(6,*) "prob",isz,i,prob(i-1,1)
      do 35 iatype=1,5
 35   dmin(iatype)=10000.
      nlenx= tlen(ift)/dlen +1
      nleny= width(ift)/dlen +1
      if(nleny.gt.100)then
      print *,'nleny large ',nleny,' for ift index ',ift
      print *,'for this fault tlen is ',tlen(ift)
      stop ' hazFXnga7: fdist Y-dimension too small '
      endif
c the below line doesnt work well for distributed top of fault
c      if(dip0(ift).eq.90.) nleny=1
c However, the idea is OK. Several cases can restrict nleny to speed up calcs.
	if(dip0(ift).eq.90..and.itype(ift).eq.1)nleny=1
c Currentlly, all char events rupture to top of fault. Only gr includes downdip top possibilitty	
c Steve Harmsen, Nov 16 2006. This needs to be discussed.
c----- new for AS hanging wall test 
      width2= (50.-depth0(ift))/(sin(abs(dip(ift))))
      nleny2= min(nint(width2/dlen) +1,100)
c      if(nleny2.eq.100)then
c      print *,nleny2,ift,width2
c      print *,'This is array limit.'
c      endif
c--------------
      nseg= npts(ift)-1
      aspectratio=tlen(ift)/width(ift)	!if rupture occupies entire fault.
c--- calculate distance to site for points (ix,iy) on fault plane
c---loop through increments along strike (ix) of each segment
	hwsite=.false.
c added below dec 14 2006 to perform checks on dipping faults that might have rupture top below
c top-of-fault. If rupture top is below fault top, more dmin checks must be performed
	if(magmin(ift,1).ge.7.0)then
	iymx=1
	elseif(magmin(ift,1).ge.6.5)then
	iymx=5
	else
	iymx=9
	endif
c	print *,ift,iymx,sinedip,nseg,nlenx,' ift iymx sin(dip) nseg,nlenx'
      do 101 ix=1,nlenx
      delta= float(ix-1)*dlen
c      if(hwsite)goto 101	!nothing left to check if site Rjb is zero
c this has to be thought over testing mar 8. Motion sometimes went down 1%. Shouldn't
c have. I don't understand but I decided to avoid this bypass (not a great time saver)
      do 500 iseg=1,nseg
      if(delta.lt.xlen(iseg,ift)) go to 501
 500  continue
 501  continue
      if(iseg.ge.2) delta= delta-xlen(iseg-1,ift)
      az= xaz(iseg,ift)
      sx= x(iseg,ift)
      sy= y(iseg,ift)
c      write(6,*) "ix, iseg, az", ix, iseg, az
      call back(delta,az,sy,sx,dfy,dfx)
      if(ix.eq.1) azprev= az
      if(abs(azprev-az).gt.10.) az= 0.5*(azprev+az)
      if(dip(ift).lt.0.) az2= az-90.
      if(dip(ift).gt.0.) az2= az+90.
      azprev= az
c---loop through increments iy downdip
	dist=10000.	!arbitrary number>dis_old
	dis_old=dist
      do 111 iy=1,nleny
c if downdip top of rupture is greater than 5 km the 5 below needs to be upped.
	if(dist.gt.dis_old.and.iy.gt.iymx)goto 111
	iymax(ix)=iy
      deltaz= (iy-1)*dlen
      depth= depth0(ift)+ deltaz*sinedip
      deltaz= deltaz*cosDELTA
c---find surface point above downdip portion of fault
      call back(deltaz,az2,dfy,dfx,dfy2,dfx2)
	dis_old=dist	
c This calc can stop at dwndip location when dist starts to rise;
c However, if the fault rupture top is downdip must continue at least to 4 or 8 km.
c The idea above of iy .gt. iymx is to keep going... testing nov15 2006 SH	
c--- find distance from each source point on fault to receiver; fdist
      call delaz(dfy2,dfx2,ry,rx,dist,az0,baz)
c dist is not a good approximation to R_jb which should be 0 over fault.
c we need to improve this. Below fix looks good if increment o(1 km)
c 4 possible HW combinations associated with short distances, 2 for fault with
c positive strike (az>0) and 2 for fault with negative strike (az < 0).
	if(dist.lt.0.75.and.az.ge.0.)then
	if(az0.ge.az.or.az0.le.az-180.)then
	dist=0.0
	hwsite=itype(ift).eq.1	!possible bypass for char faults
	endif
	elseif(dist.lt.0.75.and.az.lt.0.)then
	if(az0.le.az.or.az0.ge.180.+az)then
	dist=0.0
	hwsite=itype(ift).eq.1
	endif
	endif
c end fix for hw site (what about Art's material below?). If the above dont produce
c a zero at some iy location, then the site (rx,ry) is on the foot wall. 
c That is the idea anyway. A clear zero is needed for some nga HW terms
c	if(ift.eq.15.and.iy.eq.1.and.rx.eq.-119.05.and.ry.gt.34.15)
c	1write(25,*)rx,ry,dist,az0,az2,baz,ix,dfx2
      fdist(ix,iy,1)= dist
      fdist(ix,iy,2)= dist
      fdist(ix,iy,3)= sqrt(dist*dist+depth*depth)
      fdist(ix,iy,4)= fdist(ix,iy,3)
      fdist(ix,iy,5)= dist
c--- for Campbell, if depth less than seismogenic depth, ignore this part 
c--- of fault by making distance 1000 km
      if(depth.lt.3..and..not.hwsite)then
       fdist(ix,iy,4)= 1000.
       elseif(depth.lt.3.)then
       fdist(ix,iy,4)=3.
       endif
      if(dip0(ift).eq.90.) then
       if(depth0(ift).le.3.) fdist(ix,iy,4)= sqrt(dist*dist+9.)
       if(depth0(ift).gt.3.) fdist(ix,iy,4)= 
     &   sqrt(dist**2 + (depth0(ift))**2)
       endif
c---- added 6/13/02
      if(dist.gt.(tlen(ift)+dmax)) go to 850
      do 36 iatype=1,4
  36  if(fdist(ix,iy,iatype).lt.dmin(iatype)) 
     &   dmin(iatype)=fdist(ix,iy,iatype)
      if(fdist(ix,iy,5).lt.dmin(5)) then
         dmin(5)= fdist(ix,iy,5)
         testhw= 2.
         endif
 111  continue
c----- new loop for AS97 hanging wall test not using for nga SH. may need again.
      if(dip0(ift).eq.90.) go to 101
      if(nleny2.le.(nleny+1)) go to 101
      if(ix.eq.1) azold= az
      if(abs(azold-az).gt.40.) then
       do 1114 iy=nleny+1,nleny2
1114   fdist(ix,iy,5)= 10000.
       go to 101
       endif
	goto 1112	!not using the below test for nga. may need to reinstate.
1111      do iy=nleny+1,nleny2
         deltaz= (iy-1)*dlen
      depth= depth0(ift)+ deltaz*sin(abs(dip(ift)))
      deltaz= deltaz*cos(dip(ift))
c---find surface point above downdip portion of fault
      call back(deltaz,az2,dfy,dfx,dfy2,dfx2)
c--- find distance from each source point on fault to receiver; fdist
      call delaz(dfy2,dfx2,ry,rx,dist,az0,baz)
      fdist(ix,iy,5)= dist
      if(fdist(ix,iy,5).lt.dmin(5)) then
        dmin(5)=fdist(ix,iy,5)
        dhy= (iy-(nleny+1))*dlen*cos(abs(dip(ift)))
        testhw= dhy*angtest +2.
        endif
        enddo	!abrahamson test
 1112 continue
c------- end of new loop
      azold= az
 101  continue
c        write(6,*) ry,rx,testhw,dhy,angtest,dmin(5)
c  dmin is minimum distance from fault to receiver 
	nearsrc=dmin(1).lt.30.0.and.depth0(ift).lt.1.5	!certain calcs can be bypassed for distant  flts
      if(dmin(1).gt.dmax) go to 850 
      if(itype(ift).eq.2) then
c----  loop through floating rupture zones along fault
c--- find minimum distance dmin2 to receiver for each rupture zone
c--- nrups(m,ift) rupture zones per magnitude bin m
c-- move rupture zones by dlen horizontally along fault
      ntmp=0
      do imag=1,nmagf(ift)
      ntmp=max(ntmp,nmag0(ift,imag))
      enddo
        do 222 m=1,ntmp	!+2 no need for overkill.
        xmag= magmin(ift,1)+(m-1)*dmag(ift,1)	
c! magmin: can change slightly with imag. Using first branch value here
c------find rupture length from Wells Coppersmith relation 
c        if(iftype(ift).eq.1) ruplen=  (xmag-5.16)/1.12
c        if(iftype(ift).eq.2) ruplen=  (xmag-5.00)/1.22
c        if(iftype(ift).eq.3) ruplen=  (xmag-4.86)/1.32
c        if(iftype(ift).eq.1) ruplen=  -3.55+0.74*xmag
c        if(iftype(ift).eq.2) ruplen=  -2.86+0.63*xmag
c        if(iftype(ift).eq.3) ruplen=  -3.22+0.69*xmag
c---- changed 5/29/02
c        if(iftype(ift).eq.3) ruplen=  -2.01+0.50*xmag
c here is one place where certain calcs are done only once. New nov 2006
	if(firstf(ift))then
c---- ruplen based on W&C all flt slip types. changed 7/1/02
        ruplen= -3.22+ 0.69*xmag
        ruplen= 10**ruplen
c down-dip rupture possibilities for M<= 7 . This information
	if(xmag.lt.6.5)then
	nrupdd=5	!smaller events can have deeper tops. new dec 2006.
	elseif(xmag.le.6.75)then
	nrupdd=3
	elseif(xmag.le.7.0)then
	nrupdd=2
	else
	nrupdd=1
	endif
	do idn=1,nrupdd
c below guards against the long strip downdip in case M is less than 6.2 or so.
	widthrup=max(1.0, min(width(ift)-2.*float(idn-1),ruplen))
        ar(m,idn)=ruplen/widthrup
        enddo	!variable aspect ratio for floating rupture downdip.
c--- changed to dmove move for floating rupture
        nrups(m,ift)= (tlen(ift)-ruplen)/dmove +1.
        nrupd(m,ift)=nrupdd
	rupln(m,ift)=min(ruplen,tlen(ift))
        if(ruplen.ge.tlen(ift))nrups(m,ift)=1
c the above calcs are done once per fault, when firstf(ift) is .true.	
	endif
        nxx= rupln(m,ift)/dlen
        nyy= width(ift)/dlen
      if(dip0(ift).eq.90.) nyy=0
        nyy2= min(100,nint(width2/dlen)) 
c do jrup below is the new downdip rupture loop: if M<7 then nrupd>1.
c nrupd is 4 for M<6.5. Maximum top of rupture 8 km deep in that case.
c nrup is nrups * nrupd (number along strike * number downdip)
c simple rectangle is assumed. Does this have problems for complicated geom?
c
        iy0 = 1
c each station -source pair has calculation branch that is based on "nearsrc"
        if(nearsrc)then
        nrupdd=nrupd(m,ift)
        else
        nrupdd=1
c nearsource sensitivity. far away no sensitivity to depth of rupture top
	endif
        do jrup=1,nrupdd
        do 302 irup=1,nrups(m,ift)
        testhw3(irup,m)=2.
        do 37 iatype=1,5
  37    dminr(iatype,jrup)=10000.
        xmove= dmove*(irup-1)
        ix0= xmove/dlen+1
        ix1=min(ix0+nxx,nlenx)
        do 304 ix= ix0,ix1
c iy1 is new, dec 2006, to control downdip search. Square or 
c rectangular strike-dominant ruptures as of dec 2006.
c squarish rupture shape
        iy1= min(iymax(ix),iy0+nint(widthrup/dlen))
c        if(irup.eq.1.and.ix.eq.ix0.and.ift.eq.1)
c     + print *,iy0,iy1,iymax(ix),ar(m,1),ar(m,2),ar(m,4),xmag
        do 303 iy= iy0,iy1
        do 303 iatype=1,5
        dist= fdist(ix,iy,iatype)
        dminr(iatype,jrup)=min(dminr(iatype,jrup), dist)
  303   continue
c----- Hanging wall test for AS97. Skip it if as97 is not invoked
        if(dip0(ift).eq.90..or.noas97) go to 304
        if(nyy2.le.(nyy+2)) go to 304
        do 3031 iy=nyy+2, nyy2
        dist= fdist(ix,iy,5)
        if(dist.lt.dminr(5,jrup)) then
         dminr(5,jrup)= dist
         dhy= (iy-(nyy+2))*dlen*cos(abs(dip(ift)))
         testhw3(irup,m)= dhy*angtest+ 2.
         endif
 3031   continue
c-----------------------
  304   continue
        do 39 iatype=1,5
 39     dmin2(m,irup,jrup,iatype)=dminr(iatype,jrup)
  302   continue
	iy0=iy0+2
	enddo	!downdip index
  222   continue
	firstf(ift)=.false.
c end of down-dip related changes
      endif
c 
c
c-----------------------------------------
c----  GR with nmag0>1 with Mmax uncertainties
      if((itype(ift).eq.2).and.(nmag0(ift,1).gt.1).and.
     &   (itest(ift).eq.0)) then
	do imag=1,nmagf(ift)	!can have two or more distributions often
c with diffrent Mmax.
       do 403 ilt=1,nbranch
        mmax= magmax(ift,imag)+ dmbranch(ilt)
        totmo= 0.
        nmag= (mmax- magmin(ift,imag))/dmag(ift,imag) + 1.4
c-- loop through magnitudes
c       if(abs(rx+101.).lt.0.1.and.abs(ry-38.).lt.0.1)then
c       if(ilt.eq.1)write(6,*)rx,ry,' gr with uncrt ift',ift
c       write(6,*) "nmag=",nmag,"nmag0(ift,imag)",nmag0(ift,imag),nrups(m,ift)
c       endif
        do 285 m=1,nmag
        xmag= magmin(ift,imag)+(m-1)*dmag(ift,imag)
c        mm= (xmag-5.8)/0.05 +1.5
        rate= ratenew(ift,imag,ilt) - b(ift,imag)*xmag
c rate is now a relative rate, because of new relwt factor Nov 2 2006. SH.
        rate= relwt(ift,imag) * 10.**rate
        totmo= totmo+ rate*(10.**(1.5*xmag+ 9.05))
c        torate(mm)= torate(mm)+ rate*ale(idis+mwid+1)
c new, possible downdip top surface of rupture. nrupd can be 1, 2 or 3 
	if(nearsrc)then
	nrupdd=nrupd(m,ift)
	else
	nrupdd=1
	endif 
        rate= rate/float(nrups(m,ift)*nrupdd)
	do 284 jrup=1,nrupdd	!new loop downdip rup.
        aspectratio=ar(m,jrup)
        dz=2.*float(jrup-1)
        dtor1=dtor + dz	!all important depth to top of rupture.
        cyhwfac=atan((width(ift)-dz)*0.5*cosDELTA/(dtor1+1.0))/(pi*0.5)
c--- loop through floating rupture zones
        do 284 irup=1,nrups(m,ift)
c report rate of eqs * weight applied to logic-tree branch, R,M,rate'
        rjb=dmin2(m,irup,jrup,1)
	if(slist)write(30+i,399)rjb,xmag,rate*wtbranch(ilt),ift,irup,ilt,jrup
399	format(f7.2,1x,f6.2,1x,e12.5,1x,i3,1x,i3,2(1x,i2))
        do  ip=1,nper
        iq=iper(ip)	!std periods in 2002. 
        do 282 ia=1,nattn(ip)
        rrup= dmin2(m,irup,jrup,3)	!type 3 supposed to be rrup
        weight= wt(ip,ia,1)
        if(rjb.gt.wtdist(ip,ia)) weight=wt(ip,ia,2)
        if(rjb.gt.dmax) go to 282
c nga relations are collected into the first set of models to check
	if(nga(ip,ia)) then
        if(iatten(ip,ia).eq.13) then
	call getBooreNGA06m (iperb(ip),xmag,rjb,vs30,gnd,sigmaf)
         elseif(iatten(ip,ia).eq.14) then
	pgacalc=ip.eq.1
        call getCBNGA1106 (ipercb(ip),xmag,rrup,rjb,dtor1,
     1 vs30,dbasin,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.15)then
c 6/2006 implementation of getCYNGA 
        call CY2006H(ipercy(ip), xmag, width(ift), rrup, rjb, vs30,  
     1      dtor1, srcSiteA, F_RV, F_NM,gnd,sigmaf)
        elseif (iatten(ip,ia).eq.16) then
        call AS_2005b ( xmag, dip0(ift), rake, aspectratio, rRup, rjb,
     1                     vs30, srcSiteA, dtor1, gnd, sigma1, 
     2                     ipera(ip), period1 )
c gnd is lnSA in AS code. need to fill in some other input. esp. aspectratio.
c period1 is output by AS_modelXX. period1 should equal per(ip)
	sigmaf=1./sqrt2/sigma1
	elseif(iatten(ip,ia).eq.17)then
	call getIdriss(iper(ip),xmag,rjb,vs30,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.18)then
c new nov 7,2006. Kanno
	call kanno(iperk(ip),gnd,sigmaf,xmag,rrup,vsfac)
	endif
	elseif(wus02(ip,ia))then
c WUS pre-nga (2002 atten models)
	if(iatten(ip,ia).eq.1)then
	call getSpu2000(iq,xmag,rjb,vs30,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.3)then
	call getsadigh(iq,xmag,rrup,gnd,sigmaf,
     1 sigmanf,distnf)
	elseif(iatten(ip,ia).eq.8)then
	call getAS97(iq,xmag,rrup,sigmanf,distnf,hwsite,gnd,sigmaf)
       elseif(iatten(ip,ia).eq.9)then
       call getCamp2003(iq,xmag,rrup,rjb,gnd,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.11)then
	call getBJF97(iq,xmag,rjb,vs30,gnd,sigmaf)
	endif
	elseif(ceus02(ip,ia))then
c CEUS pre-nga (2002 atten models)
	if(iatten(ip,ia).eq.2)then
	call getToro(iq,1,xmag,rjb,gnd,sigma,sigmaf,
     1 sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-2)then
	call getToro(iq,2,xmag,rjb,gnd,sigma,sigmaf,
     1 sigmanf,distnf)
        elseif(iatten(ip,ia).eq.4)then
        call getAB06(iperab(ip),1,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf,vs30)
        elseif(iatten(ip,ia).eq.-4)then
        call getAB06(iperab(ip),2,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf,vs30)
        elseif(iatten(ip,ia).eq.19)then
	call getTP05(ipertp(ip),irtb,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.6)then
	call getFEA(iq,1,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-6)then	
	call getFEA(iq,3,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.5)then	!to distinguish ab95 from fea
	call getFEA(iq,2,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-5)then	!HR for atkinson-boore
	call getFEA(iq,4,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.7) then
        call getSomer(iq,1,xmag,rrup,sigmanf,distnf,gnd,sigma,sigmaf)
	elseif(iatten(ip,ia).eq.-7) then
        call getSomer(iq,2,xmag,rrup,sigmanf,distnf,gnd,sigma,sigmaf)
       	elseif(iatten(ip,ia).eq.10)then
        call getCampCEUS(iq,1,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
       	elseif(iatten(ip,ia).eq.-10)then
        call getCampCEUS(iq,2,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	endif
c CEUS only: This is a good place to apply the extra clamp constraint which
c in 2002 was used only for CEUS sources. The precomputed p() matrix does
c not work for this case because truncation is no longer at mu+3sig
	test0=gnd+3.*sigma
      test= exp(test0)
      if(clamp(iq).lt.test .and. clamp(iq).gt.0.) then
      clamp2= alog(clamp(iq))
      sigmasq=1./sigma/sqrt2
      tempgt3= (gnd- clamp2)*sigmasq
      probgt3= (erf(tempgt3)+1.)*0.5
      do  k=1,nlev(ip)
      temp= (gnd- xlev(k,ip))*sigmasq
      temp1= (erf(temp)+1.)*0.5
      temp1= (temp1-probgt3)/(1.-probgt3)
      if(temp1.lt.0.) goto 282	!no more calcs once p<0
        prob(icnt,k,ip)= prob(icnt,k,ip)+ 
     &         wtbranch(ilt)*weight*rate*temp1
  	enddo
  	goto 282
  	endif
	elseif(iatten(ip,ia).eq.12)then
	call getMota(iper(ip),xmag,rrup,vs30,gnd,sigmaf)
	endif
	do  k=1,nlev(ip)
	 pr=(gnd - xlev(k,ip))*sigmaf
	 if(pr.gt.3.3)then
	 ipr=250002
	 elseif(pr.gt.plim)then
	 ipr= 1+nint(dp2*(pr-plim))	!3sigma cutoff n'(mu,sig)
	 else
	 goto 282	!transfer out if ground motion above mu+3sigma
	 endif
        prob(icnt,k,ip)= prob(icnt,k,ip)+ 
     &         wtbranch(ilt)*weight*rate*p(ipr)
         enddo

 282    continue
 	enddo	! this used to be a do 283,...283 continue loop
c testing DOALL speedup here 	
 284    continue
 285    continue

 403    continue
 	enddo	!imag loop, diff. distributions.
        go to 850
        endif
ccccccccccccccccccccccccccccc
ccc---- GR with nmag0=1, one magnitude floated, with uncertainties,
c       used for some faults outside of CA and Maacama northern CA
ccc--- for very long faults when Mmmax set to 7.5
      if((itype(ift).eq.2).and.(nmag0(ift,1).eq.1).and.
     &  (itest(ift).eq.0)) then
	do imag=1,nmagf(ift)	!can have two or more distributions often
c with diffrent Mmax.
        totmo=0.
        aspectratio=ar(1,1)	
c        print *,ift,aspectratio,' one mag floated'
        do 1403 ilt=1,nbranch
        xmag= magmax(ift,imag)+ dmbranch(ilt)
        xmo= 10.**(1.5*xmag+9.05)
c relative rate, nov 2006
        rate= relwt(ift,imag) * xmo2(ift,imag)/xmo
        rate= rate/float(nrups(1,ift))
        do 1404 idis= -mwid, mwid
        xmag2= xmag+ idis*0.05
        wt1wt2=ale2(idis+mwid+1)*wtbranch(ilt)
c--- loop through floating rupture zones
        do 1284 irup=1,nrups(1,1)
c        totmo= totmo+ ale2(idis+mwid+1)*rate*10.**(1.5*xmag2+ 9.05)
C	write rate data if station list option is in effect.
c for big long faults assume all ruptures to surface... Discusswith colleagues?
        rjb=dmin2(1,irup,1,1)
	if(slist)write(30+i,399)rjb,xmag2,rate*wt1wt2,ift,ilt,idis
        do  ip=1,nper
        iq=iper(ip)
        do 1282 ia=1,nattn(ip)
        rrup= dmin2(1,irup,1,3)
        weight= wt(ip,ia,1)
        if(rjb.gt.wtdist(ip,ia)) weight=wt(ip,ia,2)
        if(rjb.gt.dmax) go to 1282
c
c nga relations are collected into the first set of models to check
	if(nga(ip,ia)) then
        if(iatten(ip,ia).eq.13) then
	call getBooreNGA06m (iperb(ip),xmag2,rjb,vs30,gnd,sigmaf)
         elseif(iatten(ip,ia).eq.14) then
	pgacalc=ip.eq.1
        call getCBNGA1106 (ipercb(ip),xmag2,rrup,rjb,dtor,
     1 vs30,dbasin,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.15)then
c 6/2006 implementation of getCYNGA 
        call CY2006H(ipercy(ip), xmag2, width(ift), rrup, rjb, vs30,  
     1      dtor, srcSiteA, F_RV, F_NM,gnd,sigmaf)
        elseif (iatten(ip,ia).eq.16) then
        call AS_2005b ( xmag2, dip0(ift), rake, aspectratio, rRup, rjb,
     1                     vs30, srcSiteA, dtor, gnd, sigma1, 
     2                     ipera(ip), period1 )
c gnd is lnSA in AS code. need to fill in some other input. esp. aspectratio.
c period1 is output by AS_modelXX. period1 should equal per(ip)
	sigmaf=1./sqrt2/sigma1
	elseif(iatten(ip,ia).eq.17)then
	call getIdriss(iper(ip),xmag2,rjb,vs30,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.18)then
c new nov 7,2006. Kanno
	call kanno(iperk(ip),gnd,sigmaf,xmag2,rrup,vsfac)
	endif
	elseif(wus02(ip,ia))then
c WUS pre-nga (2002 atten models)
	if(iatten(ip,ia).eq.1)then
	call getSpu2000(iq,xmag2,rjb,vs30,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.3)then
	call getsadigh(iq,xmag2,rrup,gnd,sigmaf,
     1 sigmanf,distnf)
	elseif(iatten(ip,ia).eq.8)then
	call getAS97(iq,xmag2,rrup,sigmanf,distnf,hwsite,gnd,sigmaf)
       elseif(iatten(ip,ia).eq.9)then
       call getCamp2003(iq,xmag2,rrup,rjb,gnd,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.11)then
	call getBJF97(iq,xmag2,rjb,vs30,gnd,sigmaf)
	endif
	elseif(ceus02(ip,ia))then
c CEUS pre-nga (2002 atten models)
c
	if(iatten(ip,ia).eq.2)then
	call getToro(iq,1,xmag2,rjb,gnd,sigma,sigmaf,
     1 sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-2)then
	call getToro(iq,2,xmag2,rjb,gnd,sigma,sigmaf,
     1 sigmanf,distnf)
        elseif(iatten(ip,ia).eq.4)then
        call getAB06(iperab(ip),1,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf,vs30)
        elseif(iatten(ip,ia).eq.-4)then
        call getAB06(iperab(ip),2,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf,vs30)
        elseif(iatten(ip,ia).eq.19)then
	call getTP05(ipertp(ip),irtb,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.6)then
	call getFEA(iq,1,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-6)then	!to distinguish ab95 from fea
	call getFEA(iq,3,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.5)then	!HR
c hard rock possibilities. 
	call getFEA(iq,2,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-5)then	!HR for atkinson-boore
	call getFEA(iq,4,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.7) then
        call getSomer(iq,1,xmag2,rrup,sigmanf,distnf,gnd,sigma,sigmaf)
	elseif(iatten(ip,ia).eq.-7) then
        call getSomer(iq,2,xmag2,rrup,sigmanf,distnf,gnd,sigma,sigmaf)
       	elseif(iatten(ip,ia).eq.10)then
        call getCampCEUS(iq,1,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
       	elseif(iatten(ip,ia).eq.-10)then
        call getCampCEUS(iq,2,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	endif
c This is a good place to apply the extra clamp constraint which
c in 2002 was used only for CEUS sources. The precomputed p() matrix does
c not work for this case because truncation is no longer at mu+3sig
	test0=gnd+3.*sigma
      test= exp(test0)
      if(clamp(iq).lt.test .and. clamp(iq).gt.0.) then
      clamp2= alog(clamp(iq))
      sigmasq=1./sigma/sqrt2
      tempgt3= (gnd- clamp2)*sigmasq
      probgt3= (erf(tempgt3)+1.)*0.5
      do  k=1,nlev(ip)
      temp= (gnd- xlev(k,ip))*sigmasq
      temp1= (erf(temp)+1.)*0.5
      temp1= (temp1-probgt3)/(1.-probgt3)
      if(temp1.lt.0.) goto 1282	!no more calcs once p<0
        prob(icnt,k,ip)= prob(icnt,k,ip)+ wt1wt2*
     &         *weight*rate*temp1
   	enddo	!do k...
   	goto 1282
  	endif
	elseif(iatten(ip,ia).eq.12)then
	call getMota(iper(ip),xmag2,rrup,vs30,gnd,sigmaf)
	endif
        do  k=1,nlev(ip)
	 pr=(gnd - xlev(k,ip))*sigmaf
	 if(pr.gt.3.3)then
	 ipr=250002
	 elseif(pr.gt.plim)then
	 ipr= 1+nint(dp2*(pr-plim))	!3sigma cutoff n'(mu,sig)
	 else
	 goto 1282	!transfer out if ground motion above mu+3sigma
	 endif
        prob(icnt,k,ip)= prob(icnt,k,ip)+wt1wt2*weight*rate*p(ipr)
     	enddo
1282    continue
c1283    continue
	enddo	!the DOALL parallelization if possible.
1284    continue
1285    continue
1404    continue
1403    continue
	enddo	!imag new index 6/2006. Multiple mmax rate per fault.
c        write(6,*) totmo,(xmo2(ift,j),j=1,nmagf(ift))
c        read(5,*) idum
        go to 850
        endif
c---------------------
c------ all GR without uncertainties
      if((itype(ift).eq.2).and.(itest(ift).eq.1)) then
c-- loop through magnitudes
        iftype2= iftype(ift)
	do imag=1,nmagf(ift)	!can have two or more distributions often
c with diffrent Mmax.
        do 2285 m=1,nmag0(ift,imag)
        xmag= magmin(ift,imag)+(m-1)*dmag(ift,imag)
        rate= a(ift,imag) - b(ift,imag)*xmag
c relative rate
        rate= relwt(ift,imag) * 10.**rate
	if(nearsrc)then
	nrupdd=nrupd(m,ift)
	else
	nrupdd=1
	endif 
        rate= rate/float(nrups(m,ift)*nrupdd)
c--- down-dip loop through floating rupture zones
	do 2284 jrup=1,nrupdd
        aspectratio=ar(m,jrup)
        dz=2.*float(jrup-1)
        dtor1=dtor + dz	!all important depth to top of rupture.
        cyhwfac=atan((width(ift)-dz)*0.5*cosDELTA/(dtor1+1.0))/(pi*0.5)
c variable factor above for CY relation when downdip rupture occurs        
c--- along-strike loop through floating rupture zones
        do 2284 irup=1,nrups(m,ift)
        rjb  = dmin2(m,irup,jrup,1)
	if(slist)write(30+i,399)rjb,xmag,rate,ift,imag,irup,jrup
        do  ip=1,nper
        iq=iper(ip)	!std period index
        do 2282 ia=1,nattn(ip)
         iftype2= iftype(ift)
         rrup = dmin2(m,irup,jrup,3)
        weight= wt(ip,ia,1)
        if(rjb.gt.wtdist(ip,ia)) weight=wt(ip,ia,2)
        if(rjb.gt.dmax) go to 2282
c nga relations are collected into the first set of models to check
	if(nga(ip,ia)) then
        if(iatten(ip,ia).eq.13) then
	call getBooreNGA06m (iperb(ip),xmag,rjb,vs30,gnd,sigmaf)
         elseif(iatten(ip,ia).eq.14) then
	pgacalc=ip.eq.1
        call getCBNGA1106 (ipercb(ip),xmag,rrup,rjb,dtor1,
     1 vs30,dbasin,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.15)then
c 6/2006 implementation of getCYNGA 
        call CY2006H(ipercy(ip), xmag, width(ift), rrup, rjb, vs30,  
     1      dtor1, srcSiteA, F_RV, F_NM,gnd,sigmaf)
        elseif (iatten(ip,ia).eq.16) then
        call AS_2005b ( xmag, dip0(ift), rake, aspectratio, rRup, rjb,
     1                     vs30, srcSiteA, dtor1, gnd, sigma1, 
     2                     ipera(ip), period1 )
c gnd is lnSA in AS code. need to fill in some other input. esp. aspectratio.
c period1 is output by AS_modelXX. period1 should equal per(ip)
	sigmaf=1./sqrt2/sigma1
	elseif(iatten(ip,ia).eq.17)then
	call getIdriss(iper(ip),xmag,rjb,vs30,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.18)then
c new nov 7,2006. Kanno
	call kanno(iperk(ip),gnd,sigmaf,xmag,rrup,vsfac)
	endif
	elseif(wus02(ip,ia))then
c WUS pre-nga (2002 atten models)
	if(iatten(ip,ia).eq.1)then
	call getSpu2000(iq,xmag,rjb,vs30,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.3)then
	call getsadigh(iq,xmag,rrup,gnd,sigmaf,
     1 sigmanf,distnf)
	elseif(iatten(ip,ia).eq.8)then
	call getAS97(iq,xmag,rrup,sigmanf,distnf,hwsite,gnd,sigmaf)
       elseif(iatten(ip,ia).eq.9)then
       call getCamp2003(iq,xmag,rrup,rjb,gnd,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.11)then
	call getBJF97(iq,xmag,rjb,vs30,gnd,sigmaf)
	endif
	elseif(ceus02(ip,ia))then
c
c CEUS pre-nga (2002 atten models). These motions can be "clamped"
c
	if(iatten(ip,ia).eq.2)then
	call getToro(iq,1,xmag,rjb,gnd,sigma,sigmaf,
     1 sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-2)then
	call getToro(iq,2,xmag,rjb,gnd,sigma,sigmaf,
     1 sigmanf,distnf)
        elseif(iatten(ip,ia).eq.4)then
        call getAB06(iperab(ip),1,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf,vs30)
        elseif(iatten(ip,ia).eq.-4)then
        call getAB06(iperab(ip),2,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf,vs30)
        elseif(iatten(ip,ia).eq.19)then
	call getTP05(ipertp(ip),irtb,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.6)then
	call getFEA(iq,1,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-6)then	!HR
	call getFEA(iq,3,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.5)then	!Rto distinguish ab95 from fea
	call getFEA(iq,2,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-5)then	!HR for atkinson-boore
	call getFEA(iq,4,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.7) then
        call getSomer(iq,1,xmag,rrup,sigmanf,distnf,gnd,sigma,sigmaf)
	elseif(iatten(ip,ia).eq.-7) then
        call getSomer(iq,2,xmag,rrup,sigmanf,distnf,gnd,sigma,sigmaf)
       	elseif(iatten(ip,ia).eq.10)then
        call getCampCEUS(iq,1,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
       	elseif(iatten(ip,ia).eq.-10)then
        call getCampCEUS(iq,2,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	endif
c This is a good place to apply the extra clamp constraint which
c in 2002 was used only for CEUS sources. The precomputed p() matrix does
c not work for this case because truncation is no longer at mu+3sig
	test0=gnd+3.*sigma
      test= exp(test0)
      if(clamp(iq).lt.test .and. clamp(iq).gt.0.) then
      clamp2= alog(clamp(iq))
      sigmasq=1./sigma/sqrt2
      tempgt3= (gnd- clamp2)*sigmasq
      probgt3= (erf(tempgt3)+1.)*0.5
      do  k=1,nlev(ip)
      temp= (gnd- xlev(k,ip))*sigmasq
      temp1= (erf(temp)+1.)*0.5
      temp1= (temp1-probgt3)/(1.-probgt3)
      if(temp1.lt.0.) goto 2282	!no more calcs once p<0
        prob(icnt,k,ip)= prob(icnt,k,ip)+ 
     &         weight*rate*temp1
  	enddo	!do k=1,nlev
  	goto 2282
  	endif
	elseif(iatten(ip,ia).eq.12)then
	call getMota(iper(ip),xmag,rrup,vs30,gnd,sigmaf)
	endif
        do  k=1,nlev(ip)
	 pr=(gnd - xlev(k,ip))*sigmaf
	 if(pr.gt.3.3)then
	 ipr=250002
	 elseif(pr.gt.plim)then
	 ipr= 1+nint(dp2*(pr-plim))	!3sigma cutoff n'(mu,sig)
	 else
	 goto 2282	!transfer out if ground motion above mu+3sigma
	 endif
        prob(icnt,k,ip)= prob(icnt,k,ip)+ 
     1  weight*rate*p(ipr)
	enddo
2282    continue
c2283    continue
	enddo
2284    continue
2285    continue
	enddo	!imag loop, different GR distributions.
        go to 850
        endif
c---------------------------
c--- for characteristic event, modified to include multiple mags per fault
c---- characteristic with uncertainties
c To some extent diff M(RA) uncertainties take care of mag. variation. We seem to
c be repeating some mag uncertainty here.
c characteristic events fill the fault by definition. no variation in top of rup.
c discuss with colleagues? nov 15 20006
      if((itype(ift).eq.1).and.(itest(ift).eq.0)) then
	do imag=1,nmagf(ift)	!new 6/06 consolidate mag variation for given fault
        xmag= cmag(ift,imag)
        xmo= 1.5*xmag +9.05
        xmo= 10.**xmo
c relative rate, added nov 2006.
        rate= relwt(ift,imag) *crate(ift,imag)
        xmorate= xmo *rate
        do 203 ilt=1,nbranch
        xmag= cmag(ift,imag) + dmbranch(ilt)
        xmo= 1.5*xmag+9.05
        xmo= 10.**xmo
        rate= xmorate/xmo
        totmo =0.
        do 244 idis= -mwid, mwid
        xmag2= xmag + idis*0.05
c        totmo= totmo+ rate*ale2(idis+mwid+1)*(10.**(1.5*xmag2+9.05))
        rjb = dmin(1)
        wt1wt2=wtbranch(ilt)*ale2(idis+mwid+1)
	if(slist)write(30+i,399)rjb,xmag2,rate*wt1wt2,ift,ilt,idis
        do  ip=1,nper
        iq = iper(ip)
        do 204 ia=1,nattn(ip)
        iftype2= iftype(ift)
        rrup = dmin(3)	!type3 r_cd or rrup
        if(rjb.gt.dmax)goto 204	!sail on out if too far.
        weight= wt(ip,ia,1)
        if(rjb.gt.wtdist(ip,ia)) weight=wt(ip,ia,2)
c nga relations are collected into the first set of models to check
	if(nga(ip,ia)) then
        if(iatten(ip,ia).eq.13) then
	call getBooreNGA06m (iperb(ip),xmag2,rjb,vs30,gnd,sigmaf)
         elseif(iatten(ip,ia).eq.14) then
	pgacalc=ip.eq.1
        call getCBNGA1106 (ipercb(ip),xmag2,rrup,rjb,dtor,
     1 vs30,dbasin,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.15)then
c 6/2006 implementation of getCYNGA 
        call CY2006H(ipercy(ip), xmag2, width(ift), rrup, rjb, vs30,  
     1      dtor, srcSiteA, F_RV, F_NM,gnd,sigmaf)
        elseif (iatten(ip,ia).eq.16) then
        call AS_2005b ( xmag2, dip0(ift), rake, aspectratio, rRup, rjb,
     1                     vs30, srcSiteA, dtor, gnd, sigma1, 
     2                     ipera(ip), period1 )
c gnd is lnSA in AS code. need to fill in some other input. esp. aspectratio.
c period1 is output by AS_modelXX. period1 should equal per(ip)
	sigmaf=1./sqrt2/sigma1
	elseif(iatten(ip,ia).eq.17)then
	call getIdriss(iper(ip),xmag2,rjb,vs30,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.18)then
c new nov 7,2006. Kanno
	call kanno(iperk(ip),gnd,sigmaf,xmag2,rrup,vsfac)
	endif
	elseif(wus02(ip,ia))then
c WUS pre-nga (2002 atten models)
	if(iatten(ip,ia).eq.1)then
	call getSpu2000(iq,xmag2,rjb,vs30,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.3)then
	call getsadigh(iq,xmag2,rrup,gnd,sigmaf,
     1 sigmanf,distnf)
	elseif(iatten(ip,ia).eq.8)then
	call getAS97(iq,xmag2,rrup,sigmanf,distnf,hwsite,gnd,sigmaf)
       elseif(iatten(ip,ia).eq.9)then
       call getCamp2003(iq,xmag2,rrup,rjb,gnd,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.11)then
	call getBJF97(iq,xmag2,rjb,vs30,gnd,sigmaf)
	endif
	elseif(ceus02(ip,ia))then
c CEUS pre-nga (2002 atten models)
	if(iatten(ip,ia).eq.2)then
	call getToro(iq,1,xmag2,rjb,gnd,sigma,sigmaf,
     1 sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-2)then
	call getToro(iq,2,xmag2,rjb,gnd,sigma,sigmaf,
     1 sigmanf,distnf)
        elseif(iatten(ip,ia).eq.4)then
        call getAB06(iperab(ip),1,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf,vs30)
        elseif(iatten(ip,ia).eq.-4)then
        call getAB06(iperab(ip),2,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf,vs30)
        elseif(iatten(ip,ia).eq.19)then
	call getTP05(ipertp(ip),irtb,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.6)then
	call getFEA(iq,1,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-6)then	!FEA- HR
	call getFEA(iq,3,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.5)then	!to distinguish ab95 from fea
c hard rock possibilities. These are  available for CEUS atten models as
c of July or August 2006.
	call getFEA(iq,2,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-5)then	!HR for atkinson-boore
	call getFEA(iq,4,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.7) then
        call getSomer(iq,1,xmag2,rrup,sigmanf,distnf,gnd,sigma,sigmaf)
	elseif(iatten(ip,ia).eq.-7) then
        call getSomer(iq,2,xmag2,rrup,sigmanf,distnf,gnd,sigma,sigmaf)
       	elseif(iatten(ip,ia).eq.10)then
        call getCampCEUS(iq,1,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
       	elseif(iatten(ip,ia).eq.-10)then
        call getCampCEUS(iq,2,xmag2,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	endif
c This is a good place to apply the extra clamp constraint which
c in 2002 was used only for CEUS sources. The precomputed p() matrix does
c not work for this case because truncation is no longer at mu+3sig
	test0=gnd+3.*sigma
      test= exp(test0)
      if(clamp(iq).lt.test .and. clamp(iq).gt.0.) then
      clamp2= alog(clamp(iq))
      sigmasq=1./sigma/sqrt2
      tempgt3= (gnd- clamp2)*sigmasq
      probgt3= (erf(tempgt3)+1.)*0.5
      do  k=1,nlev(ip)
      temp= (gnd- xlev(k,ip))*sigmasq
      temp1= (erf(temp)+1.)*0.5
      temp1= (temp1-probgt3)/(1.-probgt3)
      if(temp1.lt.0.) goto 204	!no more calcs once p<0
        prob(icnt,k,ip)= prob(icnt,k,ip)+ wt1wt2*weight*rate*temp1
   	enddo	!do k...
   	goto 204
  	endif
	elseif(iatten(ip,ia).eq.12)then
	call getMota(iper(ip),xmag2,rrup,vs30,gnd,sigmaf)
	endif
        do  k=1,nlev(ip)
	 pr=(gnd - xlev(k,ip))*sigmaf
	 if(pr.gt.3.3)then
	 ipr=250002
	 elseif(pr.gt.plim)then
	 ipr= 1+nint(dp2*(pr-plim))	!3sigma cutoff n'(mu,sig)
	 else
	 goto 204	!transfer out if ground motion above mu+3sigma
	 endif
        prob(icnt,k,ip)= prob(icnt,k,ip)+ wt1wt2*weight*rate*p(ipr)
	enddo	!k=1,nlev
 
ccccccccc
 204    continue
	enddo	
 244    continue
c        write(6,*) "totmo, xmorate",ift,ilt,totmo, xmorate
c        read(5,*) idum
 203    continue
	enddo	!imag index
        endif
ccccccccccccccccc
cc-- characteristic without uncertainties
      if((itype(ift).eq.1).and.(itest(ift).eq.1)) then
	do imag=1,nmagf(ift)	!new 6/06 consolidate mag variation for given fault
        xmag= cmag(ift,imag)
        xmag0=xmag
c relative rate nov 2006. SH.
        rate= relwt(ift,imag) * crate(ift,imag)
        iftype2= iftype(ift)
        rjb = dmin(1)
	if(slist)write(30+i,399)rjb,xmag,rate,ift,imag
        do  ip=1,nper
        iq=iper(ip)
        do 3203 ia=1,nattn(ip)
        iftype2= iftype(ift)
        rrup= dmin(3)
        if(rjb.gt.dmax)goto 3203
        weight= wt(ip,ia,1)
        if(rjb.gt.wtdist(ip,ia)) weight=wt(ip,ia,2)
c nga relations are collected into the first set of models to check
	if(nga(ip,ia)) then
        if(iatten(ip,ia).eq.13) then
	call getBooreNGA06m (iperb(ip),xmag,rjb,vs30,gnd,sigmaf)
         elseif(iatten(ip,ia).eq.14) then
	pgacalc=ip.eq.1
        call getCBNGA1106 (ipercb(ip),xmag,rrup,rjb,dtor,
     1 vs30,dbasin,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.15)then
c 6/2006 implementation of getCYNGA 
        call CY2006H(ipercy(ip), xmag, width(ift), rrup, rjb, vs30,  
     1      dtor, srcSiteA, F_RV, F_NM,gnd,sigmaf)
        elseif (iatten(ip,ia).eq.16) then
        call AS_2005b ( xmag, dip0(ift), rake, aspectratio, rRup, rjb,
     1                     vs30, srcSiteA, dtor, gnd, sigma1, 
     2                     ipera(ip), period1 )
c gnd is lnSA in AS code. need to fill in some other input. esp. aspectratio.
c period1 is output by AS_modelXX. period1 should equal per(ip)
	sigmaf=1./sqrt2/sigma1
	elseif(iatten(ip,ia).eq.17)then
	call getIdriss(iper(ip),xmag,rjb,vs30,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.18)then
c new nov 7,2006. Kanno
	call kanno(iperk(ip),gnd,sigmaf,xmag,rrup,vsfac)
	endif
	elseif(wus02(ip,ia))then
c WUS pre-nga (2002 atten models)
	if(iatten(ip,ia).eq.1)then
	call getSpu2000(iq,xmag,rjb,vs30,gnd,sigmaf)
	elseif(iatten(ip,ia).eq.3)then
	call getsadigh(iq,xmag,rrup,gnd,sigmaf,
     1 sigmanf,distnf)
	elseif(iatten(ip,ia).eq.8)then
	call getAS97(iq,xmag,rrup,sigmanf,distnf,hwsite,gnd,sigmaf)
       elseif(iatten(ip,ia).eq.9)then
       call getCamp2003(iq,xmag,rrup,rjb,gnd,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.11)then
	call getBJF97(iq,xmag,rjb,vs30,gnd,sigmaf)
	endif
	elseif(ceus02(ip,ia))then
c CEUS pre-nga (2002 atten models)
c
	if(iatten(ip,ia).eq.2)then
	call getToro(iq,1,xmag,rjb,gnd,sigma,sigmaf,
     1 sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-2)then
	call getToro(iq,2,xmag,rjb,gnd,sigma,sigmaf,
     1 sigmanf,distnf)
        elseif(iatten(ip,ia).eq.4)then
        call getAB06(iperab(ip),1,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf,vs30)
        elseif(iatten(ip,ia).eq.-4)then
        call getAB06(iperab(ip),2,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf,vs30)
        elseif(iatten(ip,ia).eq.19)then
	call getTP05(ipertp(ip),irtb,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.5)then	!to distinguish ab95 from fea
	call getFEA(iq,2,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-5)then	!HR for atkinson-boore
	call getFEA(iq,4,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.6)then
	call getFEA(iq,1,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.-6)then	!hr
	call getFEA(iq,3,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	elseif(iatten(ip,ia).eq.7) then
        call getSomer(iq,1,xmag,rrup,sigmanf,distnf,gnd,sigma,sigmaf)
	elseif(iatten(ip,ia).eq.-7) then
        call getSomer(iq,2,xmag,rrup,sigmanf,distnf,gnd,sigma,sigmaf)
       	elseif(iatten(ip,ia).eq.10)then
        call getCampCEUS(iq,1,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
       	elseif(iatten(ip,ia).eq.-10)then
        call getCampCEUS(iq,2,xmag,rrup,gnd,sigma,sigmaf,sigmanf,distnf)
	endif
c This is a good place to apply the extra clamp constraint which
c in 2002 was used only for CEUS sources. The precomputed p() matrix does
c not work for this case because truncation is no longer at mu+3sig
	test0=gnd+3.*sigma
      test= exp(test0)
      if(clamp(iq).lt.test .and. clamp(iq).gt.0.) then
      clamp2= alog(clamp(iq))
      sigmasq=1./sigma/sqrt2
      tempgt3= (gnd- clamp2)*sigmasq
      probgt3= (erf(tempgt3)+1.)*0.5
      do k=1,nlev(ip)
      temp= (gnd- xlev(k,ip))*sigmasq
      temp1= (erf(temp)+1.)*0.5
      temp1= (temp1-probgt3)/(1.-probgt3)
      if(temp1.lt.0.) goto 3203	!no more calcs once p<0
        prob(icnt,k,ip)= prob(icnt,k,ip)+ 
     &         weight*rate*temp1
  	enddo	!k=1,nlev
  	goto 3203
  	endif
	elseif(iatten(ip,ia).eq.12)then
	call getMota(iper(ip),xmag,rrup,vs30,gnd,sigmaf)
	endif
        do  k=1,nlev(ip)
	 pr=(gnd - xlev(k,ip))*sigmaf
	 if(pr.gt.3.3)then
	 ipr=250002
	 elseif(pr.gt.plim)then
	 ipr= 1+nint(dp2*(pr-plim))	!3sigma cutoff n'(mu,sig)
	 else
	 goto 3203	!transfer out if ground motion above mu+3sigma
	 endif
        prob(icnt,k,ip)= prob(icnt,k,ip)+weight*rate*p(ipr)
	enddo
 3203   continue
	enddo	!period set
	enddo	!imag set
c        go to 850	!superfluous
        endif
ccccccccccccccccccc
 850  continue
c--- write output files every 1000 sites
 860    continue
 	 if(grid.and.((icnt.eq.1000).or.(i.eq.nrec))) then
      write(6,*) i,prob(icnt,1,1)
        iend= 1000
        if(i.eq.nrec) iend=icnt
        do 115 ip=1,nper
        ndata= iend*nlev(ip)
        do 50 ii=1,ndata
        i2= ii-1
        irec= i2/nlev(ip)
        ilev= i2-irec*nlev(ip)
        irec= irec+1
        ilev= ilev+1
        out(ii)= prob(irec,ilev,ip)
   50   continue
        call putbufx(ifp(ip),out,ndata,readn)
        readn= readn/4
c        write(6,*) ndata,readn
 115    continue
        icnt= 0
        do 230 ii=1,1000
        do 230 ip=1,nper
        do 230 k=1,nlev(ip)
 230    prob(ii,k,ip)= 0.1e-20	!convenient to start with nonzero for logging
 	elseif(.not.grid)then
67	format(/,'#Station ',f7.4,1x,f10.4,1x,a,' vs30 ',f6.1) 	
      do 615 ip=1,nper
 	write(9+ip,67)slat(i),slong(i),sname(i),vs30
      write(9+ip,69) period(ip), nlev(ip)

69	format('#',f9.2,1x,i2)
      do 614 k=1,nlev(ip)

      write(9+ip,612) ylev(k,ip), prob(i,k,ip)
 612	format(f10.6,1x,e11.5) 
 614  continue
 615  continue
c 	write(10,68)sname(i)
c 68	format('#End station for ',a,/)	
        endif
  100 icnt= icnt+1
      dum=dtime(tarray)
 	if(slist)then
 	do ip=1,nper
 	close(9+ip)
 	enddo
 	print *,'An ascii file was written for each period in input'
 	do i=1,nrec
 	close(30+i)
 	enddo
 	print *,'A file of eqrates was written for each station'
 	endif
       write(*,*)tarray(1),' s = time to complete hazFXnga7'
      end
c
      subroutine delaz(sorlat,sorlon,stnlat,stnlon,delta,az,baz)
      parameter (coef= 3.1415926/180.)
      xlat= sorlat*coef
      xlon= sorlon*coef
      st0= cos(xlat)
      ct0= sin(xlat) 
      phi0= xlon
      xlat= stnlat*coef
      xlon= stnlon*coef
      ct1= sin(xlat)
      st1= cos(xlat)
      sdlon= sin(xlon-phi0)
      cdlon= cos(xlon-phi0)
      cdelt= st0*st1*cdlon+ct0*ct1
      x= st0*ct1-st1*ct0*cdlon
      y= st1*sdlon
      sdelt= sqrt(x*x+y*y)
      delta= atan2(sdelt,cdelt)
      delta= delta/coef
      az= atan2(y,x)
      az= az/coef
      x= st1*ct0-st0*ct1*cdlon
      y= -sdlon*st0
      baz= atan2(y,x)
      baz= baz/coef
      delta= delta*111.2
      return
      end         

      subroutine back(delta0,az,sorlat,sorlon,stnlat,stnlon)
      parameter (coef= 3.1415926/180.)
      delta= delta0/111.11
      delta= delta*coef
      sdelt= sin(delta)
      cdelt= cos(delta)
      xlat= sorlat*coef
      xlon= sorlon*coef
      az2= az*coef
      st0= cos(xlat)
      ct0= sin(xlat)
      phi0= xlon
      cz0= cos(az2)
      ct1= st0*sdelt*cz0+ct0*cdelt
      x= st0*cdelt-ct0*sdelt*cz0
      y= sdelt*sin(az2)
      st1= sqrt(x*x+y*y)
      dlon= atan2(y,x)
      stnlat= atan2(ct1,st1)
      stnlat= stnlat/coef
      stnlon= phi0+dlon
      stnlon= stnlon/coef
      return
      end

      subroutine gettab(gma,f,xmag,rlog)
c      gets corresponding log PSA values (cm/s**2) from interpolation
c      of file ab94.tab.
      dimension xmag(20),gma(22,30,20), rlog(30), f(20)
      character*60 header
c      Written by G.M. Atkinson, Jan. 1994
C----  modified by A. Frankel 10/95
c
c     Read AB94 simulated grd. motion table.
      open(3,file='ab94.tab',status='old')
 900  format(i2)
      do 20 j = 1, 5

        read(3,10)header
        read(3,900) idum

10      format(a)
20    continue
      nf = 11
      nmag = 14

      nd = 18

      jdl = 0

      do 30 jf = 1, nf-2

        f(jf) = 10.**(-0.3 + float(jf-1)*0.2)

30    continue

      f(nf) = 89.

      f(nf-1) = 99.
      do 50 jm = 1, nmag
        read(3,900) idum
        read(3,900) idum
        read(3,35)xmag(jm)

35      format(13x,f5.2)
        read(3,900) idum

        read(3,45)
        read(3,900) idum
        read(3,45)
        read(3,900) idum

        do 40 jd = 1, nd

          read(3,45)rlog(jd),(gma(jf,jd,jm), jf = 1,nf)

          read(3,900) idum
45        format(f6.2,2x,11f6.2)

40      continue

50    continue
      close(3)
c      write(6,*) gma(1,1,1)
      return
      end

c***************************************************************
c*****************************************************************

      subroutine table(gma,amag,R,freq,amean,f,xmag,rlog)
      dimension xmag(20),gma(22,30,20), rlog(30), f(20)
      dimension avg(20)
c     Use interpolation to get amean for given freq(jfreq), amag, R.
c
      nf= 11
      nmag= 14
      nd= 18

      rl = alog10(R)

      jfl = 0

c     Find bounding jf values.

      do 10 j = 1,nf-3

        if (freq .ge. f(j) .and. freq .lt. f(j+1))jfl = j

10    continue

      if (abs(freq-f(1)) .lt. 0.01) jfl = 1

      if (abs(freq-f(nf)) .lt. 0.01) jfl = nf

      if (abs(freq-f(nf-1)) .lt. 0.01) jfl = nf-1

      if (abs(freq-20.) .lt. 0.01)  jfl = nf-2

      if (jfl .eq. 0) write(6,*) ' ERROR. FREQ. OUTSIDE RANGE.'

      if (freq .gt. 20. .and. freq .lt. 89.)

     *   write(6,*)' ERROR. FREQ. OUTSIDE RANGE'

      jfu = jfl + 1

      fracf = 0.

      if (freq .ge. 20.) go to 15

      fracf = (alog10 (freq) - alog10 (f(jfl)) ) /

     *        (alog10 (f(jfu)) - alog10 (f(jfl)) )

15    continue

c     Find bounding jm values.

      jml = 0

      do 20 j = 1, nmag-1

         if (amag .ge. xmag(j) .and. amag .lt. xmag(j+1)) jml = j

20    continue

      if (amag .eq. xmag(nmag)) jml = nmag

      if (jml .eq. 0) write(6,*)' ERROR. MAGNITUDE OUTSIDE RANGE.'

      jmu = jml + 1

      fracm = (amag - xmag(jml)) / (xmag(jmu)-xmag(jml))

c     find bounding distance values.
      jdl= 0

      do 30 j = 1, nd-1

        if (rl .ge. rlog(j) .and. rl .lt. rlog(j+1)) jdl= j

30    continue

      if (rl .eq. rlog(nd)) jdl = nd

      if (jdl .eq. 0) write(6,*)' ERROR. DISTANCE OUTSIDE RANGE.'

      jdu = jdl + 1

      fracd = (rl - rlog(jdl)) / (rlog(jdu)-rlog(jdl))

      do 40 j = jfl, jfu

        arl = gma(j,jdl,jml) + fracm * (gma(j,jdl,jmu)-gma(j,jdl,jml))

        aru = gma(j,jdu,jml) + fracm * (gma(j,jdu,jmu)-gma(j,jdu,jml))

c       arl is the amplitude for lower dist. bound, so arl>aru

        avg(j) = arl - fracd*(arl-aru)

40    continue

      amean = avg(jfl) + fracf * (avg(jfu) - avg(jfl))

      return

      end

cccccccccccccccccccccccccccccc
      subroutine getSpu2000(iq,xmag,dist0,vs30,gnd,sigmaf)
c commandeered by Spudich ea. from BJF93 of "hazFXv3" etc.
c To distinguish from BJF97. 7 periods.
c Inputs:
c iq is the index of the current period, see perx(iq)
c dist0 is Rjb
c xmag = M or moment magnitude
c vs30 = site Vs top 30 m
c Outputs gnd = ln(median motion,g)
c	  sigmaf = 1/sigma/sqrt2  where sigma is dispersion natural log
c
c adapted to nga july 26 2006.SH
	parameter (sqrt2=1.414213562, pi=3.141592654,np=7,aln10=2.30258509)
	parameter (vref=760.)
c spudich coeffs...
      real magmin,perx(8)
c spudich coeffs...
c site amp: for now use that of BJF97. THis should be reviewed July26 2006.
	real bv(np),va(np)
        real b1(np),b2(np),b3(np),b4(np),b5(np),h(np),sigma(np)
c array constructors OCT 2006. No coeffs corresponding to PGV, perx(8)
        perx=(/0.,0.2,1.0,0.1,0.3,0.5,2.0,-1./)
        bv = (/-.371,-.292,-.698,-.212,-.401,-.553,-.655 /)
        va = (/1396.,2118.,1406.,1112.,2133.,1816.,1795. /)
        b1 = (/0.299,2.224,2.276,2.144,2.263, 2.292, 2.168/)           
        b2 = (/ 0.229, 0.309, 0.450,0.327, 0.334,0.384,0.471/)
        b3 = (/0., -0.090,-.014,-0.098,-0.070,-0.039, -0.037/)
        b4 = (/ 0., 0.,0.,0.0,0.,0.,0.0/)
        b5 =(/-1.052,-1.047,-1.083,-1.250,-1.020,-1.038,-1.049/)
        h = (/7.27,8.63, 6.01,9.99,7.72,6.70, 6.71/)
         sigma= (/0.225,0.262,0.301,0.295,0.263 ,0.275,0.341/)
          sigmaf = 1./(sigma(iq)*aln10*sqrt2)
c site amp from BJF97. THis will need review. Placeholder july 27 2006.
	period=perx(iq)
       dist= sqrt(dist0*dist0+h(iq)**2)
          gnd=  b1(iq) +b2(iq)*(xmag-6.) +b3(iq)*(xmag-6.)**2
          gnd= gnd + b5(iq)*alog10(dist)	!+ b4(iq)*dist nuisance is 0
c--- convert from psv in cm/sec to psa in g
          if(period.ne.0.) gnd=gnd+alog10(2.*pi/(980.*period))
c bse 10 to base e
c site amp is last term because it is a natural log term. 
c Not too useful when soil siteamp has known nonlinear response.
          gnd= gnd *aln10 +bv(iq)*alog(vs30/vref)
      return
      end

cccccccccccccccc
      subroutine getToro(ip,ir,xmag0,dist0,gnd,sigma,sigmaf,sigmanf,distnf)
c midcontinent w/moment mag. Adapted to NGA code SH June 2006. 7 periods used in2002.
c ip = index in perx() array, 
c ir=1 use BC rock; ir=2 use hardrock model.
c Hard-rock in tc1h, otherwise same regression model & coeffs.
c dist0 is rjb (km). Eqn 4 SRL converts to "R_M".
c median motions are capped. Max motions are not really constrained here.
c Warning: Clamp business will have to be done in main.
c replaced data statements with array constructors oct 2006.
        parameter (sqrt2=1.414213562, pi=3.141592654)
       	real, dimension(7):: tc1,tc2,tc3,tc4,tc5,tc6
	real, dimension(7):: tc1h,th,tsigma,clamp
     	real   perx(8) 
c array constructors
       perx = (/0.,0.2,1.0,0.1,0.3,0.5,2.0,-1./)
	tc1 = (/2.619,2.295,0.383,2.92,1.8823,1.288,-0.558/)
	tc1h = (/2.20,1.73,0.09,2.50,1.462,0.868,-0.978/)	
	tc2 = (/0.81,0.84,1.42,0.81,0.964,1.14,1.86/)
	tc3 = (/0.,0.0,-0.2,0.,-0.059,-0.1244,-0.31/)
	tc4 = (/1.27,0.98,0.90,1.1,0.951,0.9227,0.92/)
	tc5 = (/1.16,0.66,0.49,1.02,0.601,0.5429,0.46/)
	tc6 = (/0.0021,0.0042,0.0023,0.004,0.00367,0.00306,0.0017/)
	
     	th = (/9.3,7.5,6.8,8.3,7.26,7.027,6.9/)
c write sigma in nat log units. Saves a divide
     	tsigma = (/0.7506,0.7506,0.799,.7506,.7506,.7506,0.799/)	
     	clamp = (/3.,6.,4.,6.,6.,6.,6./)
        xmag= xmag0
c correct mag will be used in calling program. never need to convert here.
c        if(iconv(ip,ia).eq.1) xmag= 2.715 -0.277*xmag0+0.127*xmag0*xmag0
          sigma= tsigma(ip)
          if(dist0.lt.distnf) sigma= sigma+ sigmanf
          sigmaf= 1./sigma/sqrt2
        cor = exp(-1.25 + 0.227*xmag)
c        dist= sqrt(dist0*dist0+th(ip)*th(ip))
c Modified Toro for finite-fault Oliver. Nov 2006.
          dist= sqrt(dist0*dist0+th(ip)*th(ip)*cor*cor)
	if(ir.eq.1)then
c firm rock const coeff.
          gnd= tc1(ip)
          else
c hard rock. Could have other possibilities as well. For now default to h.r.
          gnd=tc1h(ip)
          endif
          gnd=gnd+tc2(ip)*(xmag-6.)+ tc3(ip)*((xmag-6.)**2)
          gnd= gnd-tc4(ip)*alog(dist)-tc6(ip)*dist
          factor= alog(dist/100.)
          if(factor.gt.0.) gnd= gnd-(tc5(ip)-tc4(ip))*factor
c---following is for clipping gnd motions: 1.5g PGA, 3.0g for rest 
          if(ip.eq.1.or.ip.eq.7) then
c for long period I also put the PGA  limit (g). SH June 2006.
           gnd=min(gnd,0.405)
          else
           gnd=min(1.099,gnd)
          endif
c clamp applied in main if needed.
      return
      end

cccccccccccccccccc
	subroutine getsadigh(iq,xmag,rrup,gnd,sigmaf,
     1 sigmanf,distnf)
c modified to perform like nga functions. SH June 2 2006 workin progress...
c iq is the index of perx() associated with period being run with index ip in main
c we are not using sigmanf or distnf at this time...
        parameter (sqrt2=1.414213562,rockcoef=0.240336)
c Rock-site coefs only, written below for 7 periods. How fast is that rock?
c walt silva says about 500 m/s (NGA discussion hot topic)
c replaced data statements with array constructors oct 2006.
	real sc1(7),sc2(7),sc3(7),sc4(7),sc5(7),sc6(7),perx(7)
	real sd1(7),sd2(7),sd3(7),sd4(7),sd5(7),sd6(7),sd7(7)	
	real ssigma1(7),ssigma2(7),ssigmacoef(7),smagsig(7)
        common/mech/ss,rev,normal,obl
        common/dipinf/dipang,cdipsq
        logical ss,rev,normal,obl
c prepared for 7 periods jun 22 2006. gnd is modified
c for sense-of-slip  from common/mech/ 
	real sh(7)/7*5./
	real sthrust(7)/7*.1823/
	sc1 = (/-.5328,.2442,-1.6138,0.2750,-0.057,-0.5880,-2.945/)
	sc2 = (/1.0,1.,1.,1.,1.,1.,1./)
	sc3 = (/0.0,-0.004,-0.055,0.006,-0.017,-0.04,-0.07/)
	sc4 = (/-2.1,-2.08,-1.8,-2.148,-2.028,-1.945,-1.67/)
	sc5 = (/1.29649,1.29649,1.29649,1.29649,1.29649,1.29649,1.29649/)
	sc6 = (/0.25,.25,.25,.25,.25,.25,.25/)
	perx = (/0.0,0.2,1.0,0.1,0.3,0.5,2.0/)
	sd1 = (/-1.1828,-.4058,-2.2638,-0.375,-0.707,-1.238,-3.595/)
	sd2 = (/1.1,1.1,1.1,1.1,1.1,1.1,1.1/)
	sd3 = (/0.,-.004,-0.055,0.006,-0.071,-0.040,-0.07/)
	sd4 = (/-2.1,-2.08,-1.8,-2.148,-2.028,-1.945,-1.67/)
	sd5 = (/-.48451,-.48451, -.48451,-.48451,-.48451, -.48451,-.48451/)
	sd6 = (/.524,.524,.524,.524,0.524,.524,.524/)
	sd7 = (/0.,0.,0.,-0.041,0.,0.,0./)
	ssigma1 = (/1.39,1.43,1.53,1.41,1.45,1.5,1.53/)
	ssigmacoef = (/0.14,0.14,0.14,0.14,0.14,0.14,0.14/)
	ssigma2 = (/0.38,0.42,0.52,0.4,0.44,0.49,0.52/)
	smagsig = (/7.21,7.21,7.21,7.21,7.21,7.21,7.21/)
        xmag0=xmag
c        if(iconv(ip,ia).eq.1) xmag= 2.715 -0.277*xmag0+0.127*xmag0*xmag0
          if(xmag.lt.smagsig(iq))then
           sig= ssigma1(iq)- ssigmacoef(iq)*xmag
          else
           sig= ssigma2(iq)
           endif
          if(rrup.lt.distnf) sig= sig+ sigmanf
          sigmaf= 1./(sig*sqrt2)
          dist= sqrt(rrup*rrup + sh(iq)**2)
          if(xmag.lt.6.5) then
	gnd= sc1(iq)+sc2(iq)*xmag+sc3(iq)*((8.5-xmag)**2.5)
	gnd= gnd+ sc4(iq)*alog(dist+ exp(sc5(iq)+sc6(iq)*xmag))
           else
	gnd= sd1(iq)+sd2(iq)*xmag+sd3(iq)*((8.5-xmag)**2.5)
	gnd= gnd+ sd4(iq)*alog(dist+ exp(sd5(iq)+sd6(iq)*xmag))
	if(rev)gnd=gnd + sthrust(iq)
            endif
          if(sd7(iq).ne.0.)gnd= gnd+sd7(iq)*alog(dist0+2.)
      return
      end

c getCamp removed: no longer used. Replace with getCamp2003

      subroutine getAB95(ip,iq,ia,ndist,di,nmag,sigmanf,distnf)
c this subroutine has not been fully modified. Should never be needed.
c replaced data statements with array constructors oct 2006.
        parameter (np=7,sqrt2i=0.707106781)
              dimension gma(22,30,20),amag(20),rlog(20),f(20)
	real ab1(np),absigma(np)
c	ab1/7*1/	!temp
c	absigma/7*0.5/	!temp
       	real perx(8)	!a reference set including pgv which wasn't used in 2002
      perx= (/0.,0.2,1.0,0.1,0.3,0.5,2.0,-1./)
c         write(6,*) "enter bcfac, coeficients, depth, sigma"
c        read(1,*) bcfac, ab1,ab2,ab3,ab4,
c     &            abdepth,absigma,clamp
         call gettab(gma,f,amag,rlog)
c set up erf matrix p as ftn of dist,mag,period,level,flt type,atten type
c--- Mmin=6.0 nmag=45 dmag=0.05
c-- loop through distances
c-- gnd for SS; gnd2 for thrust; gnd3 for normal
        xmag= xmag0
c--- following for Atkinson and Boore (95) look-up table
c        if(iconv(ip,ia).eq.1) xmag= 2.715 -0.277*xmag0+0.127*xmag0*xmag0
          sigma= absigma(ip)/0.4343
          if(dist0.lt.distnf) sigma= sigma+ sigmanf
c          sigmasq= sigma*sqrt(2.)
cccccccccc  if fault depth0 term ne 0 then this depth term not needed
c          dist= sqrt(dist0*dist0+ abdepth*abdepth)
          if(dist.lt.10.) dist=10.
          if(period.gt.0.) freq=1./period
          if(period.eq.0.) freq= 99.
c---------if M> 7.25 use quadratic formula
          if((xmag.gt.7.25).or.(dist.gt.501.)) then
             gnd= ab1(ip)+ab2*(xmag-6.)+ab3*((xmag-6)**2)
     &            -alog10(dist)- ab4*dist
             go to 402
             endif
          call table(gma,xmag,dist,freq,gnd,f,amag,rlog)
cc- convert to fraction of g
  402     fac= -alog10(980.)
          gnd= gnd+fac + alog10(bcfac)
          gnd= gnd/0.4343
c----------- clipping
          if((period.eq.0.).and.(gnd.gt.0.405)) gnd=0.405
          if((period.eq.0.3).and.(gnd.gt.1.099)) gnd=1.099
          if((period.eq.0.2).and.(gnd.gt.1.099)) gnd=1.099
          if((period.eq.0.1).and.(gnd.gt.1.099)) gnd=1.099
          if((period.eq.0.5).and.(gnd.gt.1.099)) gnd=1.099
          gnd2= gnd
          gnd3= gnd
          t0=gnd + 3.*sigma
      test= exp(t0)	!units g
      if((clamp.lt.test).and.(clamp.gt.0.))then
       clamp2= alog(clamp)
      else
       clamp2= t0
       endif
      tempgt3= (gnd- clamp2)/sigmasq
      probgt3= (erf(tempgt3)+1.)*0.5
  103 continue
      return
      end


	subroutine getFEAtab(ip,iq)
c  hardrock and   BC rock tables can be read in here.
c 
c replaced data statements with array constructors oct 2006.
	parameter (np=7)
	real gma(20,21,4*np),tabdist(21,4)
	logical isok
	common/gmat/gma,tabdist
	character*30 nametab(np),nameab(np),hardtab(np),hardab(np)
	character*4 adum
c assumes these files are in working directory or GR/ sub-directory.
      nametab=(/'pgak01l.tbl ','t0p2k01l.tbl','t1p0k01l.tbl',
     1 't0p1k01l.tbl','t0p3k01l.tbl','t0p5k01l.tbl','t2p0k01l.tbl'/)
	nameab=(/'Abbc_pga.tbl','Abbc0p20.tbl','Abbc1p00.tbl',
     1 'Abbc0p10.tbl','Abbc0p30.tbl','Abbc0p50.tbl','Abbc2p00.tbl'/)
       hardtab=(/'pgak006.tbl ','t0p2k006.tbl','t1p0k006.tbl',
     1 't0p1k006.tbl','t0p3k006.tbl','t0p5k006.tbl','t2p0k006.tbl'/)
	hardab=(/'ABHR_PGA.TBL','ABHR0P20.TBL','ABHR1P00.TBL',
     1'ABHR0P10.TBL','ABHR0P30.TBL','ABHR0P50.TBL','ABHR2P00.TBL'/)
	if(iq.eq.1)then		!fea BCtable
	inquire(file=nametab(ip),exist=isok)
	if(.not.isok)then
c look in GR subdirectory if not in working dir
	nametab(ip)='GR/'//nametab(ip)
	inquire(file=nametab(ip),exist=isok)
	if(.not.isok)goto 20
	endif
         open(unit=15,file=nametab(ip),status='old')
         ipq=ip
         elseif(iq.eq.2)then	!ab BC table
	inquire(file=nameab(ip),exist=isok)
	if(.not.isok)then
c look in GR subdirectory if not in working dir
	nameab(ip)='GR/'//nameab(ip)
	inquire(file=nameab(ip),exist=isok)
	if(.not.isok)goto 21
	endif
         open(unit=15,file=nameab(ip),status='old')
         ipq=ip+np
         elseif(iq.eq.3)then	!fea A table
	inquire(file=hardtab(ip),exist=isok)
	if(.not.isok)then
c look in GR subdirectory if not in working dir
	hardtab(ip)='GR/'//hardtab(ip)
	inquire(file=hardtab(ip),exist=isok)
	if(.not.isok)goto 23
	endif
         open(unit=15,file=hardtab(ip),status='old')
         ipq=ip+np+np
         elseif(iq.eq.4)then	!ab A table
	inquire(file=hardab(ip),exist=isok)
	if(.not.isok)then
c look in GR subdirectory if not in working dir
	hardab(ip)='GR/'//hardab(ip)
	inquire(file=hardab(ip),exist=isok)
	if(.not.isok)goto 24
	endif
         open(unit=15,file=hardab(ip),status='old')
         ipq=ip+np*3
         endif
         read(15,900) adum
900	format(a)
         do 80 idist=1,21
   80    read(15,*) tabdist(idist,iq),(gma(imag,idist,ipq),imag=1,20)
         close(15)
	return
20	print *,'getFEAtab open failed for ',nametab(ip)
	stop 'hazFXnga7: put in working dir or rewrite program'
21	print *,'getFEAtab  open failed for ',nameab(ip)
	stop 'hazFXnga7: put in working dir or rewrite program'
23	print *,'getFEAtab  open failed for ',hardtab(ip)
	stop 'hazFXnga7: put in working dir or rewrite program'
24	print *,'getFEAtab  open failed for ',hardab(ip)
	stop 'hazFXnga7: put in working dir or rewrite program'
	end

ccccccccccccccccccccccc
      subroutine getFEA(ip,iq,xmag,dist0,gnd,sigma,sigmaf,sigmanf,distnf)
c table info is available, from common/gmat/. See getFEAtab.
c this routine should work for finite CEUS faults. What if 0 depth suchas meers?
c four tables are set up and good to go as of july 28 2006.
c if iq = 1 use feaBC. if  iq=2, use ab95 BC table. 
c if iq = 3 fea A rock, and iq=4, ab95 A rock table.
c primary outputs:
c gnd=log median motion
c sigma = logarthmic s.d.
c sigmaf = 1/sigma/sqrt(2)
c inputs:
c ip=period index in perx() below. This controls which period coeffs are used
c iq=table index used with ip for table lookup
c xmag= moment mag (only)
c dist0= hypo distance used in getfea
c sigmanf, distnf = nearfield sigma apply when distance < distnf (not used 2002)
c replaced data statements with array constructors oct 2006.
c
        parameter (np=7,sqrt2i=0.707106781)
	common/gmat/gma,tabdist
	real bdepth(7),bsigma(7),clamp(7),xlogfac(7)
	real gma(20,21,4*np),tabdist(21,4)
       	real perx(8)	!a reference set including pgv which wasn't used in 2002
        perx= (/0.,0.2,1.0,0.1,0.3,0.5,2.0,-1./ )
     	bdepth= (/5.0,5.0,5.0,5.0,5.0,5.0,5.0/)
     	bsigma= (/0.7506,0.7506,0.799,0.7506,0.7506,.7506,0.799/)	!converted to nat log
     	clamp=(/3.,6.,6.,5.,6.,5.,5./)
c     	xlogfac/7*0./
c---- following for  FEA or Atkinson-Boore look-up table
	ipq=ip+np*(iq-1)
c        if(iconv(ip,ia).eq.1) xmag= 2.715 -0.277*xmag0+0.127*xmag0*xmag0
          sigma= bsigma(ip)	!in correct log base already
          if(dist0.lt.distnf) sigma= sigma+ sigmanf
          sigmaf= sqrt2i/sigma
          dist= dist0
ccccccccc if fault depth0 ne 0. then this depth term not needed 
c          dist= sqrt(dist0*dist0+bdepth*bdepth)
          if(dist.lt.10.) dist=10.
          imag= (xmag-4.4)/0.2 +1
          rdist= alog10(dist)
          idist= (rdist-tabdist(1,iq))/0.1 + 1
          xm1= (imag-1)*0.2 + 4.4
          fracm= (xmag-xm1)/0.2
          xd1= (idist-1)*0.1 +tabdist(1,iq)
          fracd= (rdist-xd1)/0.1
          idist1= idist+1
          if(idist.gt.21) idist=21
          if(idist1.gt.21) idist1=21
          gm1= gma(imag,idist,ipq)
          gm2= gma(imag+1,idist,ipq)
          gm3= gma(imag,idist1,ipq)
          gm4= gma(imag+1,idist1,ipq)
          arl= gm1 + fracm*(gm2-gm1)
          aru= gm3 + fracm*(gm4-gm3)
          gnd= arl +fracd*(aru-arl)
c          gnd= gnd+ xlogfac	!nuisance. is 0
          gnd= gnd/0.4343
c          if(dist0.gt.950.) then
c            taper= (1001.-dist)/50.
c            if(taper.le.0.01) taper=.01
c            taper= log(taper)
c            gnd=gnd+taper
c            endif
c--- following is for clipping 
          if(ip.eq.1)then
c pga has index ip=1
           gnd=min(0.405,gnd)
           elseif(ip.ne.3)then
c 1s SA haz index 3. 2s has period index 7 and median should be controlled
           gnd=min(gnd,1.099)
           endif
c      test= exp(gnd + 3.*sigmasq/sqrt(2.))
c      if((clamp.lt.test).and.(clamp.gt.0.)) clamp2= alog(clamp)
c      if(clamp.ge.test) clamp2= gnd+ 3.*sigmasq/sqrt(2.)
c      if(clamp.eq.0.) clamp2= gnd+ 3.*sigmasq/sqrt(2.)
c      tempgt3= (gnd- clamp2)/sigmasq
c      probgt3= (erf(tempgt3)+1.)/2.
  103 continue
      return
      end

ccccccccccccccccccccccccc
      subroutine getSomer(ip,ir,xmag0,dist0,sigmanf,distnf,gnd,sig,sigmaf)
c---- Somerville et al. (2001) for CEUS
c input dist0 (km) and xmag0 (moment mag) 
c Input ir to control rock conditions:
c ip = index in period array that is currently of interest, ip=1 => PGA for example
c ir=1 BC or firm rock
c ir=2 hard rock (2800 m/s?)
c output gnd=log(median) and sigmaf=1/sigma/sqrt2
c replaced data statements with array constructors oct 2006.
c
	parameter(dist1=50.358713,sqrt2=1.41421356)
c      dist1= sqrt(50.*50.+ 6.*6.) in above parameter statement
	real a1(7),a2(7),a3(7),a4(7),a5(7),a6(7),a7(7),sig0(7)
c enter statements with coeff values.
       	real perx(8),a1h(7)	!a reference set including pgv which wasn't used in 2002
      perx = (/0.,0.2,1.0,0.1,0.3,0.5,2.0,-1./)
      a1 = (/0.658,1.358,-0.0143,1.442,1.2353,0.8532,-0.9497/)
	a1h = (/0.239,0.793,-0.307,0.888,0.6930,0.8313,-1.132/)
      a2 = (/0.805,0.805,0.805,0.805,0.805,0.805,0.805/)
      a3 = (/-0.679,-.679,-.696,-.679,-.67023,-.671792,-0.728/)
      a4 = (/0.0861,0.0861,.0861,.0861,0.0861,.0861,.0861/)
      a5 = (/-0.00498,-.00498,-0.00362,-.00498,-.0048045,-.00442189,-0.00221/)
      a6 = (/-0.477,-.477,-0.755,-.477,-.523792,-.605213,-.946/)
      a7 = (/0.,0.,-0.102,0.,-.030298,-.0640237,-.140/)
      sig0 = (/0.587,0.611,0.693,0.595,.6057,.6242,0.824/)
c      clamp = (/3.,6.,3.,6.,6.,6.,6./)
c compute SOmerville median and dispersion estimates.
      sig= sig0(ip)
      if(dist0.lt.distnf) sig= sig0(ip)+ sigmanf
      sigmaf= 1/sig/sqrt2
      dist= sqrt(dist0*dist0+ 36.)
	if(ir.eq.1)then
	gnd=a1(ip)
	else
	gnd=a1h(ip)
c hard rock/firm rock variation in Somerville only affects a1 coef.
	endif	
      xmag= xmag0
c      if(iconv(ip,ia).eq.1) xmag= 2.715 -0.277*xmag0+0.127*xmag0*xmag0
      if(dist0.lt.50.) then
      gnd= gnd + a2(ip)*(xmag-6.4) + a3(ip)*alog(dist)
     1 +a4(ip)*(xmag-6.4)*alog(dist)
     2  + a5(ip)*dist0 + a7(ip)*(8.5-xmag)*(8.5-xmag)
        else
      gnd= gnd + a2(ip)*(xmag-6.4) + a3(ip)*alog(dist1)
     1 +a4(ip)*(xmag-6.4)*alog(dist)+a5(ip)*dist0
     2 + a6(ip)*(alog(dist)-alog(dist1))+a7(ip)*(8.5-xmag)*(8.5-xmag)
      endif
c      write(16,*) period,dist0,xmag,exp(gnd)
          if(ip.eq.1.or.ip.eq.7) then
c for long period I also put the PGA  limit (g). SH June 2006.
           gnd=min(gnd,0.405)
          else
           gnd=min(1.099,gnd)
          endif
c	clamp, if any, is applied in main.
  103 continue
      return
      end

ccccccccccccccccccccccccc
      subroutine getAS97(ip,xmag0,dist0,sigmanf,distnf,hwsite,gnd,sigmaf)
c modified for nga style, 7 periods, rock. SHarmsen June 2006.
c input xmag0=moment mag
c dist0 = r_cd or r_rup (km)
c sigmanf,distnf: near-field terms to modify s.d. 0 if none.
c hw = logical variable, true if site on hanging wall
c output:
c gnd,sigmaf
c replaced data statements with array constructors oct 2006.
        parameter (sqrt2=1.414213562)
	common/mech/ss,rev,normal,obl
	logical hw	!.true. if site on hanging wall established in calling pgm
	logical ss,rev,normal,obl
	real, dimension(7):: as1,as2,as3,as4,as5,as6
	real, dimension(7)::  as9,as12,as13,asc1,asc4,b5,b6
       	real perx(8)	!a reference set including pgv which wasn't used in 2002
        perx= (/0.,0.2,1.0,0.1,0.3,0.5,2.0,-1./)
	as1= (/1.64,2.406,0.828,2.16,2.114,1.615,-0.15/)
	as2= (/0.512,0.512,0.512,0.512,0.512,0.512,0.512/)
	as3= (/-1.145,-1.115,-0.8383,-1.145,-1.035,-0.9515,-0.725/)
	as4= (/-0.144,-0.144,-0.144,-0.144,-0.144,-0.144,-0.144/)
	as5= (/0.61,0.610,0.49,0.610,0.610,0.5810,0.40/)
	as6= (/0.26,0.26,0.013,0.26,0.198,0.119,-0.094/)
	as9= (/0.37,0.37,0.281,0.37,0.37,0.37,0.16/)
	as12= (/0.,-0.0138,-0.102,0.0280,-0.036,-0.0635,-0.14/)
	as13= (/0.17,0.17,0.17,0.17,0.17,0.17,0.17/)
	asc1= (/6.4,6.4,6.4,6.4,6.4,6.4,6.4/)
	asc4= (/5.6,5.1,3.7,5.5,4.8,4.3,3.5/)
	b5= (/0.70,0.77,0.83,0.74,0.78,0.8,0.85/)
	b6= (/0.135,0.135,0.118,0.135,0.135,0.13,0.105/)
c from 2003 input files: no correction (20% median redux?) for normal faults. Is this
c the current understanding?
c-- gnd for SS; gnd2 for thrust; gnd3 for normal
        xmag= xmag0
c        if(iconv(ip,ia).eq.1) xmag= 2.715 -0.277*xmag0+0.127*xmag0*xmag0
        if(xmag.lt.7.0)then
         sig= b5(ip)- b6(ip)*(xmag-5.0)
        else
         sig= b5(ip)- b6(ip)*2.0
         endif
        if(dist0.lt.distnf) sig= sig+ sigmanf
        sigmaf= 1./(sig*sqrt2)
          r= sqrt(dist0*dist0+ asc4(ip)*asc4(ip))
          if(xmag.le.asc1(ip)) then
          gnd= as1(ip)+as2(ip)*(xmag-asc1(ip))+as12(ip)*((8.5-xmag)**2)
     &         + (as3(ip)+ as13(ip)*(xmag-asc1(ip)))*alog(r)
          
          else 
          gnd= as1(ip)+as4(ip)*(xmag-asc1(ip))+as12(ip)*((8.5-xmag)**2)
     &         + (as3(ip)+ as13(ip)*(xmag-asc1(ip)))*alog(r)
          endif
          if(.not.rev)return	
c rest of calculations for reverse-slip sources
        if(xmag.le.5.8) then
          fltfac= as5(ip)
        elseif(xmag.lt.asc1(ip))then
           fltfac= as5(ip)
     &        +(as6(ip)-as5(ip))*(xmag-5.8)/(asc1(ip)-5.8)
        else
           fltfac= as6(ip)
        endif
          gnd= gnd+ fltfac
        if(.not.hw)return
c------- for hanging wall sites some additional increments of ground motion
           if(xmag.lt.6.5) then
             fac1= xmag-5.5
           else
              fac1= 1.
           endif
          if(dist0.le.4..or.dist0.gt.25.)return
          if(dist0.lt.8.)then
               fac2= as9(ip)*(dist0-4.)*0.25
          elseif(dist0.lt.18.)then
              fac2= as9(ip)
          else
               fac2= as9(ip)*(1.-(dist0-18.)/7.)
          endif
             gnd= gnd+ fac1*fac2
c      write(14,*) period,dist0,xmag,exp(gnd)
      return
      end

ccccccccccccccccccccccccccccc
      subroutine getCamp2003(ip,xmag,dist,rjb,gnd,sigmaf,sigmanf,distnf)
c  Campbell and Bozorgnia (2003). modifying for nga style. Input rock coeffs.
c Later, add soil coeffs?
c Hangingwall indicated by relation between dist and rjb (both input)
c Coeffs written but not checked july 27 2006. SH
        parameter (sqrt2=1.414213562)
	common/mech/ss,rev,normal,obl
	logical ss,rev,normal,obl	
	common/dipinf/dipang,cosDELTA,cdipsq,cyhwfac,cbhwfac
      real, dimension(7):: c1,c2,c3,c4,c5,c6,c7,c8,c9,cmagsig
      real, dimension(7):: csigma1,csigmacoef,csigma2,c10,c11,csite,c15
      real mfac
	c1= (/-4.033,-2.771,-3.867,-2.661,-2.999,-3.556,-4.311/)
	c2= (/0.812,0.812,0.812, 0.812,0.812,0.812,0.812/)
	c3= (/0.036,0.030,-.101,0.060,.007,-0.035,-0.180/)
	c4= (/ -1.061,-1.153,-.964,-1.308,-1.080,-0.964,-0.964/)
	c5= (/0.041,0.098,0.019,0.166,0.059,0.023,0.019/)
	c6= (/-0.005,-0.014,0.,-0.009,-0.007,-0.002,0./)
	c7= (/-.018,-0.038,0.,-0.068,-0.022,-0.004,0./)
	c8= (/0.766,0.704,0.842,0.621,0.752,0.842,0.842/)
	c9= (/0.034,0.026,-.105,0.046,0.007,-0.036,-0.187/)
	c10= (/0.343,0.296,0.329,0.224,0.359,0.406,0.060/)
	c11= (/0.351,0.342,0.338,0.313,0.385,0.479,0.064/)
	c15= (/.370,.370,0.281,0.370,0.370,0.370,0.160/)	!HW effect.
	csite= (/-0.289,-0.331,-0.607,-0.299,-0.453,-0.528,-0.649/)	!is this a vs30-dependent term?
	csigma1= (/0.920,0.981,1.021,0.958,0.984,0.990,1.021/)
	csigmacoef= (/0.07, 0.07,0.07,0.07, 0.07,0.07,0.07/)
	csigma2= (/.402,0.463,0.503,0.44,0.466,0.472,0.503/)
	cmagsig= (/ 7.4,7.4,7.4,7.4,7.4,7.4,7.4/)
      mfac=(8.5-xmag)*(8.5-xmag)
c
c        if(iconv(ip,ia).eq.1) xmag= 2.715 -0.277*xmag0+0.127*xmag0*xmag0
      gnd= c1(ip) + c2(ip)*xmag + c3(ip)*mfac
      arg0= c8(ip)*xmag + c9(ip)*mfac
      arg= dist*dist + ((c5(ip) + 0.5*c6(ip) +0.5*c7(ip))*exp(arg0))**2
      arg= sqrt(arg)
      gnd = gnd + c4(ip)*alog(arg) + csite(ip)
c----  for thrust faults work in progress june 23 06
	if(rev.and.cosDELTA.lt.0.76)then
      gnd= gnd+ c11(ip)
c--- other coef for reverse faults
	elseif(rev)then
      gnd= gnd+ c10(ip)
      endif
c----- gnd3 for normal faults
c      gnd3= gnd
ccc   sigma C&B with mag-dependence
          if(xmag.lt.cmagsig(ip)) csigma= csigma1(ip)- 
     &     csigmacoef(ip)*xmag
          if(xmag.ge.cmagsig(ip)) csigma= csigma2(ip)
          if(dist.lt.distnf) csigma= csigma+ sigmanf
      sigmaf= 1./csigma/sqrt2
c      if(dist.le.30.) then
      if(dist.le.30..and.rjb.lt.5.) then
      fhw= (5.-rjb)/5.
      if(xmag.le.6.5) fhw= fhw*(xmag-5.5)
      if(dist.lt.8.)then
       fhw= fhw*c15(ip)*dist/8.
      else
       fhw= fhw*c15(ip)
       endif
c---- hanging wall term for thrust faults or more steeply dipping reverse faults.
      gnd= gnd + fhw
      endif
      return
      end

cccccccccccccc
      subroutine getCampCEUS(ip,ir,xmag,dist,gnd,csigma,sigmaf,sigmanf,distnf)
        parameter (sqrt2=1.414213562,alg70=4.2484952,alg130=4.8675345)
        parameter (np=7)
	common/mech/ss,rev,normal,obl
	logical ss,rev,normal,obl	
c  Campbell CEUS BSSA June 2003. BC or A rock. 7 periods.
c Campbell has exceptionally low sigma for higher M events (NMSZ M7.7 for example) 
c testing june 23 2006. SH. No clamp during
c initial effort. 6-23-06.
c input xmag= moment mag
c input dist = rrup (km) appropriate for Camp Ceus.
c ir=1 BC or firm rock
c ir=2 A or hard rock. Only difference is in constant term (check this)
c output gnd = log(median SA) (geometric mean), sigmaf= sigmafactor, and csigma
c
	real,dimension(np):: c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,
     1 clamp,c1h,csigma1,csigmacoef,csigma2,cmagsig

	c1= (/0.4492,.1325,-.3177,.4064,-0.1483,-0.1333,-1.2483/)
        c1h= (/0.0305,-0.4328,-.6104,-0.1475,-.6906,-.5907,-1.4306/)
	c2= (/.633,.617,.451,.613,0.609,0.534,0.459/)
	c3= (/-.0427,-.0586,-.2090,-.0353,-0.0786,-0.1379,-0.2552/)
	c4= (/-1.591,-1.32,-1.158,-1.369,-1.28,-1.216,-1.124/)
	c5= (/.683,.399,.299,0.484,0.349,0.318,.310/)
	c6= (/.416,.493,.503,0.467,0.502,0.503,.499/)
	c7= (/1.140,1.25,1.067,1.096,1.241,1.116,1.015/)
	c8= (/-.873,-.928,-.482,-1.284,-.753,-0.606,-.417/)
	c9= (/-.00428,-.0046,-.00255,-.00454,-.00414,-.00341,-.00187/)
	c10= (/.000483,.000337,.000141,.00046,.000263,.000194,.000103/)
	csigma1= (/1.030,1.077,1.110,1.059,1.081,1.098,1.093 /)
	csigmacoef= (/-.0860,-.0838,-.0793,-.0838,-0.0838,-0.0824,-.0758/)
	csigma2= (/0.414,.478,.543,0.460,0.482,0.508,0.551/)
	cmagsig= (/7.16,7.16,7.16,7.16,7.16,7.16,7.16/)
	clamp= (/3.0,6.0,0.,6.,6.,6.,3.0/)
	if(ir.eq.1)then
	gnd=c1(ip)
	else
	gnd= c1h(ip)
	endif
      gnd= gnd + c2(ip)*xmag + c3(ip)*(8.5-xmag)*(8.5-xmag)
      arg= dist*dist + (c5(ip)*exp(c6(ip)*xmag))**2
      arg= sqrt(arg)
      fac=0.
      if(dist.gt.70.) fac= c7(ip)*(alog(dist)- alg70)
      if(dist.gt.130.) fac= fac+ c8(ip)*(alog(dist)-alg130)
      gnd = gnd + c4(ip)*alog(arg) + fac +(c9(ip)+c10(ip)*xmag)*dist
c      write(12,*) period,dist0,xmag,exp(gnd)
c--- following is for clipping 
         if(ip.eq.1.or.ip.eq.7) then
          gnd=min(gnd,0.405)
         else
           gnd=min(gnd,1.099)
          endif
         if(xmag.lt.cmagsig(ip))then
           csigma= csigma1(ip)+ csigmacoef(ip)*xmag
          else
           csigma= csigma2(ip)
          endif
          if(dist.lt.distnf) csigma= csigma+ sigmanf
      sigmaf= 1./csigma/sqrt2
c apply clamp in main if needed.
  103 continue
      return
      end

ccccccc
      subroutine getBJF97(iq,xmag,dist0,vs30,gnd,sigmaf)
c adapted to nga 7 periods. any vs30.
c dist0 is rjb
c returns gnd, sigmaf
         parameter (sqrt2=1.414213562,np=7)
	common/mech/ss,rev,normal,obl
	logical ss,rev,normal,obl	
        real,dimension(np):: b1ss,b2,b3,b4,b5,hsq,sigma,
     1 b1rv,b1all,bv,va
       	real,dimension(8):: perx
c	!a reference set including pgv which wasn't used in 2002
c array constructors
	b1all= (/-0.242,1.089,-1.08,1.059,0.70,-.25,-1.743/)
        bv= (/-.371,-.292,-.698,-.212,-.401,-.553,-.655/)
        va= (/1396.,2118.,1406.,1112.,2133.,1816.,1795./)
	b1ss= (/-.313,0.999,-1.133,1.006,0.598,-.268,-1.699/)
	b1rv= (/-.117,1.17,-1.009,1.087,.803,.087,-1.801/)
	b1all= (/-.242,1.089,-1.08,1.059,0.70,-0.025,-1.743/)
	b2= (/0.527,0.711,1.036,0.753,0.769,0.884,1.085/)
	b3= (/0.,-0.207,-0.032,-.226,-.161,-.09,-.085/)
	b4= (/0.,0.,0.,0.,0.,0.,0./)
	b5= (/-0.778,-0.924,-0.798 ,-.934,-.893,-.846,-.812/)   
c	h= (/5.57,7.02,2.90,6.27,5.94,4.13,5.85/)
	hsq= (/31.0249,49.2804,8.41,39.3129,35.2836,17.0569,34.2225/)
	sigma= (/0.520,0.502,0.613,0.479,0.522,0.556,0.672/)
       perx= (/0.,0.2,1.0,0.1,0.3,0.5,2.0,-1./)
c what about near-source dispersion?
c          if(dist0.lt.distnf) sig= sig+ sigmanf
          sigmaf= 1./sigma(iq)/sqrt2
c mech-dependent and site Vs30 dependency
	if(ss)then
	gnd0=b1ss(iq)
	elseif(rev)then
	gnd0 =b1rv(iq)
	else
	gnd0=b1all(iq)
	endif
	gnd0=gnd0+bv(iq)*alog(vs30/va(iq))
c        if(iconv(ip,ia).eq.1) xmag= 2.715 -0.277*xmag0+0.127*xmag0*xmag0
          dist= sqrt(dist0*dist0+hsq(iq))
          gnd= gnd0 +b2(iq)*(xmag-6.)+b3(iq)*(xmag-6.)**2
          gnd= gnd + b4(iq)*dist + b5(iq)*alog(dist)
      return
      end

cccccccc
      subroutine getMota(iq,xmag,dist0,vs30,gnd,sigmaf)
c input xmag = moment mag
c	dist0 = rrup (check with Chuck) (km)
c	vs30  = top30 m Vs. for site amp term. (ditto)
c--  for Motazedian and Atkinson 2003 Puerto Rico relations
c adaptations: predefine some frequently used scalars. put in bjf97 siteamp
       parameter (np=7,alg75=1.8750613,sqrt2=1.41421356)
       parameter (vref=760.0,aln10=2.30258509,alg=2.99122608)
	real bv(np),va(np)
c alg = log10(980)      
      real deltasq,fac,sigmasq,perx(8)
	real c1(np),c2(np),c3(np),c4(np),sigma(np)
c array constructors 10/2006. SH
          perx= (/0.,0.2,1.0,0.1,0.3,0.5,2.0,-1./)	!-1 shall be reserved for pgv
        bv= (/-.371,-.292,-.698,-.212,-.401,-.553,-.655/)
        va= (/1396.,2118.,1406.,1112.,2133.,1816.,1795./)
	c1= (/3.87,4.33,3.40,3.,3.,3.,2.86/)
	c2= (/0.39062,0.38815,0.64818,1.,1.,1.,0.77055/)
	c3= (/-0.11289,-0.13977,-0.15222,0.,0.,0.,-0.11963/)
	c4= (/-0.00213,-0.00189,-0.00091,0.,0.,0.,-0.00082/)
	sigma= (/0.28,0.28,0.28,0.28,0.28,0.28,0.28/)
c	h= (/5.,5.,5.,5.,5.,5.,5./)
c site amp first, convert to base 10 for compatibility
c first try at siteamp is the BJF 97 version. no site nonlinearity. Needs work for better compatibility w/nga
	gnd0 = bv(iq)*alog(vs30/vref)/aln10
        sigmaf= 1./sigma(iq)/sqrt2
	period = perx(iq)
c gnd0 the site term is added to the magnitude-dependent terms
        deltasq = (-7.333 + 2.333*xmag)**2
        dist= sqrt(dist0*dist0 + deltasq)
        gnd=gnd0 +c1(iq)+c2(iq)*(xmag-6.)+c3(iq)*((xmag-6.)**2)+ c4(iq)*dist
        if(dist.le.75.) then
        fac= (-1.88+0.14*xmag)*alog10(dist)
        elseif(dist.le.100.)then
        fac= (-1.88+0.14*xmag)*alg75
        else 
        fac= (-1.88+0.14*xmag)*alg75 -0.5*alog10(dist/100.)
        endif
c alg serves to convert cm/s/s to g
        gnd= gnd + fac - alg
c base10 to base e
        gnd= gnd*aln10
      return
      end
c

      subroutine AS_2005b ( mag, dip, rake, aspectratio, rRup, rjb,
     1                     vs30, srcSiteA, DepthTop, lnSa, sigma1, 
     2                     iper, period1 )
     
      real mag, dip, rake, aspectratio, rRup, rjb, vs30, pgaRock,
     1       srcSiteA, lnSa, sigma, tau, period1, sigma1
      integer iper
     
c     compute pga on rock
      iper1 = 1
      pgaRock = 0.
      vs30_1 = 1100.
      call AS_2005_model ( mag, dip, rake, aspectratio, rRup, rjb,
     1                     vs30_1, pgaRock, srcSiteA, 
     1                DepthTop, lnSa, sigma, tau, 
     2                     iper1, period2 )
      pgaRock = exp(lnSa)
c      write (*,'( ''  rockpga='',2f10.4)') pgaRock
      
   
c     compute Sa (given the PGA rock value)
      call AS_2005_model ( mag, dip, rake, aspectratio, rRup, rjb,
     1                     vs30, pgaRock, srcSiteA, DepthTop, 
     1                     lnSa, sigma, tau, 
     2                     iper, period1 )

      sigma1 = sqrt( sigma**2 + tau**2 )
      
c      write (*,'( f10.4)') period1
      return
      end
      
c ----------------------------------------------------------------------

      subroutine AS_2005_model ( mag, dip, rake, aspectratio, rRup, rjb,
     1                     vs30, pgaRock, srcSiteA, DepthTop, 
     1                     lnSa, sigma, tau, 
     2                     iper, period1 )
      
      parameter (MAXPER=21)
      real c0(MAXPER), c1(MAXPER), c2(MAXPER), c3(MAXPER), 
     1     c4(MAXPER), c5(MAXPER), 
     1     c6(MAXPER), c7(MAXPER), c8(MAXPER), c9(MAXPER),  c10(MAXPER),
     2      c11(MAXPER),  c12(MAXPER)
      real period (MAXPER), b_soil(MAXPER), vref(MAXPER)
      real sigma, tau,lnSa, pgaRock, vs30, rjb, rRup, aspectratio, rake,
     & dip, mag, sigma0(MAXPER), tau0(MAXPER)
      integer iper
      real n, c

c     PEN model #5
      period = (/ 0.,0.01,0.02,0.03,0.04,0.05,0.075,0.1,0.15,
     1  0.2,0.25,0.3,0.4,0.5,0.75,1.,1.5,2.,3.,4.,5./)
      vref = (/ 865.1,865.1,865.1,907.8,994.5,1053.5,1085.7,
     1    1032.5,877.6,
     1    748.2,654.3,587.1,503.0,456.6,410.5,
     1    400.,400.,400.,400.,400.,400./)
      b_soil = (/ -1.186,-1.186,-1.219,-1.273,-1.308,
     1  -1.346,-1.471,-1.624,
     1  -1.931,-2.188,-2.381,-2.518,-2.657,-2.669,-2.401,
     2  -1.955,-1.025,-0.299,0.,0.,0./)
      c0 = (/ 6.4,6.7,6.6,6.4,6.7,7.1,8.3,9.6,10.3,9.5,8.7,
     1  7.3,6.8,6.1,3.8,3.6,2.7,2.4,3.9,5.1,6.1/)
      c1 = (/ 1.283,1.2474,1.2808,1.3632,1.4936,1.6645,
     1   2.1555,2.5918,2.87,2.7123,
     1   2.5164,2.2411,2.0442,1.9085,1.3589,
     1   1.0968,0.5499,0.0308,-0.0884,-0.2875,-0.3686/)
      c2 = (/ -0.9841,-0.9704,-0.9771,-0.9969,-1.0286,
     1   -1.0637,-1.1423,-1.2036,-1.1957,-1.1051,
     1  -1.0301,-0.9411,-0.883,-0.8539,-0.7629,
     1  -0.7397,-0.6657,-0.6195,-0.7102,-0.7218,-0.7683/)
      c3 = (/ -0.2,-0.2,-0.2,-0.2,-0.2,-0.2,-0.2,
     1  -0.2,-0.2,-0.2,-0.2,-0.2,-0.2,
     1  -0.2,-0.2,-0.2,-0.2,-0.2,-0.2,-0.2,-0.2/)
      c5 = (/ 0.05,0.05,0.05,0.05,0.05,0.05,0.05,
     1  0.05,0.05,0.05,0.05,0.05,
     1  0.05,0.05,0.05,0.05,0.05,0.05,0.05,0.05,0.05/)
      c6 = (/ 0.01,0.0112,0.0118,0.0131,0.0163,
     1   0.0194,0.0281,0.0282,0.0218,
     1   0.0068,-0.0056,-0.0158,-0.0293,
     1   -0.0469,-0.0687,-0.0874,-0.1146,
     2  -0.1282,-0.1574,-0.1916,-0.1994/)
      c7 = (/ 0.2601,0.2491,0.2511,0.2512,0.236,
     1  0.2297,0.1891,0.1719,0.1894,
     1  0.2071,0.2327,0.2282,0.22,0.2364,0.2589,
     1  0.268,0.2012,0.2527,
     1  0.2511,0.1449,0.0998/)
      c8 = (/ -0.09,-0.09,-0.09,-0.09,-0.09,-0.09,
     1  -0.09,-0.09,-0.09,-0.09,
     1  -0.09,-0.09,-0.09,-0.09,-0.09,-0.09,
     1  -0.09,-0.09,-0.09,-0.09,-0.09/)
      c9 = (/ 0.213,0.1986,0.2084,0.2389,0.2495,
     1  0.2748,0.2351,0.2122,0.1978,
     1  0.1531,0.0514,-0.0102,-0.0246,
     1  -0.0299,-0.0193,0.0178,-0.0019,
     1  0.0336,0.1418,0.321,0.2559/)
      c10 = (/ 0.9475,0.949,0.9898,1.054,1.0943,
     1   1.1456,1.3126,1.4806,1.8391,
     1   2.1163,2.319,2.4505,2.5833,2.558,
     1   2.1441,1.533,0.3399,-0.5625,
     2   -0.8821,-0.8508,-0.7994/)
      c11 = (/ 0.0647,0.0546,0.0557,0.0583,0.064,
     1   0.0694,0.0628,0.0566,0.0458,
     1   0.0286,0.0511,0.05,0.0491,0.0385,0.0227,
     1   0.0294,0.0222,0.0667,0.0262,0.0272,0.0073/)
      c12 = (/ 0.0245,0.0245, 0.0248,	0.0254,	
     1   0.0259,0.0274,	0.0291,	0.0291,
     1  0.0314,	0.029,	0.0288, 0.0277,	
     1   0.0181,0.019,	0.0077,	-0.003,	-0.0189,
     2   -0.0264,-0.0275,-0.0385,-0.0377 /)
      sigma0 = (/ 0.5065,0.509,0.5106,0.5176,0.5249,
     1  0.5313,0.5476,0.558,0.556,0.5465,0.5458,
     1  0.5521,0.5499,0.5604,0.5809,0.598,
     1  0.6156,0.6159,0.5719,0.58,0.5889/)
      tau0 = (/ 0.3281,0.326,0.3304,0.3443,0.3573,
     1   0.3796,0.4044,0.4008,0.3929,0.3657,
     1   0.3507,0.336,0.3504,0.377,0.3535,0.3614,
     1   0.3795,0.4161,0.4935,0.4882,0.5652/)

      n = 1.18
      c = 1.88
      
c      write (*,'( 10f10.5)') vs30, PgaRock, mag, rRup, rake
c      write (*,'( i5)') iper


c       Mechanism
        if ( rake .gt. 22.5 .and. rake .lt. 157.5) then
          Frv = 1.
        else
          Frv = 0.
        endif
        if ( rake .lt. -22.5 .and. rake .gt. -157.5) then
          Fn = 1.
        else
          Fn = 0.
        endif

c     Base Model
      r = sqrt(rRup**2 + c0(iper)**2)
      sum = c1(iper) + (c2(iper)+c3(iper)*(7.5-mag))*alog(r)   
     1     + c5(iper)*(mag-6.) + c6(iper)*(8.5-mag)**2 
c      write (*,'( 2x,''test 1'',f10.4)') sum
     
c     Mech model     
      sum = sum  + c7(iper)*Frv + c9(iper)*Fn 
c      write (*,'( 2x,''test 1a'',7f10.4)') sum, Frv, Fn

c     Set Taper 1           
      if ( mag .gt. 7. ) then
          taperM1 = 1.0
      elseif ( mag .gt. 6.5) then
          taperM1 = (mag-6.5)*2.
      else
          taperM1 = 0.0
      endif

c     Set Taper 2           
      if ( mag .gt. 6.5 ) then
          taperM2 = 1.0
      elseif ( mag .gt. 6.0) then
          taperM2 = (mag-6.0)*2.
      else
          taperM2 = 0.0
      endif
        
c     Aspect ratio model
      ar1 = aspectratio
      if (ar1 .gt. 20. ) then
          ar1 = 20.
      elseif ( ar1 .lt. 1.5) then
          ar1 = 1.5
      endif
      sum = sum + c8(iper)*(alog(ar1)-alog(1.5))*taperM1
c      write (*,'( 2x,''test 2'',4f10.4)') sum, 
c     & ar1, c8(iper)*(alog(ar1)-alog(1.5))
c     &,taperM1

c     soil     
      if ( vs30 .lt. vref(iper)) then
          soilamp =  c10(iper)*alog(vs30/vref(iper)) 
     1              - b_soil(iper)*alog(c+pgaRock) 
     1              + b_soil(iper)*
     1 alog(pgaRock+c*((vs30/vref(iper))**(n)) )
      else
     	  soilamp = (c10(iper)+b_soil(iper)*n) *alog(vs30/vref(iper))
      endif
      sum = sum + soilamp
c      write (*,'( f10.5)') soilAmp
c      write (*,'( 2x,''test 3'',f10.4)') sum

c     HW model
          hw1 = 0.
          angle1 = abs(srcSiteA)
          if (angle1 .gt. 90. ) then
              angle1 = 180. - srcSiteA
          endif
          if ( angle1 .lt. 20. ) then
              taperTheta = angle1/20.
          else
              taperTheta = 1.
          endif
          t_hw = (30.-rjb)/30. * (90.-dip)/45. * taperM2 
          if ( depthTop .eq. 0. ) then
            t_fw = 0.
          else   
            t_fw = 1. - rjb / (2.*depthTop+1.)
          endif
          if ( srcSiteA .gt. 0. .and. rjb .lt. 30. ) then
            hw1 = c11(iper)* (t_hw*taperTheta + t_fw*(1.-taperTheta) )
          elseif ( srcSiteA .lt. 0. .and. rjb .lt. 2.*depthTop ) then
            hw1 = c11(iper) * t_fw
          else
            hw1 = 0.
          endif
          sum = sum + hw1
c      write (*,'( 2x,''test 4'',f10.4)') sum
         
c         depth of rupture term          
          if ( mag .lt. 6.5 ) then         
            sum = sum + c12(iper) * (depthTop - 5.) * (1.-taperM2)
          endif
c      write (*,'( 2x,''test 5'',f10.4)') sum

      period1 = period(iper)
      lnSa = sum

c     sigma is independent of magnitude, 
      sigma = sigma0(iper)
      tau = tau0(iper)
      
      return
      end
      
      subroutine getIdriss(ip,xmag,rjb,vs30,gnd,sigmaf)
c Oct 2005: for pga only.
c ip is period index in calling program. 
c iq is period index in this subroutine. But there is no need for period
c subscripting because only pga is available.
	parameter (pi=3.14159265,sqrt2=1.414213562,vref=760.)
	common/mech/ss,rev,normal,obl
	common/dipinf/dipang,cosDELTA,cdipsq,cyhwfac,cbhwfac
c----  This version assumes v30 in neighborhood of 760 m/sec (no Vs30 dependency)
c----  uses ln coefficients
	real magmin,dmag,sigmanf,distnf
	real a1/2.14/,a2/0.134/,b1/2.8/,b2/-0.197/
	real phi/0.08/,sigma/0.68/
	real a16/6.052/,a26/-.473/,b16/3.256/,b26/-0.273/
	logical ss,rev,normal,obl
	if(ip.ne.1)stop'getIdriss: pga only.'
c coeffs. from oct 5 2005 powerpoint progress report
          sigmaf= 1./sigma/sqrt2
c-- 
      dist0= rjb
          dist= dist0
          if(xmag.lt.6.0) then
          gnd= a1+a2*xmag-(b1+b2*xmag)*alog(dist+10.)
	  else
          gnd= a16+a26*xmag- (b16+b26*xmag)*alog(dist+10.)
          endif
          if(rev)then
          gnd = gnd+ phi
          endif

      return
      end

      subroutine getBooreNGA06m(ip,xmag,rjb,vs30,gnd,sigmaf)
c
c In: ip = period index in per() array below,
c	xmag=moment mag
c	rjb= distance (km)
c	vs30= top30 m Vs, (m/s)
c Out: gnd = ln(median), sigmaf = 1/sigma/sqrt2
c
c Oct 30 2006 update of BooreAtkinson documentation.  Includes 12 periods
c up to 5-s T.
c----  enter vs30 (need not be 760 m/sec)
c *** gnd is sensitive to mech type, based on logical variable ss, rev, normal
c----  non-lin soil terms.  Form does not change in dec or may vers.
c --- returns log(median) and sigmaf, or "sigma-factor"=1/sigma/sqrt(2)
c --- testing June 29 2006. Several coeffs have changed meaning compared to earlier.
	parameter (pi=3.14159265,sqrt2=1.414213562,vref=760.,np=12)
	parameter (dx=1.098612289,dxsq=1.206948961,dxcube=1.325968960,plfac=-0.510825624)
c plfac = ln(pga_low/0.1)	This never changes so shouldnt be calculated.
	common/mech/ss,rev,normal,obl
	logical ss,rev,normal,obl	
	real per(np),e1(np),e2(np),e3(np),e4(np),e5(np),e6(np),e7(np),e8(np)
     1 ,mh(np),c1(np),c2(np),c3(np),c4(np),mref(np),rref(np),h(np),
     2blin(np),b1(np),b2(np),v1(np),v2(np),
     2 sig1(np),sig2u(np),sigtu(np),sig2m(np),sigtm(np)
c Boore considers 12 periods inOct'06 rev. 
c Smooths a kink pp 9-11 of boore sept report.
      real e1nl/-0.96402/,e2nl/0.29795/,e3nl/-0.20341/,e4nl/0.0/
      real c1nl/-0.55/,c2nl/0./,c3nl/-0.01151/,hnl/3.0/,b1nl/0./
      real b2nl/0./,pga_low/0.06/
c a1,a2 are scalars here. Boore has 'em as vectors in the spreadsheet, but
c unchanging with spectral period.
      real  a1/ 0.030/
      real  a2/ 0.090/,a2fac/0.405465108/
	integer i
c dx = ln(a2/a1), made a param. used in a smoothed nonlin calculation sept 2006.
c a2fac=ln(a2/pga_low)
c e2,e3,e4 are the mech-dependent set. e1 is a mech-unspecified value.
c Notation change from previous version of 12/05
c array constructors for f95 Linux
c from ba_oct27_usnr.xls coef file
      per= (/-1.00, 0.00, 0.05, 0.10, 0.20, 0.30, 0.50,1.00,
     + 2.00, 3.00, 4.00, 5.00/)
       e1= (/ 4.30814,-1.11599,-0.86040,-0.49660,-0.18575,-0.31699,
     1 -0.62784,-1.27487,-2.06005,-2.60576,-2.93734,-2.26498/)
       e2= (/ 4.37031,-1.07915,-0.78212,-0.45054,-0.16733,-0.31009,
     1 -0.62094,-1.24033,-1.98637,-2.52057,-2.84754,-2.19130/)
       e3= (/ 3.94064,-1.34556,-1.06833,-0.67845,-0.35388,-0.50650,
     1 -0.81194,-1.59746,-2.41603,-3.00710,-3.28664,-2.49017/)
       e4= (/ 4.34942,-1.08589,-0.94180,-0.50546,-0.14161,-0.23300,
     1 -0.54956,-1.19819,-2.10691,-2.69448,-3.07123,-2.39245/)
       e5= (/ 0.43312, 0.38983, 0.41009, 0.21582, 0.41055, 0.50910,
     1  0.65140, 0.69377, 0.72117, 0.74903, 1.11952, 0.10516/)
       e6= (/-0.11280,-0.11736,-0.09570,-0.14218,-0.16809,-0.18428,
     1 -0.14354,-0.19885,-0.31499,-0.42298,-0.35897,-0.39006/)
       e7= (/ 0.00000, 0.00000, 0.01804, 0.00000, 0.00000, 0.00632,
     1  0.00000, 0.00058, 0.32628, 0.69630, 0.68456, 0.00000/)
       e8= (/ 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000,
     1  0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000/)
       mh= (/ 8.50000, 7.00000, 7.00000, 7.00000, 7.00000, 7.00000,
     1  7.00000, 7.00000, 7.00000, 7.00000, 7.00000, 8.50000/)
       c1= (/-0.793300,-0.660300,-0.535200,-0.651800,-0.583300,-0.554300,
     1 -0.691700,-0.818200,-0.828600,-0.784600,-0.685100,-0.506800/)
       c2= (/ 0.111100, 0.119600, 0.154400, 0.118800, 0.042870, 0.019550,
     1  0.060910, 0.102700, 0.094360, 0.072880, 0.037460,-0.023550/)
       c3= (/-0.006220,-0.011510,-0.018730,-0.013670,-0.009520,-0.007500,
     1 -0.005400,-0.003340,-0.002170,-0.001910,-0.001910,-0.002020/)
       c4= (/ 0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000,
     1  0.00000, 0.00000, 0.00000, 0.00000, 0.00000, 0.00000/)
       mref= (/4.500,4.500,4.500,4.500,4.500,4.500,
     1 4.500,4.500,4.500,4.500,4.500,4.500/)
       rref= (/5.000,5.000,5.000,5.000,5.000,5.000,
     1 5.000,5.000,5.000,5.000,5.000,5.000/)
c Oct 31, 2006: h pseudo-depth is shallower than it was in previous coef. files
      h= (/2.500,1.400,1.400,1.700,2.000,2.100,
     1 2.300,2.500,2.700,2.800,2.900,2.900/)
      blin= (/-0.600,-0.360,-0.290,-0.250,-0.310,-0.440,
     1 -0.600,-0.700,-0.730,-0.740,-0.750,-0.750/)
       b1= (/-0.500,-0.640,-0.640,-0.600,-0.520,-0.520,
     1 -0.500,-0.440,-0.380,-0.340,-0.310,-0.300/)
       b2= (/-0.060,-0.140,-0.110,-0.130,-0.190,-0.140,
     1 -0.060, 0.000, 0.000, 0.000, 0.000, 0.000/)
         v1= (/ 180., 180., 180., 180., 180., 180.,
     1  180., 180., 180., 180., 180., 180./)
         v2= (/ 300., 300., 300., 300., 300., 300.,
     1  300., 300., 300., 300., 300., 300./)
       sig1= (/0.513,0.502,0.576,0.530,0.523,0.546,
     1 0.555,0.573,0.580,0.566,0.583,0.603/)
      sig2u= (/0.286,0.262,0.368,0.325,0.286,0.269,
     1 0.262,0.313,0.396,0.410,0.389,0.414/)
      sigtu= (/0.587,0.566,0.684,0.622,0.596,0.608,
     1 0.612,0.654,0.702,0.700,0.702,0.732/)
      sig2m= (/0.256,0.256,0.366,0.327,0.288,0.269,
     1 0.262,0.297,0.389,0.401,0.380,0.437/)
      sigtm= (/0.573,0.562,0.682,0.622,0.596,0.608,
     1 0.612,0.645,0.698,0.693,0.695,0.744/)
c	character*8 s_o_s(3)/'str_slp','reverse','normal'/
c----  Input vs30. Ref v30= 760 m/sec
c
c  ip index corresponds to period. (check per correspondence with main perx)
c--- 
	site=0.0	!site term, nonzero for nonrefernce vs30
c sigma for specific mech type. If unspecified, sigmaf is redefined.
          sigmaf= 1./sigtm(ip)/sqrt2	! used with erf( ) in rate/prob calcs.
          dist= sqrt(rjb*rjb+h(ip)**2)
          if(xmag.le.mh(ip)) then
          gnd= e5(ip)*(xmag-mh(ip))
     1  +e6(ip)*((xmag-mh(ip))**2)
          else
           gnd= e7(ip)*(xmag-mh(ip))
c	1+e8(ip)*((xmag-mh(ip))**2)	!commented out because e8 is zero
           endif
          gnd= gnd+ (c1(ip)+ c2(ip)*(xmag-mref(ip)))*alog(dist/rref(ip))
     1  +c3(ip)*(dist-rref(ip))	
c	2 +c4(ip)*(dist-rref(ip))*(xmag-mref(ip)) 		
c 2nd continuation line commented out:nuisance
c computation because c4 is zero. Could change in the future. Still 0 june 06.     
          if(rev) then
          gnd = gnd + e4(ip)	!e4 can be lower than e2, the ss-mech coeff.
          elseif(normal) then
          gnd = gnd + e3(ip)	!e3 is lower.
          elseif(ss) then
          gnd = gnd + e2(ip)
          else			!unspecified or oblique?
          gnd = gnd + e1(ip)
          sigmaf= 1./sigtu(ip)/sqrt2	! used with erf( ) in rate/prob calcs.
          endif
          if(vs30.eq.vref)return
c Otherwise correct for non-reference site conditions.
c nonlinear effects, from a dave aug 05 file,retained thru june 2006
          distnl = sqrt(rjb**2+hnl*hnl)
          if(xmag.le.mh(ip))then
	pganl= e1nl+e2nl*(xmag-mh(ip))+e3nl*((xmag-mh(ip))**2)
          else
	pganl= e1nl + e4nl*(xmag-mh(ip))
           endif
c This pganl is needed when vs30 is not equal to vref. 
          pganl= pganl+ c1nl*alog(distnl/rref(ip))+c3nl*(distnl-rref(ip))
c	1 + c2nl*(xmag-mref(ip))*alog(dist/rref(ip))	!c2nl is zero. another
c nuisance calculation is commented out.
          pganl=exp(pganl)      !units g
          
        if(v1(ip).lt.vs30.and.vs30.le.v2(ip))then
        bnl=(b1(ip)-b2(ip))*
     1 alog(vs30/v2(ip))/alog(v1(ip)/v2(ip)) + b2(ip)
        elseif(v2(ip).lt.vs30.and.vs30.le.vref)then
        bnl=b2(ip)*alog(vs30/vref)/alog(v2(ip)/vref)
        elseif(vs30.le.v1(ip))then
        bnl=b1(ip)
        else
        bnl=0.0
        endif
        dy=bnl*a2fac
c Below: include site term. C.f., site with 760 m/s vref.
        site=blin(ip)*alog(vs30/vref)
        if(pganl.le.a1)then
        site=site+bnl*plfac
        pgafac=0.
        elseif(pganl.le.a2)then
c c and d from p 10 of boore sept report. Smoothing introduces extra calcs
c in the range a1 < pganl < a2. Otherwise nonlin term same as in june-july.
c many of these terms are fixed and are defined in or parameter statements
c Of course, if a1 and a2 change from their sept 06 values the parameters will
c also have to be redefined.
        c=(3.*dy-bnl*dx)/dxsq
        d=(bnl*dx-2.*dy)/dxcube
        pgafac=alog(pganl/a1)
        site=site+bnl*plfac + c*pgafac**2 + d*pgafac**3
        else
        site=site+bnl*alog(pganl/0.1)
        pgafac=0.
        endif
        gnd=gnd+site
c There may be a different sigma for nonlin soil. Not included as of
c sept 2006. There is a sigma associated with pganl. Given as 0.241 in xls
c file of Dec 2005. Not used here. May need work. CB relation does have
c sigma as a fcn of PGA_rock at this time (9/06).
c
c	if(ip.eq.2.and.xmag.gt.6.90)print *,rjb,xmag,exp(gnd),exp(site),pgafac,' bor9/06'
	return
      end


        subroutine CY2006H(iprd, M, Width, R_Rup, R_JB, V_S30, 
     1      Z_TOR, THETA_SITE, F_RV, F_NM,psa,sigmaf)
        parameter (mxnprd=105)
	parameter (pi=3.14159265,d2r=0.0174533,sqrt2=1.414213562)
c	implicit none
c Outputs psa=ln(median) and sigmaf, two scalar quantities needed for Pex calcs.
c Minor mod of June 2006 Chiou & Youngs NGA subroutine "cy2006h".
c  Steve Harmsen 6/20/2006. I reviewed the July document from C&Y and did not
c find any changes in the math. formulas or coefficients. Fortran efficiencies
c Predictor variables
c DELTA = fault dip (degrees) no longer an argument
c dipang (radians) is available in common/dipinf/
c z10 = depth where vs is 1.0 km/s. THis is not used in the current vers of code.
c Something to include later if z10 happens to be known,
c  see p. 32 of C&Y report of May 31 2006
	common/dipinf/dipang,cosDELTA,cdipsq,cyhwfac,cbhwfac
c	common/mech/ss,rev,normal,obl
        real PERIOD, M, Width, R_rup, R_JB, V_S30, Z10, DELTA, Z_TOR,
     1       THETA_SITE, F_RV, F_NM

c Model coefficients
        real, dimension(mxnprd):: prd,
     1       c1, c1a, c1b, c2,
     1       c3, cn,  cM,  c4,
     1       c4a,cRB, c5,  c6,
     1       cHM,c7,  c9,
     1       gamma1, gamma2, gamma3,
     1       f1, f2, f3, f4,
     1       tau, sigma, sigma_t
	real cc,gamma, cosDELTA, cyhwfac, cbhwfac, psa,psa_ref
	real dipang,cdipsq,sigmaf
	real r1,r2, r3, r4, fw, hw, a,b,c
	integer iprd, sa,i
c prd array not used below. Assume SA 0.01 s is PGA.
      prd= (/0.010,0.020,0.022,0.025,0.029,0.030,0.032,0.035,0.036,0.040,0.042,0.044,0.045,0.046,
     10.048,0.050,0.055,0.060,0.065,0.067,0.070,0.075,0.080,0.085,0.090,0.095,0.100,0.110,0.120,
     10.130,0.133,0.140,0.150,0.160,0.170,0.180,0.190,0.200,0.220,0.240,0.250,0.260,0.280,0.290,
     10.300,0.320,0.340,0.350,0.360,0.380,0.400,0.420,0.440,0.450,0.460,0.480,0.500,0.550,0.600,
     10.650,0.667,0.700,0.750,0.800,0.850,0.900,0.950,1.000,1.100,1.200,1.300,1.400,1.500,1.600,
     11.700,1.800,1.900,2.000,2.200,2.400,2.500,2.600,2.800,3.000,3.200,3.400,3.500,3.600,3.800,
     14.000,4.200,4.400,4.600,4.800,5.000,5.500,6.000,6.500,7.000,7.500,8.000,8.500,9.000,9.500,
     110.0/)
       c1= (/-1.2686,-1.2474,-1.2308,-1.2064,-1.1716,-1.1622,-1.1432,-1.1136,-1.1032,-1.0598,-1.0341,-1.0080,-0.9961,-0.9845,
     1-0.9606,-0.9363,-0.8686,-0.8090,-0.7487,-0.7296,-0.7065,-0.6661,-0.6329,-0.5993,-0.5678,-0.5408,-0.5207,-0.4899,-0.4535,
     1-0.4365,-0.4350,-0.4487,-0.4658,-0.4782,-0.4933,-0.5191,-0.5455,-0.5698,-0.6372,-0.7017,-0.7267,-0.7519,-0.8115,-0.8394,
     1-0.8667,-0.9306,-0.9978,-1.0268,-1.0589,-1.1152,-1.1649,-1.2189,-1.2742,-1.2996,-1.3257,-1.3752,-1.4201,-1.5247,-1.6343,
     1-1.7303,-1.7640,-1.8214,-1.8933,-1.9712,-2.0411,-2.1069,-2.1716,-2.2326,-2.3433,-2.4313,-2.5399,-2.6311,-2.7212,-2.8125,
     1-2.8974,-2.9774,-3.0531,-3.1249,-3.2583,-3.3802,-3.4373,-3.4922,-3.5960,-3.6926,-3.7829,-3.8678,-3.9084,-3.9478,-4.0235,
     1-4.0953,-4.1636,-4.2288,-4.2910,-4.3506,-4.4077,-4.5412,-4.6630,-4.7750,-4.8788,-4.9754,-5.0657,-5.1506,-5.2306,-5.3063,
     1-5.3820/)
      c1a= (/ 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000,
     1 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000,
     1 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.1000,
     1 0.1000, 0.1000, 0.1000, 0.1000, 0.1000, 0.0994, 0.0987, 0.0978, 0.0967, 0.0960, 0.0951, 0.0931, 0.0906, 0.0828, 0.0744,
     1 0.0652, 0.0617, 0.0547, 0.0435, 0.0323, 0.0214, 0.0112, 0.0018,-0.0068,-0.0210,-0.0328,-0.0432,-0.0525,-0.0602,-0.0661,
     1-0.0707,-0.0746,-0.0784,-0.0821,-0.0886,-0.0932,-0.0948,-0.0961,-0.0982,-0.0999,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,
     1-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,
     1-0.1000/)
      c1b= (/-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,
     1-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,-0.2554,
     1-0.2554,-0.2554,-0.2554,-0.2554,-0.2543,-0.2527,-0.2511,-0.2495,-0.2478,-0.2442,-0.2405,-0.2385,-0.2366,-0.2327,-0.2308,
     1-0.2288,-0.2250,-0.2211,-0.2192,-0.2173,-0.2135,-0.2098,-0.2061,-0.2025,-0.2007,-0.1990,-0.1955,-0.1920,-0.1839,-0.1768,
     1-0.1705,-0.1686,-0.1651,-0.1603,-0.1562,-0.1525,-0.1491,-0.1461,-0.1433,-0.1384,-0.1342,-0.1306,-0.1274,-0.1247,-0.1221,
     1-0.1199,-0.1177,-0.1158,-0.1140,-0.1107,-0.1080,-0.1067,-0.1056,-0.1036,-0.1019,-0.1006,-0.1000,-0.1000,-0.1000,-0.1000,
     1-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,-0.1000,
     1-0.1000/)
       c2= (/ (1.060, i=1,105)/)
       c3= (/ (3.450, i=1,105)/)
       cn= (/ 2.9960, 3.2920, 3.3520, 3.4290, 3.5010, 3.5140, 3.5330, 3.5510, 3.5550, 3.5630, 3.5630, 3.5610, 3.5590, 3.5570,
     1 3.5530, 3.5470, 3.5310, 3.5130, 3.4930, 3.4840, 3.4710, 3.4480, 3.4230, 3.3970, 3.3690, 3.3410, 3.3120, 3.2550, 3.1990,
     1 3.1450, 3.1290, 3.0930, 3.0440, 2.9970, 2.9520, 2.9100, 2.8700, 2.8310, 2.7600, 2.6920, 2.6580, 2.6260, 2.5640, 2.5330,
     1 2.5050, 2.4490, 2.3970, 2.3720, 2.3480, 2.3030, 2.2610, 2.2220, 2.1850, 2.1670, 2.1500, 2.1180, 2.0870, 2.0170, 1.9570,
     1 1.9040, 1.8870, 1.8550, 1.8120, 1.7730, 1.7370, 1.7040, 1.6750, 1.6480, 1.6050, 1.5720, 1.5460, 1.5260, 1.5110, 1.4980,
     1 1.4890, 1.4810, 1.4740, 1.4700, 1.4630, 1.4580, 1.4560, 1.4560, 1.4550, 1.4560, 1.4570, 1.4580, 1.4590, 1.4610, 1.4630,
     1 1.4650, 1.4680, 1.4700, 1.4730, 1.4750, 1.4780, 1.4830, 1.4880, 1.4920, 1.4960, 1.4980, 1.4990, 1.5000, 1.5010, 1.5010,
     1 1.5020/)
       cM= (/ 4.1840, 4.1880, 4.1830, 4.1730, 4.1590, 4.1560, 4.1480, 4.1380, 4.1350, 4.1230, 4.1170, 4.1120, 4.1100, 4.1080,
     1 4.1040, 4.1010, 4.0940, 4.0890, 4.0870, 4.0860, 4.0860, 4.0860, 4.0870, 4.0900, 4.0940, 4.0990, 4.1030, 4.1140, 4.1280,
     1 4.1420, 4.1460, 4.1560, 4.1720, 4.1870, 4.2020, 4.2170, 4.2320, 4.2480, 4.2760, 4.3040, 4.3180, 4.3320, 4.3580, 4.3710,
     1 4.3840, 4.4090, 4.4320, 4.4440, 4.4560, 4.4770, 4.4980, 4.5170, 4.5360, 4.5450, 4.5540, 4.5710, 4.5880, 4.6270, 4.6630,
     1 4.6960, 4.7070, 4.7280, 4.7570, 4.7850, 4.8110, 4.8360, 4.8600, 4.8820, 4.9250, 4.9640, 5.0010, 5.0370, 5.0700, 5.1020,
     1 5.1330, 5.1620, 5.1910, 5.2170, 5.2690, 5.3170, 5.3390, 5.3610, 5.4010, 5.4390, 5.4740, 5.5070, 5.5230, 5.5380, 5.5690,
     1 5.5980, 5.6250, 5.6520, 5.6780, 5.7030, 5.7280, 5.7860, 5.8400, 5.8920, 5.9420, 5.9890, 6.0340, 6.0770, 6.1170, 6.1560,
     1 6.1930/)
       c4= (/ (-2.1000, i=1,105)/)
      c4a= (/ (-0.5000, i=1,105)/)
      cRB= (/ (50.0000, i=1,105)/)
       c5= (/ 6.1600, 6.1580, 6.1580, 6.1590, 6.1600, 6.1600, 6.1600, 6.1600, 6.1600, 6.1600, 6.1600, 6.1600, 6.1600, 6.1600,
     1 6.1600, 6.1600, 6.1600, 6.1570, 6.1510, 6.1490, 6.1450, 6.1370, 6.1280, 6.1180, 6.1070, 6.0940, 6.0820, 6.0550, 6.0280,
     1 6.0000, 5.9920, 5.9720, 5.9460, 5.9200, 5.8960, 5.8730, 5.8510, 5.8300, 5.7930, 5.7580, 5.7420, 5.7260, 5.6950, 5.6800,
     1 5.6650, 5.6360, 5.6080, 5.5950, 5.5810, 5.5550, 5.5310, 5.5070, 5.4840, 5.4730, 5.4630, 5.4440, 5.4250, 5.3820, 5.3440,
     1 5.3110, 5.3010, 5.2820, 5.2560, 5.2330, 5.2110, 5.1920, 5.1730, 5.1550, 5.1230, 5.0960, 5.0720, 5.0520, 5.0370, 5.0240,
     1 5.0160, 5.0100, 5.0060, 5.0030, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000,
     1 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000, 5.0000,
     1 5.0000/)
       c6= (/ 0.4893, 0.4893, 0.4893, 0.4893, 0.4893, 0.4893, 0.4893, 0.4893, 0.4893, 0.4893, 0.4893, 0.4893, 0.4893, 0.4893,
     1 0.4893, 0.4893, 0.4893, 0.4893, 0.4893, 0.4892, 0.4890, 0.4886, 0.4882, 0.4878, 0.4872, 0.4867, 0.4861, 0.4849, 0.4835,
     1 0.4822, 0.4818, 0.4810, 0.4797, 0.4784, 0.4772, 0.4760, 0.4749, 0.4739, 0.4721, 0.4707, 0.4700, 0.4694, 0.4682, 0.4676,
     1 0.4671, 0.4660, 0.4649, 0.4644, 0.4639, 0.4629, 0.4619, 0.4609, 0.4601, 0.4597, 0.4593, 0.4586, 0.4578, 0.4564, 0.4553,
     1 0.4544, 0.4541, 0.4536, 0.4530, 0.4525, 0.4521, 0.4517, 0.4513, 0.4511, 0.4508, 0.4506, 0.4505, 0.4505, 0.4504, 0.4504,
     1 0.4503, 0.4503, 0.4503, 0.4503, 0.4502, 0.4502, 0.4502, 0.4502, 0.4501, 0.4501, 0.4501, 0.4501, 0.4501, 0.4501, 0.4500,
     1 0.4500, 0.4500, 0.4500, 0.4500, 0.4500, 0.4500, 0.4500, 0.4500, 0.4500, 0.4500, 0.4500, 0.4500, 0.4500, 0.4500, 0.4500,
     1 0.4500/)
      cHM= (/ (3.00, i=1,105)/)
       c7= (/ 0.0512, 0.0512, 0.0512, 0.0512, 0.0512, 0.0511, 0.0511, 0.0510, 0.0509, 0.0508, 0.0507, 0.0506, 0.0506, 0.0505,
     1 0.0505, 0.0504, 0.0502, 0.0500, 0.0499, 0.0498, 0.0497, 0.0495, 0.0494, 0.0492, 0.0491, 0.0490, 0.0488, 0.0486, 0.0484,
     1 0.0482, 0.0482, 0.0481, 0.0479, 0.0477, 0.0476, 0.0474, 0.0473, 0.0471, 0.0468, 0.0466, 0.0464, 0.0463, 0.0460, 0.0459,
     1 0.0458, 0.0455, 0.0453, 0.0452, 0.0450, 0.0448, 0.0445, 0.0442, 0.0439, 0.0437, 0.0436, 0.0432, 0.0429, 0.0421, 0.0412,
     1 0.0404, 0.0401, 0.0395, 0.0387, 0.0379, 0.0372, 0.0364, 0.0357, 0.0350, 0.0336, 0.0322, 0.0308, 0.0294, 0.0280, 0.0266,
     1 0.0253, 0.0240, 0.0226, 0.0214, 0.0188, 0.0165, 0.0154, 0.0143, 0.0124, 0.0106, 0.0090, 0.0076, 0.0069, 0.0063, 0.0052,
     1 0.0041, 0.0033, 0.0025, 0.0019, 0.0014, 0.0010, 0.0002, 0.0000, 0.0000, 0.0000, 0.0000, 0.0000, 0.0000, 0.0000, 0.0000,
     1 0.0000/)
       c9= (/ 1.0480, 1.0830, 1.0990, 1.1250, 1.1570, 1.1650, 1.1770, 1.1940, 1.1990, 1.2150, 1.2210, 1.2270, 1.2290, 1.2320,
     1 1.2350, 1.2380, 1.2440, 1.2480, 1.2490, 1.2500, 1.2500, 1.2490, 1.2480, 1.2450, 1.2430, 1.2390, 1.2350, 1.2260, 1.2150,
     1 1.2040, 1.2010, 1.1930, 1.1820, 1.1700, 1.1590, 1.1470, 1.1360, 1.1240, 1.1020, 1.0810, 1.0700, 1.0590, 1.0390, 1.0290,
     1 1.0190, 1.0000, 0.9813, 0.9722, 0.9632, 0.9458, 0.9288, 0.9123, 0.8963, 0.8885, 0.8809, 0.8658, 0.8513, 0.8167, 0.7846,
     1 0.7542, 0.7443, 0.7256, 0.6982, 0.6721, 0.6471, 0.6229, 0.5996, 0.5771, 0.5346, 0.4951, 0.4584, 0.4244, 0.3930, 0.3639,
     1 0.3369, 0.3120, 0.2889, 0.2675, 0.2294, 0.1965, 0.1818, 0.1680, 0.1431, 0.1210, 0.1016, 0.0846, 0.0769, 0.0698, 0.0569,
     1 0.0459, 0.0364, 0.0283, 0.0213, 0.0154, 0.0104, 0.0012, 0.0000, 0.0000, 0.0000, 0.0000, 0.0000, 0.0000, 0.0000, 0.0000,
     1 0.0000/)
      gamma1=(/-0.008040,-0.008113,-0.008155,-0.008230,-0.008351,-0.008387,-0.008454,-0.008564,
     1-0.008599,-0.008754,-0.008833,-0.008906,-0.008945,-0.008984,-0.009050,-0.009121,
     1-0.009288,-0.009433,-0.009561,-0.009603,-0.009656,-0.009733,-0.009782,-0.009808,
     1-0.009809,-0.009788,-0.009753,-0.009627,-0.009460,-0.009269,-0.009205,-0.009054,
     1-0.008832,-0.008610,-0.008398,-0.008183,-0.007976,-0.007776,-0.007397,-0.007044,
     1-0.006877,-0.006715,-0.006408,-0.006263,-0.006123,-0.005859,-0.005614,-0.005497,
     1-0.005386,-0.005175,-0.004980,-0.004799,-0.004632,-0.004552,-0.004477,-0.004332,
     1-0.004199,-0.003903,-0.003652,-0.003435,-0.003368,-0.003246,-0.003078,-0.002929,
     1-0.002795,-0.002674,-0.002564,-0.002464,-0.002287,-0.002138,-0.002010,-0.001898,
     1-0.001802,-0.001717,-0.001643,-0.001578,-0.001519,-0.001467,-0.001381,-0.001311,
     1-0.001281,-0.001255,-0.001209,-0.001172,-0.001142,-0.001117,-0.001106,-0.001096,
     1-0.001079,-0.001065,-0.001052,-0.001042,-0.001032,-0.001024,-0.001016,-0.000999,
     1-0.000987,-0.000977,-0.000968,-0.000961,-0.000955,-0.000950,-0.000945,-0.000941,
     1-0.000937/)
      gamma2= (/-0.007850,-0.007921,-0.007962,-0.008035,-0.008154,-0.008189,-0.008255,-0.008362,
     1-0.008396,-0.008547,-0.008624,-0.008696,-0.008734,-0.008771,-0.008836,-0.008906,
     1-0.009068,-0.009210,-0.009335,-0.009376,-0.009428,-0.009503,-0.009550,-0.009577,
     1-0.009577,-0.009557,-0.009522,-0.009400,-0.009236,-0.009050,-0.008988,-0.008840,
     1-0.008623,-0.008406,-0.008199,-0.007989,-0.007787,-0.007592,-0.007222,-0.006878,
     1-0.006714,-0.006556,-0.006257,-0.006115,-0.005979,-0.005720,-0.005481,-0.005368,
     1-0.005259,-0.005053,-0.004862,-0.004686,-0.004522,-0.004445,-0.004371,-0.004230,
     1-0.004100,-0.003811,-0.003565,-0.003354,-0.003288,-0.003169,-0.003005,-0.002860,
     1-0.002729,-0.002611,-0.002504,-0.002406,-0.002233,-0.002087,-0.001962,-0.001854,
     1-0.001759,-0.001677,-0.001604,-0.001540,-0.001483,-0.001433,-0.001348,-0.001280,
     1-0.001251,-0.001225,-0.001181,-0.001145,-0.001115,-0.001091,-0.001080,-0.001071,
     1-0.001054,-0.001040,-0.001027,-0.001017,-0.001007,-0.001000,-0.000992,-0.000976,
     1-0.000964,-0.000954,-0.000945,-0.000938,-0.000933,-0.000927,-0.000923,-0.000919,
     1-0.000914/)
      gamma3= (/ (4.0, i=1,105)/)
      f1= (/-0.482300,-0.472300,-0.469100,-0.463900,-0.456600,-0.454800,-0.451300,-0.446300,
     1-0.444700,-0.438500,-0.435700,-0.433100,-0.431800,-0.430600,-0.428400,-0.426300,
     1-0.422200,-0.419500,-0.418300,-0.418200,-0.418500,-0.419900,-0.422600,-0.426300,
     1-0.431000,-0.436300,-0.442100,-0.454800,-0.467900,-0.481100,-0.485000,-0.493900,
     1-0.506100,-0.517600,-0.528300,-0.538500,-0.547900,-0.556800,-0.573100,-0.587700,
     1-0.594400,-0.600800,-0.612800,-0.618500,-0.623800,-0.633900,-0.643200,-0.647600,
     1-0.651800,-0.659900,-0.667500,-0.674600,-0.681300,-0.684500,-0.687600,-0.693700,
     1-0.699500,-0.712800,-0.724800,-0.735700,-0.739300,-0.745800,-0.755100,-0.763700,
     1-0.771800,-0.779300,-0.786400,-0.793100,-0.805400,-0.816500,-0.826500,-0.835900,
     1-0.844400,-0.852300,-0.859500,-0.866400,-0.872700,-0.878600,-0.889100,-0.898100,
     1-0.902100,-0.905700,-0.912200,-0.917300,-0.921500,-0.924600,-0.925900,-0.926800,
     1-0.928200,-0.928600,-0.928100,-0.926900,-0.924900,-0.922200,-0.918800,-0.907500,
     1-0.892900,-0.875800,-0.856900,-0.837000,-0.816500,-0.795900,-0.775700,-0.756000,
     1-0.737200/)
      f2= (/-0.192800,-0.189500,-0.190900,-0.194100,-0.200600,-0.202600,-0.207100,-0.214400,
     1-0.216900,-0.227500,-0.232900,-0.238300,-0.241000,-0.243700,-0.249100,-0.254400,
     1-0.267100,-0.278900,-0.289500,-0.293400,-0.298700,-0.306600,-0.313200,-0.318700,
     1-0.323100,-0.326600,-0.329300,-0.332800,-0.334300,-0.334300,-0.334100,-0.333300,
     1-0.331400,-0.328800,-0.325700,-0.322400,-0.318600,-0.314700,-0.306000,-0.296700,
     1-0.291900,-0.286800,-0.276500,-0.271300,-0.266000,-0.255400,-0.244900,-0.239600,
     1-0.234400,-0.224000,-0.213900,-0.203900,-0.194300,-0.189600,-0.185000,-0.176100,
     1-0.167600,-0.148000,-0.131100,-0.116400,-0.112000,-0.103900,-0.093100,-0.083770,
     1-0.075640,-0.068540,-0.062260,-0.056690,-0.047240,-0.039500,-0.033080,-0.027680,
     1-0.023140,-0.019290,-0.016030,-0.013270,-0.010920,-0.008925,-0.005808,-0.003580,
     1-0.002728,-0.002017,-0.000930,-0.000190, 0.000000, 0.000000, 0.000000, 0.000000,
     1 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000,
     1 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000, 0.000000,
     1 0.000000/)
      f3= (/-0.005911,-0.005864,-0.005817,-0.005730,-0.005578,-0.005533,-0.005451,-0.005316,
     1-0.005274,-0.005087,-0.005002,-0.004917,-0.004873,-0.004834,-0.004758,-0.004682,
     1-0.004517,-0.004374,-0.004266,-0.004228,-0.004182,-0.004120,-0.004079,-0.004058,
     1-0.004050,-0.004058,-0.004075,-0.004136,-0.004228,-0.004348,-0.004383,-0.004476,
     1-0.004617,-0.004762,-0.004903,-0.005047,-0.005185,-0.005316,-0.005572,-0.005799,
     1-0.005905,-0.006006,-0.006195,-0.006289,-0.006371,-0.006532,-0.006678,-0.006745,
     1-0.006812,-0.006943,-0.007055,-0.007162,-0.007263,-0.007314,-0.007365,-0.007447,
     1-0.007529,-0.007712,-0.007868,-0.008003,-0.008043,-0.008115,-0.008213,-0.008304,
     1-0.008379,-0.008438,-0.008497,-0.008548,-0.008626,-0.008695,-0.008747,-0.008791,
     1-0.008818,-0.008835,-0.008862,-0.008871,-0.008880,-0.008880,-0.008888,-0.008888,
     1-0.008888,-0.008888,-0.008888,-0.008888,-0.008888,-0.008880,-0.008880,-0.008880,
     1-0.008880,-0.008880,-0.008880,-0.008880,-0.008880,-0.008880,-0.008880,-0.008880,
     1-0.008880,-0.008880,-0.008880,-0.008880,-0.008880,-0.008880,-0.008880,-0.008880,
     1-0.008880/)
      f4= (/ 0.100359, 0.103066, 0.104269, 0.106074, 0.109583, 0.110415, 0.112089, 0.114716,
     1 0.115598, 0.120311, 0.122617, 0.125023, 0.126226, 0.127429, 0.129935, 0.132442,
     1 0.138858, 0.145375, 0.151892, 0.153998, 0.158309, 0.164525, 0.170540, 0.176355,
     1 0.181769, 0.186983, 0.191795, 0.200518, 0.207736, 0.213752, 0.215456, 0.218464,
     1 0.222073, 0.224580, 0.226284, 0.227086, 0.227187, 0.226685, 0.224279, 0.220469,
     1 0.218013, 0.215557, 0.209942, 0.207035, 0.204027, 0.197811, 0.191494, 0.188386,
     1 0.185278, 0.179163, 0.173147, 0.167332, 0.161718, 0.159011, 0.156304, 0.151090,
     1 0.146177, 0.134547, 0.124221, 0.114997, 0.112190, 0.106776, 0.099377, 0.092739,
     1 0.086744, 0.081330, 0.076427, 0.071956, 0.064146, 0.057579, 0.051984, 0.047192,
     1 0.043041, 0.039412, 0.036234, 0.033426, 0.030940, 0.028714, 0.024924, 0.021826,
     1 0.020553, 0.019270, 0.017114, 0.015300, 0.013745, 0.012402, 0.011821, 0.011239,
     1 0.010226, 0.009334, 0.008552, 0.007850, 0.007229, 0.006677, 0.006176, 0.005133,
     1 0.004311, 0.003659, 0.003128, 0.002697, 0.002346, 0.002045, 0.001795, 0.001584,
     1 0.001404/)
      tau= (/ 0.3024, 0.3034, 0.3089, 0.3151, 0.3235, 0.3257, 0.3303, 0.3339, 0.3346, 0.3384, 0.3432, 0.3468, 0.3476, 0.3493,
     1 0.3551, 0.3634, 0.3856, 0.3913, 0.4036, 0.4092, 0.4065, 0.4101, 0.4120, 0.4131, 0.4200, 0.4243, 0.4230, 0.4126, 0.4243,
     1 0.4088, 0.4055, 0.4012, 0.3929, 0.3778, 0.3652, 0.3526, 0.3380, 0.3234, 0.3189, 0.3087, 0.3075, 0.3018, 0.2871, 0.2876,
     1 0.2902, 0.2836, 0.2879, 0.2931, 0.2959, 0.3009, 0.3088, 0.3175, 0.3232, 0.3215, 0.3173, 0.3063, 0.3038, 0.3095, 0.3170,
     1 0.3205, 0.3224, 0.3203, 0.3029, 0.3086, 0.2934, 0.2999, 0.3106, 0.3165, 0.3421, 0.3510, 0.3494, 0.3469, 0.3513, 0.3591,
     1 0.3655, 0.3735, 0.3810, 0.3818, 0.3764, 0.3889, 0.3896, 0.4008, 0.4099, 0.4045, 0.4127, 0.4195, 0.4162, 0.4158, 0.4215,
     1 0.4287, 0.4648, 0.4520, 0.4443, 0.4466, 0.4405, 0.4379, 0.4245, 0.4414, 0.4585, 0.4888, 0.5105, 0.3588, 0.3597, 0.3528,
     1 0.2934/)
      sigma= (/ 0.4720, 0.4736, 0.4747, 0.4769, 0.4815, 0.4822, 0.4835, 0.4865, 0.4879, 0.4925, 0.4945, 0.4957, 0.4962, 0.4968,
     1 0.4985, 0.4989, 0.4998, 0.5029, 0.5027, 0.5012, 0.5036, 0.5043, 0.5068, 0.5091, 0.5092, 0.5084, 0.5104, 0.5125, 0.5148,
     1 0.5150, 0.5141, 0.5109, 0.5096, 0.5111, 0.5117, 0.5168, 0.5182, 0.5154, 0.5110, 0.5123, 0.5129, 0.5159, 0.5256, 0.5303,
     1 0.5343, 0.5426, 0.5429, 0.5428, 0.5408, 0.5370, 0.5373, 0.5390, 0.5395, 0.5397, 0.5398, 0.5419, 0.5461, 0.5511, 0.5614,
     1 0.5638, 0.5652, 0.5661, 0.5641, 0.5621, 0.5605, 0.5578, 0.5540, 0.5477, 0.5442, 0.5381, 0.5383, 0.5374, 0.5379, 0.5440,
     1 0.5447, 0.5440, 0.5413, 0.5439, 0.5460, 0.5442, 0.5431, 0.5381, 0.5321, 0.5397, 0.5480, 0.5524, 0.5532, 0.5549, 0.5547,
     1 0.5563, 0.5521, 0.5609, 0.5709, 0.5782, 0.5837, 0.5894, 0.5997, 0.6110, 0.6038, 0.6048, 0.6156, 0.6110, 0.6264, 0.6357,
     1 0.6445/)
      sigma_t= (/ 0.5606, 0.5624, 0.5664, 0.5716, 0.5801, 0.5819, 0.5855, 0.5901, 0.5916, 0.5976, 0.6020, 0.6050, 0.6059, 0.6073,
     1 0.6120, 0.6172, 0.6313, 0.6372, 0.6447, 0.6470, 0.6472, 0.6500, 0.6532, 0.6556, 0.6601, 0.6621, 0.6629, 0.6579, 0.6672,
     1 0.6575, 0.6547, 0.6496, 0.6435, 0.6356, 0.6287, 0.6256, 0.6186, 0.6085, 0.6024, 0.5981, 0.5981, 0.5977, 0.5989, 0.6032,
     1 0.6081, 0.6123, 0.6145, 0.6169, 0.6165, 0.6155, 0.6197, 0.6255, 0.6288, 0.6282, 0.6261, 0.6224, 0.6249, 0.6320, 0.6447,
     1 0.6485, 0.6507, 0.6504, 0.6403, 0.6412, 0.6326, 0.6333, 0.6352, 0.6326, 0.6428, 0.6425, 0.6418, 0.6397, 0.6424, 0.6518,
     1 0.6559, 0.6599, 0.6619, 0.6645, 0.6632, 0.6689, 0.6684, 0.6709, 0.6717, 0.6744, 0.6860, 0.6937, 0.6922, 0.6934, 0.6967,
     1 0.7023, 0.7217, 0.7204, 0.7234, 0.7306, 0.7313, 0.7343, 0.7348, 0.7538, 0.7582, 0.7776, 0.7997, 0.7085, 0.7223, 0.7271,
     1 0.7081/)
	cc = c5(iprd)*cosh(c6(iprd) *max(M-cHM(iprd),0.))
        gamma = gamma1(iprd) + gamma2(iprd)/cosh(max(M-gamma3(iprd),0.0))
c        cosDELTA = cos(dipang)	!available from common.

c Magnitude scaling
        r1 = c1(iprd) + c2(iprd) * (M-6.0) +
     1       (c2(iprd)-c3(iprd))/cn(iprd) *
     1             log(1.0 + exp(-cn(iprd)*(M-cM(iprd))))

c Near-field magnitude and distance scaling
        r2 = c4(iprd) * log(R_Rup + cc)

c Distance scaling at large distance
        r3 = (c4a(iprd)-c4(iprd))/2.0 *
     1            log( R_Rup*R_Rup+cRB(iprd)*cRB(iprd) ) +
     1       R_Rup * gamma

c More source scaling
        r4 = c1a(iprd)*F_RV +
     1       c1b(iprd)*F_NM +
     1       c7(iprd)*(Z_TOR - 4.0)

c HW effect
c cyhwfac is available in common, equals atan(Width*0.5*cosDELTA/(Z_TOR+1))/(pi/2.0)
        hw = c9(iprd) * cosDELTA**2 * (1.0 -R_JB/(R_Rup + 0.001)) *
     1   cyhwfac * tanh(0.5*R_Rup)

c Predicted median Sa on reference condition (Vs=1130 m/sec)
        psa_ref = r1+r2+r3+r4+hw

c Linear soil amplification
        a = f1(iprd) * min(log(V_S30/1130.), 0.)

c Nonlinear soil amplification
        b = f2(iprd) *
     1 (exp(f3(iprd)*(min(V_S30,1130.)-360.)) 
     2 - exp(f3(iprd)*(1130.-360.)))
        c = f4(iprd)

c Sa on soil condition
        psa = psa_ref + (a + b * log((exp(psa_ref)+c)/c))

c        psa = exp(psa)
c        psa_ref = exp(psa_ref)
	sigmaf= 1./sigma_t(iprd)/sqrt2
        return
        end

      subroutine getCBNGA1106(ip,amag,rrup,rjb,H,
     1 vs,d,gnd,sigmaf)
c....................................................................
c  Campbell and Bozorgnia NGA regression relation, Nov 15 2006. Update of
c  November 2006 affects aleatory uncert only, add PGD (index 24).
c  from getCampNGA0601 based on code of Yuehua Zeng, USGS
c Steve Harmsen. 
c Note: this version saves pgahr computed first time, Other periods need pgar
c hard-rock value for subsequent nonlin soil calcs.
c Coeffs from CB06_NGA_MODEL.txt (xls) November 2006
c  input: 
c	  
c	  ip	:index for period in Pr array below
c         amag : magnitude
c         rrup : closest fault distance
c         rjb  : distance to the fault projection on the surface
c         rak  : rake angle (d). Replaced by style of faulting coming in in common, SH.
c         vs   : site S-velocity in m/s (should be Vs30 )
c         H    : depth to top of the fault
c         d    : sediment depth now defined as Z2.5, depth to 2.5 km/s Vs.
c
c  output: gnd   : ln(ground motion spectral value, g)
c          
c          sigmaf= 1/sig_t/sqrt2 = sigma-factor in natural log
c....................................................................
c sig_t = sqrt (tau**2+sigma**2+chisq) see coeff values below.
	common/pgac/pgacalc
	common/mech/ss,rev,normal,obl
	common/dipinf/dipang,cosDELTA,cdipsq,cyhwfac,cbhwfac
	parameter (sqrt2=1.414213562,rockcoef=0.24033595,expm75=0.47236655)
c rockcoef = alog(1100/k1(1)), expm75=exp(-0.75)	   
c C-B NGA Report: novemmber 
        parameter (np=24)
	real tpgasq/0.047961/,spgasq/0.228484/
	logical ss,rev,normal,obl,pgacalc,first/.true./
        real pgar
        save pgar,first
        real,dimension(np):: Pd,c0,c1,c2,c3,c4,c5,c6,c7,c8,
     1 c9,c10,c11,c12,k1,k2,k3,
     2 rhot,rhos,slny,tlny,clny
c Coeffs from CB06_NGA_MODEL.txt (xls) November 2006
c 22 periods available, -1 is PGV. 0.01 is PGA.
c SHarmsen June 26 2006. Pd=spectral period vector.
c 24 periods available, -1 is PGV. -2 is PGD. 0.00 is PGA.
c SHarmsen Noov 15 2006. Pd=spectral period vector.
      Pd=(/0.010,0.020,0.030,0.050,0.075,0.100,0.150,0.200,0.250,0.300,0.400,0.500,0.750,
     + 1.0, 1.5, 2.0, 3.0, 4.0, 5.0, 7.5,10.0, 0.0,-1.0,-2.0/)
       c0=(/-1.715,-1.680,-1.552,-1.209,-0.657,-0.314,-0.133,-0.486,-0.890,-1.171,-1.466,-2.569,-4.844,
     + -6.406, -8.692, -9.701,-10.556,-11.212,-11.684,-12.505,-13.087, -1.715,  0.954, -5.270/)
       c1=(/ 0.500, 0.500, 0.500, 0.500, 0.500, 0.500, 0.500, 0.500, 0.500, 0.500, 0.500, 0.656, 0.972,
     + 1.196, 1.513, 1.600, 1.600, 1.600, 1.600, 1.600, 1.600, 0.500, 0.696, 1.600/)
       c2=(/-0.530,-0.530,-0.530,-0.530,-0.530,-0.530,-0.530,-0.446,-0.362,-0.294,-0.186,-0.304,-0.578,
     +-0.772,-1.046,-0.978,-0.638,-0.316,-0.070,-0.070,-0.070,-0.530,-0.309,-0.070/)
       c3=(/-0.262,-0.262,-0.262,-0.267,-0.302,-0.324,-0.339,-0.398,-0.458,-0.511,-0.592,-0.536,-0.406,
     +-0.314,-0.185,-0.236,-0.491,-0.770,-0.986,-0.656,-0.422,-0.262,-0.019, 0.000/)
       c4=(/-2.118,-2.123,-2.145,-2.199,-2.277,-2.318,-2.309,-2.220,-2.146,-2.095,-2.066,-2.041,-2.000,
     +-2.000,-2.000,-2.000,-2.000,-2.000,-2.000,-2.000,-2.000,-2.118,-2.016,-2.000/)
       c5=(/ 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170,
     + 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170, 0.170/)
       c6=(/ 5.600, 5.600, 5.600, 5.740, 7.090, 8.050, 8.790, 7.600, 6.580, 6.040, 5.300, 4.730, 4.000,
     + 4.000, 4.000, 4.000, 4.000, 4.000, 4.000, 4.000, 4.000, 5.600, 4.000, 4.000/)
       c7=(/ 0.280, 0.280, 0.280, 0.280, 0.280, 0.280, 0.280, 0.280, 0.280, 0.280, 0.280, 0.280, 0.280,
     + 0.255, 0.161, 0.094, 0.000, 0.000, 0.000, 0.000, 0.000, 0.280, 0.245, 0.000/)
       c8=(/-0.120,-0.120,-0.120,-0.120,-0.120,-0.099,-0.048,-0.012, 0.000, 0.000, 0.000, 0.000, 0.000,
     + 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000, 0.000,-0.120, 0.000, 0.000/)
       c9=(/ 0.490, 0.490, 0.490, 0.490, 0.490, 0.490, 0.490, 0.490, 0.490, 0.490, 0.490, 0.490, 0.490,
     + 0.490, 0.490, 0.371, 0.154, 0.000, 0.000, 0.000, 0.000, 0.490, 0.358, 0.000/)
      c10=(/ 1.058, 1.102, 1.174, 1.272, 1.438, 1.604, 1.928, 2.194, 2.351, 2.460, 2.587, 2.544, 2.133,
     + 1.571, 0.406,-0.456,-0.820,-0.820,-0.820,-0.820,-0.820, 1.058, 1.694,-0.820/)
      c11=(/ 0.040, 0.040, 0.040, 0.040, 0.040, 0.040, 0.040, 0.040, 0.040, 0.040, 0.040, 0.040, 0.077,
     + 0.150, 0.253, 0.300, 0.300, 0.300, 0.300, 0.300, 0.300, 0.040, 0.092, 0.300/)
      c12=(/ 0.610, 0.610, 0.610, 0.610, 0.610, 0.610, 0.610, 0.610, 0.610, 0.610, 0.610, 0.883, 1.000,
     + 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 1.000, 0.610, 1.000, 1.000/)
         k1=(/ 865., 865., 908.,1054.,1086.,1032., 878., 748., 654., 587., 503., 457., 410.,
     + 400., 400., 400., 400., 400., 400., 400., 400., 865., 400., 400./)
       k2=(/-1.186,-1.219,-1.273,-1.346,-1.471,-1.624,-1.931,-2.188,-2.381,-2.518,-2.657,-2.669,-2.401,
     +-1.955,-1.025,-0.299, 0.000, 0.000, 0.000, 0.000, 0.000,-1.186,-1.955, 0.000/)
       k3=(/ 1.839, 1.840, 1.841, 1.843, 1.845, 1.847, 1.852, 1.856, 1.861, 1.865, 1.874, 1.883, 1.906,
     + 1.929, 1.974, 2.019, 2.110, 2.200, 2.291, 2.517, 2.744, 1.839, 1.929, 2.744/)
      slny=(/ 0.478, 0.480, 0.489, 0.510, 0.520, 0.531, 0.532, 0.534, 0.534, 0.544, 0.541, 0.550, 0.568,
     + 0.568, 0.564, 0.571, 0.558, 0.576, 0.601, 0.628, 0.667, 0.478, 0.484, 0.667/)
      tlny=(/ 0.219, 0.219, 0.235, 0.258, 0.292, 0.286, 0.280, 0.249,
     *           0.240, 0.215, 0.217, 0.214, 0.227, 0.255, 0.296, 0.296,
     *           0.326, 0.297, 0.359, 0.428, 0.485, 0.219, 0.203, 0.485/)
      clny=(/ 0.181, 0.181, 0.181, 0.179, 0.177, 0.190, 0.201, 0.207,
     *           0.208, 0.216, 0.224, 0.223, 0.236, 0.240, 0.237, 0.241,
     *           0.244, 0.252, 0.253, 0.288, 0.309, 0.181, 0.206, 0.309/)
      rhos=(/ 1.000, 0.999, 0.989, 0.963, 0.922, 0.898, 0.890, 0.871,
     *           0.852, 0.831, 0.785, 0.735, 0.628, 0.534, 0.411, 0.331,
     *           0.289, 0.261, 0.200, 0.174, 0.174, 1.000, 0.691, 0.174/)
      rhot=(/ 1.000, 0.994, 0.979, 0.927, 0.880, 0.871, 0.885, 0.913,
     *           0.873, 0.848, 0.756, 0.631, 0.442, 0.290, 0.290, 0.290,
     *           0.290, 0.290, 0.290, 0.290, 0.290, 1.000, 0.538, 0.290/)
        cs= 1.88
        cn= 1.18	!these 2 c-values did not change from the 1-06 report.
c
        i=ip	!period index
        rrupp=rrup+0.0001	!to avoid divide by zero
c return to ground-motion independent sigma, C&B 11/06.
		tausq=tlny(i)**2
		sigsq=slny(i)**2
		chisq=clny(i)**2
c random horizontal component, include the chisq boost compared to geom. mean.
		sigt=sqrt(tausq+sigsq+chisq)	!campbell has a kchi=1 factor
c  for use by USGS. Other apps might want geometric mean, whose sigt is lower.
c sigmaf is a factor in the normal prob. 
		sigmaf=1.0/sigt/sqrt2
c           f(i)=1./per(i)	!dont need
c f1=median dependence on magnitude. f2= joint M,R dependence
           f1=c0(i)+c1(i)*amag
           if(amag.gt.5.5)f1=f1+c2(i)*(amag-5.5)
           if(amag.gt.6.5)f1=f1+c3(i)*(amag-6.5)
           f2=(c4(i)+c5(i)*amag)*0.5*alog(rrup*rrup+c6(i)*c6(i))
           f3=0.0
           f4=0.0
c f3 dependence on source mechanism; f4 hanging-wall dependence N&R both
c           if(rak.gt.30.0.and.rak.lt.150.0)then
	if(rev)then	!less precise but corresponds to current classification
             if(H.gt.1.0)then
               f3=c7(i)
             else
               f3=c7(i)*H
             endif
c           elseif(rak.gt.-150.0.and.rak.lt.-30.0)then
	elseif(normal)then	!less precise but corresponds to current classification
             f3=c8(i)
         endif	!reverse or normal slip. Hangingwall can be on for normal too.
             if(amag.gt.6.0.and.H.lt.20.0)then
             if(rjb.eq.0.)then
             fhw=1.0	!eqn 7 jan 31 report
             elseif(H.lt.1.)then
c June 2006: new smoothing factor when rupture makes it to the surface or nearly makes it.
             rjbf=sqrt(rjb*rjb+1.0)
             fhw=(max(rrup,rjbf)-rjb)/max(rrup,rjbf)
             else
             fhw=(rrup-rjb)/rrup
              endif
             f4=c9(i)*fhw*cbhwfac*(20.0-H)*0.05	
c cbhwfac new july 2006, computed in main
               if(amag.lt.6.5)f4=f4*(amag-6.0)*2.0
             endif
c f6 = Shallow sediment thickness dependence:
c Null depth effect for 1<d<3. 
           f6=0.0
           if(d.lt.1.0)then
             f6=c11(i)*(d-1.0)
           elseif(d.gt.3.0)then
             f6=c12(i)*k3(i)*expm75*(1.0-exp(-0.25*(d-3.)))
           endif
           vsrk=vs/k1(i)
           if(vsrk.lt.1.0)then
c Code must save pgar for subsequent ip loop indexes. PGA has to be computed first. SH.
c Also, ip index has to be inside any distance and mag indexes. It is in current code.
             if(pgacalc)pgar=exp(f1+f2+f3+f4+f6+(c10(1)
     +                      +k2(1)*cn)*rockcoef)
             csfac=cs*vsrk**cn
             f5=c10(i)*alog(vsrk)
     +		+k2(i)*alog((pgar+csfac)/(pgar+cs))
c additional alpha term CB eqn (17) Sept 1 2006, in sigma computation
c need spgasq=spga**2 & tpgasq=tpga**2. Use the sigma(1) & tau(1). 
c these are conveniently defined in a statement to save calculations.
c		alpha=k2(i)*pgar*(1./(pgar+csfac)-1./(pgar+cs))
c		alfsq=alpha*alpha 
c		tausq=tau(i)**2+alfsq*tpgasq+2.*alpha*rhot(i)*tau(i)*tau(1)   
c		sigsq=sigma(i)**2+alfsq*spgasq+2.*alpha*rhos(i)*sigma(i)*sigma(1)
c		sigt=sqrt(tausq+sigsq)
           else
             alpha=0.
             f5=(c10(i)+k2(i)*cn)*alog(vsrk)
c             sigt=sig_t(i)
           endif
           gnd=f1+f2+f3+f4+f5+f6
c		sigmaf=1.0/sigt/sqrt2
c	if(first)print *,'CB906 i,gnd pgar,sigt,sigt_o,amag,rrup,alpha,vs30=',vs
c	first=.false. 
c	print *,i,exp(gnd),sigt,sig_t(i),pgar,amag,rrup,alpha
c sigmaf is a factor in the normal prob
        return
      end

      subroutine getAB06(ip,ir,xmag0,dist0,gnd,sigma,sigmaf,sigmanf,distnf,v30)
c Atkinson and Boore BSSA 2006. A CEUS relation
c modified from version written by Oliver Boyd. Steve Harmsen Nov 13 2006.
c sigmanf,distnf = near-source terms not used here.
c v30==site vs30 (m/s)
      parameter (np=26)
      parameter (sqrt2=1.414213562)
	parameter (gfac=6.8875526,sfac=2.3025851,tfac=-0.5108256)	!log(980),ln(10),
c  and ln(60/100), resp.
	parameter (fac70=1.8450980,fac140=2.1461280,facv1=-0.5108256,facv2=-0.9295360)	
c  log10(70),log10(140),ln(v1/v2),ln(v2/vref),resp
        parameter (vref = 760., v1 = 180., v2 = 300.)	!for siteamp calcs
      real f0,f1,f2,R,M,bnl,S
      real,dimension(np):: Frq,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10,bln,b1,b2
c the frequencies according to AB2006
      Frq = (/2.00e-01,2.50e-01,3.20e-01,4.00e-01,5.00e-01,6.30e-01,8.00e-01,1.00e+00,
     1       1.26e+00,1.59e+00,2.00e+00,2.52e+00,3.17e+00,3.99e+00,5.03e+00,6.33e+00,
     1       7.97e+00,1.00e+01,1.26e+01,1.59e+01,2.00e+01,2.52e+01,3.18e+01,4.00e+01,
     1       0.00e+00,-1.00e+00/)
c frequency - independent sigma
      sigma = 0.3*sfac
      sigmaf = 1./sqrt2/sigma
        if (ir.eq.2) then
c hr coefficients
        c1 = (/-5.41e+00,-5.79e+00,-6.04e+00,-6.17e+00,-6.18e+00,-6.04e+00,-5.72e+00,
     1        -5.27e+00,-4.60e+00,-3.92e+00,-3.22e+00,-2.44e+00,-1.72e+00,-1.12e+00,
     1        -6.15e-01,-1.46e-01,2.14e-01,4.80e-01,6.91e-01,9.11e-01,1.11e+00,1.26e+00,
     1        1.44e+00,1.52e+00,9.07e-01,-1.44e+00/)
        else
c bc coefficients
        c1 = (/-4.85e+00,-5.30e+00,-5.62e+00,-5.75e+00,-5.76e+00,-5.65e+00,-5.38e+00,
     1         -4.98e+00,-4.27e+00,-3.55e+00,-2.80e+00,-2.02e+00,-1.30e+00,-7.00e-01,
     1         -1.95e-01,2.74e-01,6.34e-01,9.00e-01,1.11e+00,1.33e+00,1.53e+00,1.68e+00,
     1         1.86e+00,1.94e+00,1.33e+00,-1.02e+00/)
        endif
        c2 = (/1.71e+00,1.92e+00,2.08e+00,2.21e+00,2.30e+00,2.34e+00,2.32e+00,2.26e+00,
     1        2.13e+00,1.99e+00,1.83e+00,1.65e+00,1.48e+00,1.34e+00,1.23e+00,1.12e+00,
     1        1.05e+00,1.02e+00,9.97e-01,9.80e-01,9.72e-01,9.68e-01,9.59e-01,9.60e-01,
     1        9.83e-01,9.91e-01/)
        c3 = (/-9.01e-02,-1.07e-01,-1.22e-01,-1.35e-01,-1.44e-01,-1.50e-01,-1.51e-01,
     1        -1.48e-01,-1.41e-01,-1.31e-01,-1.20e-01,-1.08e-01,-9.74e-02,-8.72e-02,
     1        -7.89e-02,-7.14e-02,-6.66e-02,-6.40e-02,-6.28e-02,-6.21e-02,-6.20e-02,
     1        -6.23e-02,-6.28e-02,-6.35e-02,-6.60e-02,-5.85e-02/)
        c4 = (/-2.54e+00,-2.44e+00,-2.37e+00,-2.30e+00,-2.22e+00,-2.16e+00,-2.10e+00,
     1        -2.07e+00,-2.06e+00,-2.05e+00,-2.02e+00,-2.05e+00,-2.08e+00,-2.08e+00,
     1        -2.09e+00,-2.12e+00,-2.15e+00,-2.20e+00,-2.26e+00,-2.36e+00,-2.47e+00,
     1        -2.58e+00,-2.71e+00,-2.81e+00,-2.70e+00,-2.70e+00/)
        c5 = (/2.27e-01,2.11e-01,2.00e-01,1.90e-01,1.77e-01,1.66e-01,1.57e-01,1.50e-01,
     1        1.47e-01,1.42e-01,1.34e-01,1.36e-01,1.38e-01,1.35e-01,1.31e-01,1.30e-01,
     1        1.30e-01,1.27e-01,1.25e-01,1.26e-01,1.28e-01,1.32e-01,1.40e-01,1.46e-01,
     1        1.59e-01,2.16e-01/)
        c6 = (/-1.27e+00,-1.16e+00,-1.07e+00,-9.86e-01,-9.37e-01,-8.70e-01,-8.20e-01,
     1        -8.13e-01,-7.97e-01,-7.82e-01,-8.13e-01,-8.43e-01,-8.89e-01,-9.71e-01,
     1        -1.12e+00,-1.30e+00,-1.61e+00,-2.01e+00,-2.49e+00,-2.97e+00,-3.39e+00,
     1        -3.64e+00,-3.73e+00,-3.65e+00,-2.80e+00,-2.44e+00/)
        c7 = (/1.16e-01,1.02e-01,8.95e-02,7.86e-02,7.07e-02,6.05e-02,5.19e-02,4.67e-02,
     1        4.35e-02,4.30e-02,4.44e-02,4.48e-02,4.87e-02,5.63e-02,6.79e-02,8.31e-02,
     1        1.05e-01,1.33e-01,1.64e-01,1.91e-01,2.14e-01,2.28e-01,2.34e-01,2.36e-01,
     1        2.12e-01,2.66e-01/)
        c8 = (/9.79e-01,1.01e+00,1.00e+00,9.68e-01,9.52e-01,9.21e-01,8.56e-01,8.26e-01,
     1        7.75e-01,7.88e-01,8.84e-01,7.39e-01,6.10e-01,6.14e-01,6.06e-01,5.62e-01,
     1        4.27e-01,3.37e-01,2.14e-01,1.07e-01,-1.39e-01,-3.51e-01,-5.43e-01,-6.54e-01,
     1        -3.01e-01,8.48e-02/)
        c9 = (/-1.77e-01,-1.82e-01,-1.80e-01,-1.77e-01,-1.77e-01,-1.73e-01,-1.66e-01,
     1        -1.62e-01,-1.56e-01,-1.59e-01,-1.75e-01,-1.56e-01,-1.39e-01,-1.43e-01,
     1        -1.46e-01,-1.44e-01,-1.30e-01,-1.27e-01,-1.21e-01,-1.17e-01,-9.84e-02,
     1        -8.13e-02,-6.45e-02,-5.50e-02,-6.53e-02,-6.93e-02/)
        c10 = (/-1.76e-04,-2.01e-04,-2.31e-04,-2.82e-04,-3.22e-04,-3.75e-04,-4.33e-04,
     1        -4.86e-04,-5.79e-04,-6.95e-04,-7.70e-04,-8.51e-04,-9.54e-04,-1.06e-03,
     1        -1.13e-03,-1.18e-03,-1.15e-03,-1.05e-03,-8.47e-04,-5.79e-04,-3.17e-04,
     1        -1.23e-04,-3.23e-05,-4.85e-05,-4.48e-04,-3.73e-04/)
c     endif
c Soil amplification
      bln = (/-7.52e-01,-7.45e-01,-7.40e-01,-7.35e-01,-7.30e-01,-7.26e-01,-7.16e-01,
     1        -7.00e-01,-6.90e-01,-6.70e-01,-6.00e-01,-5.00e-01,-4.45e-01,-3.90e-01,
     1        -3.06e-01,-2.80e-01,-2.60e-01,-2.50e-01,-2.32e-01,-2.49e-01,-2.86e-01,
     1        -3.14e-01,-3.22e-01,-3.30e-01,-3.61e-01,-6.00e-01/)
      b1 = (/-3.00e-01,-3.10e-01,-3.30e-01,-3.52e-01,-3.75e-01,-3.95e-01,-3.40e-01,
     1        -4.40e-01,-4.65e-01,-4.80e-01,-4.95e-01,-5.08e-01,-5.13e-01,-5.18e-01,
     1        -5.21e-01,-5.28e-01,-5.60e-01,-5.95e-01,-6.37e-01,-6.42e-01,-6.43e-01,
     1        -6.09e-01,-6.18e-01,-6.24e-01,-6.41e-01,-4.95e-01/)
      b2 = (/0.00e+00,0.00e+00,0.00e+00,0.00e+00,0.00e+00,0.00e+00,0.00e+00,0.00e+00,
     1        -2.00e-03,-3.10e-02,-6.00e-02,-9.50e-02,-1.30e-01,-1.60e-01,-1.85e-01,
     1        -1.85e-01,-1.40e-01,-1.32e-01,-1.17e-01,-1.05e-01,-1.05e-01,-1.05e-01,
     1        -1.08e-01,-1.15e-01,-1.44e-01,-6.00e-02/)
      M = xmag0
c R: I put a lower limit of 5 km SH Nov 2006. For near-surface faults singularity is possible
      R = max(5.0,dist0)
      rfac=alog10(R)
      f0 = max(1.-rfac,0.)
      f1 = min(rfac,fac70)
      f2 = max(rfac-fac140,0.)
      if(v30.gt.0.) then
c compute pga on rock
        gnd = c1(25) + c2(25)*M + c3(25)*M*M + (c4(25)+c5(25)*M)*f1 +
     1        (c6(25)+c7(25)*M)*f2 + (c8(25)+c9(25)*M)*f0 + c10(25)*R
        if(v30.le.v1) then
          bnl = b1(ip);
        elseif(v30.le.v2) then
          bnl = (b1(ip) - b2(ip))*log(v30/v2)/facv1 + b1(ip);
        elseif(v30.le.vref) then
          bnl = b2(ip)*log(v30/vref)/facv2
        else
          bnl = 0.;
        endif
        if(10**gnd.le.60.) then
          S = bln(ip)*log(v30/vref) + bnl*tfac
        else
          S = bln(ip)*log(v30/vref) + bnl*log((10**gnd)/100.)
        endif
      endif
      gnd = c1(ip) + c2(ip)*M + c3(ip)*M*M + (c4(ip)+c5(ip)*M)*f1 +
     1      (c6(ip)+c7(ip)*M)*f2 + (c8(ip)+c9(ip)*M)*f0 + c10(ip)*R + S
      if (ip.lt.26) then
        gnd = gnd*sfac - gfac
      else
c pgv?
        gnd = gnd*sfac
      endif
c      write(6,*) R,exp(gnd),M,sigma,exp(sfac*S),ip
      return
      end

c Added getTP05, Oliver Boyd
      subroutine getTP05(ip,ir,xmag0,dist0,gnd,sigma,sigmaf,sigmanf,distnf)
c for what range of vs30 is this one supposed to be valid? SH nov 13 2006
c ir seems to have a hard-rock, firm-rock feature
      parameter (np=14,sqrt2=1.414213562)
      real f1,f2,f3,R,Rrup,M,cor
      real,dimension(np):: Pd,c1,c1h,c2,c3,c4,c5,c6,c7,c8,c9,c10,c11,c12,c13,c14,c15,c16
      Pd = (/0.00e+00,5.00e-02,8.00e-02,1.00e-01,1.50e-01,2.00e-01,3.00e-01,5.00e-01,
     1       7.50e-01,1.00e+00,1.50e+00,2.00e+00,3.00e+00,4.00e+00/)
      c1h = (/1.14e+00,1.82e+00,6.83e-01,8.69e-01,2.38e+00,-5.48e-01,-5.13e-01,
     1       2.40e-01,-6.79e-01,-1.55e+00,-2.30e+00,-2.70e+00,-2.42e+00,-3.69e+00/)
      c1 = (/1.56e+00,2.24e+00,1.10e+00,1.29e+00,2.87e+00,1.70e-02,-9.27e-02,
     1       6.60e-01,-3.23e-01,-1.26e+00,-1.94e+00,-2.28e+00,-2.28e+00,-2.28e+00/)
      c2 = (/6.23e-01,5.33e-01,7.43e-01,6.07e-01,5.01e-01,8.57e-01,6.67e-01,
     1       6.11e-01,6.66e-01,7.64e-01,7.94e-01,8.05e-01,8.01e-01,8.17e-01/)
      c3 = (/-4.83e-02,-4.75e-02,-2.93e-02,-4.74e-02,-6.42e-02,-2.62e-02,
     1       -4.43e-02,-7.89e-02,-8.30e-02,-8.59e-02,-8.84e-02,-9.29e-02,
     1       -1.08e-01,-1.18e-01/)
      c4 = (/-1.81e+00,-1.63e+00,-1.71e+00,-1.52e+00,-1.73e+00,-1.68e+00,
     1       -1.42e+00,-1.55e+00,-1.48e+00,-1.49e+00,-1.45e+00,-1.44e+00,
     1       -1.65e+00,-1.46e+00/)
      c5 = (/-6.52e-01,-5.67e-01,-7.56e-01,-7.04e-01,-9.76e-01,-8.61e-01,
     1       -4.70e-01,-8.44e-01,-7.34e-01,-9.41e-01,-8.86e-01,-9.23e-01,
     1       -8.98e-01,-8.45e-01/)
      c6 = (/4.46e-01,4.54e-01,4.60e-01,4.49e-01,4.14e-01,4.33e-01,4.68e-01,
     1       4.14e-01,4.35e-01,4.24e-01,4.12e-01,4.08e-01,4.37e-01,4.25e-01/)
      c7 = (/-2.93e-05,7.77e-03,-9.68e-04,-6.19e-03,6.60e-03,2.79e-03,1.08e-02,
     1       7.89e-03,9.53e-03,-5.84e-03,8.30e-03,2.06e-02,1.67e-02,1.13e-02/)
      c8 = (/-4.05e-03,-4.91e-03,-4.94e-03,-4.70e-03,-4.80e-03,-3.65e-03,
     1       -5.41e-03,-3.65e-03,-3.37e-03,-2.09e-03,-3.27e-03,-2.14e-03,
     1       -2.03e-03,-1.72e-03/)
      c9 = (/9.46e-03,-3.14e-03,-5.50e-03,-4.24e-03,3.93e-03,-2.02e-03,6.44e-03,
     1       -2.65e-04,-1.19e-03,3.30e-03,2.51e-03,2.30e-03,3.58e-03,-3.34e-03/)
      c10 = (/1.41e+00,9.80e-01,1.13e+00,1.04e+00,1.51e+00,1.64e+00,1.52e+00,
     1       1.59e+00,1.55e+00,1.52e+00,1.71e+00,1.43e+00,1.93e+00,1.69e+00/)
      c11 = (/-9.61e-01,-9.39e-01,-9.16e-01,-9.13e-01,-8.65e-01,-9.25e-01,
     1       -9.15e-01,-8.59e-01,-7.84e-01,-7.57e-01,-7.69e-01,-7.55e-01,
     1       -8.18e-01,-7.37e-01/)
      c12 = (/4.32e-04,5.12e-04,4.82e-04,4.11e-04,3.64e-04,1.61e-04,4.32e-04,
     1       2.77e-04,2.45e-04,1.17e-04,2.33e-04,2.14e-04,1.16e-04,1.10e-04/)
      c13 = (/1.33e-04,9.30e-04,7.33e-04,3.58e-04,6.84e-04,6.43e-04,2.87e-04,
     1       1.46e-04,5.47e-04,7.59e-04,1.66e-04,3.91e-04,3.98e-04,3.59e-04/)
      c14 = (/1.21e+00,1.22e+00,1.22e+00,1.23e+00,1.24e+00,1.24e+00,1.26e+00,
     1       1.28e+00,1.28e+00,1.28e+00,1.27e+00,1.26e+00,1.26e+00,1.25e+00/)
      c15 = (/-1.11e-01,-1.08e-01,-1.08e-01,-1.08e-01,-1.08e-01,-1.08e-01,
     1       -1.09e-01,-1.73e-01,-1.05e-01,-1.03e-01,-9.99e-02,-9.78e-02,
     1       -9.52e-02,-9.26e-02/)
      c16 = (/4.09e-01,4.41e-01,4.49e-01,4.56e-01,4.64e-01,4.69e-01,4.79e-01,
     1       5.05e-01,5.22e-01,5.37e-01,5.51e-01,5.62e-01,5.73e-01,5.89e-01/)
      M = xmag0
      Rrup = dist0
      if (M.lt.7.2) then
        sigma = c14(ip) + c15(ip)*M 
      else
        sigma = c16(ip)
      endif
      sigmaf = 1./sqrt2/sigma
      if (ir.lt.0) then
        f1 = c1h(ip) + c2(ip)*M + c3(ip)*(8.5 - M)**2.5
      else
        f1 = c1(ip) + c2(ip)*M + c3(ip)*(8.5 - M)**2.5
      endif
      f2 = c9(ip)*log(Rrup + 4.5)
      if (Rrup.gt.70.) f2 = f2 + c10(ip)*log(Rrup/70.)
      if (Rrup.gt.130.) f2 = f2 + c11(ip)*log(Rrup/130.)
      cor = exp(c6(ip)*M + c7(ip)*(8.5 - M)**2.5)
      R = sqrt(Rrup*Rrup + c5(ip)*c5(ip)*cor*cor)
      f3 = (c4(ip) + c13(ip)*M)*log(R) + (c8(ip) + c12(ip)*M)*R
      gnd = f1 + f2 + f3
c      write(6,*) gnd,sigmaf,M,R,S,ip
      return
      end

	subroutine kanno(ip,gnd,sigmaf,amag,rrup,vsfac)
c....................................................................
c  Kanno et al. regression relation, 2006 for shallow earthquakes
c  written by Yuehua Zeng, USGS. Mods Steve Harmsen Nov 7 2006.
c
c  input: per  : period
c         amag : magnitude
c         rrup : closest fault distance
c         vsfac   : log 10 of site S-velocity in m/s
c
c  output: gnd   : ground motion spectral values (ln) (g). to be consistent
c
c          sigmaf : 1/sigma/sqrt2 errors in ln. the sigma factor.
c....................................................................
	parameter (gfac=6.8875526,sfac=2.3025851,sqrt2=1.414213562)
c conversion factors gfac cm/s/s to g, sfac log10 to ln.
	real, dimension (37) :: T,a1,b1,c1,d1,e1,p,q
        real sigma,sigmaf,gnd,vsfac
      T =(/0.05,0.06,0.07,0.08,0.09,0.10,0.11,0.12,0.13,0.15,0.17,0.20,0.22,
     +0.25,0.30,0.35,0.40,0.45,0.50,0.60,0.70,0.80,0.90,1.00,1.10,1.20,
     +1.30,1.50,1.70,2.00,2.20,2.50,3.00,3.50,4.00,4.50,5.00/)
      a1=(/0.54,0.54,0.53,0.52,0.52,0.52,0.50,0.51,0.51,0.52,0.53,0.54,0.54,
     +0.54,0.56,0.56,0.58,0.59,0.59,0.62,0.63,0.65,0.68,0.71,0.72,0.73,
     +0.74,0.77,0.79,0.80,0.82,0.84,0.86,0.90,0.92,0.94,0.92/)
      b1=(/-0.0035,-0.0037,-0.0039,-0.0040,-0.0041,-0.0041,-0.0040,-0.0040,
     +-0.0039,-0.0038,-0.0037,-0.0034,-0.0032,-0.0029,-0.0026,-0.0024,
     +-0.0021,-0.0019,-0.0016,-0.0014,-0.0012,-0.0011,-0.0009,-0.0009,
     +-0.0007,-0.0006,-0.0006,-0.0005,-0.0005,-0.0004,-0.0004,-0.0003,
     +-0.0002,-0.0003,-0.0005,-0.0007,-0.0004/)
      c1=(/0.48,0.57,0.67,0.75,0.80,0.85,0.96,0.93,0.91,0.89,0.84,0.76,0.73,
     +0.66,0.51,0.42,0.26,0.13,0.04,-0.22,-0.37,-0.54,-0.80,-1.04,-1.19,
     +-1.32,-1.44,-1.70,-1.89,-2.08,-2.24,-2.46,-2.72,-2.99,-3.21,-3.39,
     +-3.35/)
      d1=(/0.0061,0.0065,0.0066,0.0069,0.0071,0.0073,0.0061,0.0062,0.0062,
     +0.0060,0.0056,0.0053,0.0048,0.0044,0.0039,0.0036,0.0033,0.0030,
     +0.0022,0.0025,0.0022,0.0020,0.0019,0.0021,0.0018,0.0014,0.0014,
     +0.0017,0.0019,0.0020,0.0022,0.0023,0.0021,0.0032,0.0045,0.0064,
     +0.0030/)
      e1=(/0.37,0.38,0.38,0.39,0.40,0.40,0.40,0.40,0.40,0.41,0.41,0.40,0.40,
     +0.40,0.39,0.40,0.40,0.41,0.41,0.41,0.41,0.41,0.41,0.41,0.41,0.41,
     +0.41,0.40,0.39,0.39,0.38,0.38,0.38,0.37,0.38,0.38,0.38/)
      p= (/-0.32,-0.26,-0.24,-0.26,-0.29,-0.32,-0.35,-0.39,-0.43,-0.53,-0.61,
     + -0.68,-0.72,-0.75,-0.80,-0.85,-0.87,-0.89,-0.91,-0.92,-0.96,-0.98,
     + -0.97,-0.93,-0.92,-0.91,-0.88,-0.85,-0.83,-0.78,-0.76,-0.72,-0.68,
     + -0.66,-0.62,-0.60,-0.59/)
      q= (/0.80,0.65,0.60,0.64,0.72,0.78,0.84,0.94,1.04,1.28,1.47,1.65,1.74,
     + 1.82,1.96,2.09,2.13,2.18,2.25,2.30,2.41,2.46,2.44,2.32,2.30,2.26,
     + 2.20,2.12,2.06,1.92,1.88,1.80,1.70,1.64,1.54,1.50,1.46/)
c
	if(ip.eq.0)then
	 gnd=0.56*amag-0.0031*rrup-alog10(rrup+0.0055*10**(0.5*amag))
     +        +0.26-0.55*vsfac+1.35
        sigma=0.37*sfac
        else
	 gnd=a1(ip)*amag+b1(ip)*rrup-alog10(rrup+d1(ip)*10**(0.5*amag))
     +        +c1(ip)+p(ip)*vsfac+q(ip)
	 sigma=e1(ip)*sfac
	 endif
	 gnd=sfac*gnd-gfac
	 sigmaf=1.0/sigma/sqrt2
	return
	end subroutine kanno
c end of source code listing.
